C     This program computes the Higgs boson production and decay
C     cross section in pp or ppbar collisions at NLL+NLO and NNLL+NNLO accuracy
C
C     Version 1.0 (March 2012)
C
C     Please refer to: 
C     D. de Florian, G. Ferrera, M. Grazzini, D. Tommasini, arXiv:1203.6321
C     See http://theory.fi.infn.it/grazzini/codes.html

C     This is the main program

      program HRes

      implicit none
      include 'constants.f'
      include 'gridinfo.f'
      integer itmx1,ncall1,itmx2,ncall2
      double precision integ,integ_err
      double precision p(mxpart,4),wt
      common/iterat/itmx1,ncall1,itmx2,ncall2
    

CC    Initialization

      call hinit


CC    Warm up

      if(readin.eqv. .false.)
     & call integrate(0,itmx1,ncall1,.false.,integ,integ_err)

      
CC    Main run    

      call integrate(1,itmx2,ncall2,.true.,integ,integ_err)
    


CC    Final processing and print-out

      call hexit(integ,integ_err)
      
      stop
      end
       
