CC    Counterterm to be subtracted from real+virt to get a finite
CC    cross section at qt->0

CC    Version allowing to isolate qg+gq contribution

CC    NEW: full scale dependence included (to be checked !)

CC    NEW: Q2,qt2 and shat obtained trough a common block:
CC         no need to generate real event every time

      double precision function countint(vector,wgt)
      implicit none
      include 'constants.f'
      include 'realonly.f'
      include 'virtonly.f'
      include 'noglue.f'
      include 'vegas_common.f'
      include 'ptilde.f'
      include 'npart.f'
      include 'zerowidth.f'
      include 'efficiency.f'
      include 'masses.f'
      include 'limits.f'
C
      include 'jetlabel.f'
      include 'qcdcouple.f'
      include 'phasemin.f'
      include 'rescoeff.f'
C
      integer ih1,ih2,j,nd,nvec,order,iscale
      logical cuts,bin,incldip(0:maxd)
      double precision vector(mxdim),val,xint
      double precision sqrts!,dot
      double precision p(mxpart,4),pjet(mxpart,4)
      double precision pswt
      double precision s(mxpart,mxpart),wgt
      double precision msqc(-nf:nf,-nf:nf),xmsq(0:maxd)
      double precision BrnRat,xreal,xreal2
CC
CC    scale and factscale defined only locally
CC
      double precision scale,facscale
      double precision ptrans(mxpart,4)
      double precision q2,qt2,shat,Itilde
      double precision fx10(-nf:nf),fx20(-nf:nf)
      double precision fx1p(-nf:nf),fx2p(-nf:nf)
      double precision alfa,beta,diff,Pggreg,Pgq,Cgq
      double precision xjacq2,xjacqt2,xjcut,xth,x3,almin,almax
      double precision xmio,fluxborn,xmiob
      double precision shad,zmax,tauh,Vol,pswt0
      double precision xx0(2),xx10,xx20,y34,qt !,qtmax,cosh2y
      double precision sig1,sig2,LR,LF,LQ,LQb
      double precision sig11,sig12
      double precision sig11t,sig12t,sig11t2,sig12t2,
     &                               sig11tb,sig12tb
      double precision sig21,sig22,sig23,sig24
      double precision tdelta,tH1st,tH1stF,tgaga,tcga,tgamma2
      double precision tdeltat,tH1stt,tH1stFt,tgagat,
     &                                 tcgat,tgamma2t
      double precision tdeltat2,tH1stt2,tH1stFt2,tgagat2,
     &                                   tcgat2,tgamma2t2
      double precision tdeltatb,tH1sttb,tH1stFtb,tgagatb,
     &                                   tcgatb,tgamma2tb
      double precision LL1,LL2,LL3,LL4,LLb1,LLb2,LLb3,LLb4
      double precision z1,z2,diff10,diff20,diff1f,diff2f
      double precision diffg10,diffg20,diffc10,diffc20,cut
      double precision diffg1f,diffg2f,diffc1f,diffc2f
      double precision D0int,D1int
      double precision Pggggreg,Pgggq,Pgqqg,Pgqqq
      double precision CgqPqq,CgqPqg
      double precision msqb,msqbt
      double precision P2gq,P2gg
      double precision smur,smuf
      common/scalefactors/smur,smuf
      external Itilde,Pggreg,Pgq,Cgq,D0int,D1int,
     &         Pggggreg,Pgggq,Pgqqg,Pgqqq,CgqPqq,CgqPqg

      common/xmio/xmio,xmiob
      double precision wtswitch
      double precision qtminvirt,qtminreal,qtmax1,qtmax2,qtsw
      common/qtcut/qtminvirt,qtminreal,qtmax1,qtmax2,qtsw
!      common/qtcut/qtcutmin,qtcutmax
      double precision resummscale,resummscaleb
      double precision mtop,mbot,sigmatb,sigmat
      common/resummscale/resummscale,resummscaleb
      common/xx0/xx0
      common/nnlo/order
CC
CC    Variables passed from virtint or lowint
CC
      common/count/qt2,q2,shat

CC    alphas at the static scale

      real *8 as0
      common/as0/as0

      double precision a_param,a_paramb,b0p,b0pb,xla
      COMMON/a_param/a_param,a_paramb,b0p,b0pb

      integer higgsdec,ndec,approxim
      common/higgsdec/higgsdec,ndec
      integer n2,n3,flgq
      double precision mass2,width2,mass3,width3
      common/breit/n2,n3,mass2,width2,mass3,width3
      common/xreal/xreal,xreal2
CH
      common/tbmass/mtop,mbot
      common/flag/approxim
      common/Born/sigmatb,sigmat
CH
      common/density/ih1,ih2
      common/energy/sqrts
      common/bin/bin
      common/BrnRat/BrnRat
      common/incldip/incldip

      ntotshot=ntotshot+1
      pswt=0d0
      countint=0d0      


      do nd=0,1
      xmsq(nd)=0d0
      enddo


CC Check if q2 is the proper interval

      if(q2.lt.wsqmin.or.q2.gt.wsqmax) goto 999   
      
CC Cut on qt

      wtswitch=1d0
      qt=dsqrt(qt2)
      if(qt.lt.qtminreal .or. qt.gt.qtmax2) goto 999

       if(qt.gt.qtmax1) then
        wtswitch=(dcos((qt-qtmax1)*pi/qtsw)+1d0)*0.5d0
       endif


      shad=sqrts**2
      xmio=dsqrt(qt2/q2)
      xmiob=dsqrt(qt2/q2)

      npart=ndec+1
      nvec=npart+2
      

CC   LR,LF,LQ: all scales are static
    
      scale=smur*hmass
      facscale=smuf*hmass

      LR=dlog(q2/scale**2)
      LF=dlog(q2/facscale**2) 
      if(approxim.ne.2)then
       LQ=dlog(q2/resummscale**2)
      else
       LQ=dlog(q2/resummscale**2)
       LQb=dlog(q2/resummscaleb**2)
      endif


      xth=vector(2)
      x3=vector(1)
      if(higgsdec.ne.1)then
       xth=vector(12)
       x3=vector(13)
      endif
     
CC   jacobian for qt2

    
      xjacqt2=(shat-q2)**2/shat*dabs(1-2*xth)


CC   jacobian for Q2

      if (zerowidth) then
      xjacq2=pi*hmass*hwidth
      else
      almin=datan(-hmass/hwidth)
      almax=datan((shat-hmass**2)/hmass/hwidth)
      xjacq2=hmass*hwidth
     & *(almax-almin)/(dcos((almax-almin)*x3+almin))**2
      endif



CC   Volume

      zmax=1+2*xmio**2-2*xmio*dsqrt(1+xmio**2)
      tauh=q2/shad
      Vol=-(dlog(zmax)-dlog(tauh))/dlog(taumin)     
   

  

CC   LL1,LL2,LL3,LL4: large log (squared) corresponding to eq. (136) 
CC   In this way normalization is fixed to dsigma/dqt2


!     Add resummation scale dependence
      if(approxim.ne.2)then
       xmio=xmio*a_param
       LL1=(Itilde(1,0)/q2**2)*a_param**2
       LL2=(Itilde(2,0)/q2**2)*a_param**2
       LL3=(Itilde(3,0)/q2**2)*a_param**2
       LL4=(Itilde(4,0)/q2**2)*a_param**2
      else
       xmio=xmio*a_param
       LL1=(Itilde(1,0)/q2**2)*a_param**2
       LL2=(Itilde(2,0)/q2**2)*a_param**2
       LL3=(Itilde(3,0)/q2**2)*a_param**2
       LL4=(Itilde(4,0)/q2**2)*a_param**2
       xmiob=xmiob*a_paramb
       LLb1=(Itilde(1,1)/q2**2)*a_paramb**2
       LLb2=(Itilde(2,1)/q2**2)*a_paramb**2
       LLb3=(Itilde(3,1)/q2**2)*a_paramb**2
       LLb4=(Itilde(4,1)/q2**2)*a_paramb**2
      endif


CC Generate BORN momenta for counterterm

      if(higgsdec.eq.1) then
       call genBORN2(q2,shat,vector,ptrans,pswt0,*999)
      else
       call genBORN4(q2,shat,vector,ptrans,pswt0,*999)   
      endif

      call storeptilde(1,ptrans)


CC Compute Born matrix element

CH
      if(higgsdec.eq.1 .and. approxim.eq.0) then
       call gg_h(ptrans,msqc)
      elseif(higgsdec.eq.1 .and. approxim.ne.0)then
       call gg_hexact(ptrans,msqc)
CH
      elseif(higgsdec.eq.2 .and. approxim.eq.0) then
       call qqb_hww(ptrans,msqc)
      elseif(higgsdec.eq.2 .and. approxim.ne.0) then
       call qqb_hwwexact(ptrans,msqc)
      elseif(approxim.eq.0)then
       call qqb_hzz(ptrans,msqc)
      elseif(approxim.ne.0)then
       call qqb_hzzexact(ptrans,msqc)
      endif

      msqb=msqc(0,0)
      if(approxim.eq.2)then
       msqbt=msqb*sigmat/sigmatb
      endif

      



      do nd=0,ndmax
      xmsq(nd)=0d0
      enddo

C Scaled momentum fractions

      cut=1d-8

      if(higgsdec.eq.1) then
       beta=cut+(1-cut)*vector(8)
       alfa=cut+(1-cut)*vector(9)  
      else
       beta=cut+(1-cut)*vector(14)
       alfa=cut+(1-cut)*vector(15)
      endif

      xx10=xx0(1)
      xx20=xx0(2)


      z1=xx10**beta
      z2=xx20**alfa


CC    Generate event to be binned

      y34=0.5d0*dlog(xx10/xx20)


      if(higgsdec.eq.1) then
      call genCT2(q2,qt2,y34,vector,p,pswt,*999)
      else
      call genCT4(q2,qt2,y34,vector,p,pswt,*999)
      endif


CC Here we have to check if the counterevent passes the cuts

      jets=0

      incldip(1)=cuts(p,0)
      if (incldip(1)) goto 999


c    To be included later

      xjcut=(1-cut)**2

            
c--- calculate PDF's  

      call fdist(ih1,xx10,facscale,fx10)
      call fdist(ih2,xx20,facscale,fx20)

      call fdist(ih1,xx10**(1-beta),facscale,fx1p)
      call fdist(ih2,xx20**(1-alfa),facscale,fx2p)




CC Flux for Born cross section


   
       fluxborn=fbGeV2/(2*q2)


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC Start construction of the counterterm
        flgq=1
        if(gqonly)flgq=0

        diff10=0d0
        diff20=0d0
        diff1f=0d0
        diff2f=0d0

        diffc10=0d0
        diffc1f=0d0
        diffc20=0d0
        diffc2f=0d0

        diffg10=0d0
        diffg1f=0d0
        diffg20=0d0
        diffg2f=0d0

        tdelta=0d0
        tH1st=0d0
        tH1stF=0d0
        tgaga=0d0
        tcga=0d0
        tgamma2=0d0


        sig11=0d0
        sig12=0d0
        sig21=0d0      
        sig22=0d0
        sig23=0d0
        sig24=0d0


CC    First diagonal part, then loop over j=1,nf
      if(approxim.ne.2)then
      if(gqonly)goto 71

C     Simplest term without convolutions
  
      tdelta=tdelta+fx10(0)*fx20(0)*msqb     



C     H1st delta term
      
      tH1st=tH1st+2*C1ggdelta*fx10(0)*fx20(0)*msqb
      
c     gammagg: non delta terms, first leg    


      diff=-dlog(xx10)*((fx1p(0)-fx10(0)*xx10**beta)*3/(1-z1)
     &    +fx1p(0)*Pggreg(z1))

      tH1stF=tH1stF+diff*fx20(0)*msqb
      tH1stF=tH1stF-3*D0int(xx10)*fx10(0)*fx20(0)*msqb

c     gammagg: non delta terms, second leg    

      diff=-dlog(xx20)*((fx2p(0)-fx20(0)*xx20**alfa)*3/(1-z2)
     &    +fx2p(0)*Pggreg(z2))

      tH1stF=tH1stF+diff*fx10(0)*msqb
      tH1stF=tH1stF-3*D0int(xx20)*fx10(0)*fx20(0)*msqb

c     gammagg: delta term, both legs


      tH1stF=tH1stF+2*beta0*fx10(0)*fx20(0)*msqb

 71   if(order.eq.1) goto 74

CC    (gamma+gamma)*(gamma+gamma) term

C     First part: one gamma for each leg: gluon channel

      diff10=-dlog(xx10)
     &  *(fx1p(0)-fx10(0)*xx10**beta)/(1-z1)
     &  - D0int(xx10)*fx10(0)

      diff10=3*diff10+beta0*fx10(0)
     &     -dlog(xx10)*fx1p(0)*Pggreg(z1)

      diff20=-dlog(xx20)
     &  *(fx2p(0)-fx20(0)*xx20**alfa)/(1-z2)
     &  - D0int(xx20)*fx20(0)

      diff20=3*diff20+beta0*fx20(0)
     &     -dlog(xx20)*fx2p(0)*Pggreg(z2)


C    Second: gamma*gamma: gluon channel

c    First leg

      diff=-dlog(xx10)*((fx1p(0)-fx10(0)*xx10**beta)
     &    *(D0gggg/(1-z1)+D1gggg*dlog(1-z1)/(1-z1))
     &      +fx1p(0)*(Pggggreg(z1)+Pgqqg(z1)))
     &    +(Deltagggg-D0gggg*D0int(xx10)-D1gggg*D1int(xx10))*fx10(0)


      tgaga=tgaga+diff*flgq*fx20(0)*msqb


c    Second leg

      diff=-dlog(xx20)*((fx2p(0)-fx20(0)*xx20**alfa)
     &    *(D0gggg/(1-z2)+D1gggg*dlog(1-z2)/(1-z2))
     &      +fx2p(0)*(Pggggreg(z2)+Pgqqg(z2)))
     &    +(Deltagggg-D0gggg*D0int(xx20)-D1gggg*D1int(xx20))*fx20(0)

      tgaga=tgaga+diff*flgq*fx10(0)*msqb



CC    Start  (C+C)*(gamma+gamma) term: diagonal part


c    gamma first leg, C second

      diffg10=-dlog(xx10)
     &  *((fx1p(0)-fx10(0)*xx10**beta)*3d0/(1-z1)+Pggreg(z1)*fx1p(0))
     &    +fx10(0)*(beta0-3*D0int(xx10))

      diffc20=C1ggdelta*fx20(0)

c    gamma second leg, C first

      diffg20=-dlog(xx20)
     &  *((fx2p(0)-fx20(0)*xx20**alfa)*3d0/(1-z2)+Pggreg(z2)*fx2p(0))
     &    +fx20(0)*(beta0-3*D0int(xx20))


      diffc10=C1ggdelta*fx10(0)

c    C*gamma: first leg (ignore delta term in Cgg: taken into account in H1stf)

      tcga=tcga+CgqPqg(z1)*(-dlog(xx10))*flgq*fx1p(0)*fx20(0)*msqb 

c    C*gamma: second leg (ignore delta term in Cgg: taken into account in H1stf)

      tcga=tcga+CgqPqg(z2)*(-dlog(xx20))*flgq*fx2p(0)*fx10(0)*msqb 

c    End of (C+C)*(gamma+gamma)


CC    gamma2: diagonal part

c     First leg

      diff=-dlog(xx10)
     &  *(fx1p(0)-fx10(0)*xx10**beta)/(1-z1)
     &  - D0int(xx10)*fx10(0)  

      tgamma2=tgamma2+(1.5d0*Kappa*diff-dlog(xx10)*P2gg(z1)*fx1p(0))
     &                *flgq*fx20(0)*msqb


c     Second leg

      diff=-dlog(xx20)
     &  *(fx2p(0)-fx20(0)*xx20**alfa)/(1-z2)
     &  - D0int(xx20)*fx20(0)  

      tgamma2=tgamma2+(1.5d0*Kappa*diff-dlog(xx20)*P2gg(z2)*fx2p(0))
     &                *flgq*fx10(0)*msqb


 74   continue


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
           
      do j=1,nf


C     H1st: Cgq, first leg


      tH1st=tH1st+(fx1p(j)+fx1p(-j))*Cgq(z1)
     & *(-dlog(xx10))*fx20(0)*msqb


C     H1st: Cgq, second leg

      
      tH1st=tH1st+(fx2p(j)+fx2p(-j))*Cgq(z2)
     & *(-dlog(xx20))*fx10(0)*msqb
    

C     H1st: muf dependence: Pgq, first leg


      tH1stF=tH1stF+(-dlog(xx10))
     & *(fx1p(j)+fx1p(-j))*Pgq(z1)*fx20(0)*msqb


C     H1st: muf dependence: Pgq, second leg


      tH1stF=tH1stF+(-dlog(xx20))
     & *(fx2p(j)+fx2p(-j))*Pgq(z2)*fx10(0)*msqb
  

CC    End of H1st

      if(order.eq.1) goto 75

CC    Now (gamma+gamma)*(gamma+gamma) term

C     First part: one gamma for each leg


      diff1f=diff1f-dlog(xx10)*Pgq(z1)*(fx1p(j)+fx1p(-j))

      diff2f=diff2f-dlog(xx20)*Pgq(z2)*(fx2p(j)+fx2p(-j))


C     Second part: gamma*gamma terms

c     Pij * Pjk = D1ijjk (log(1-z)/(1-z))_+ + D0ijjk/(1-z)_+ 
c              + Pijjk(z) + Deltaijjk delta(1-z)

      tgaga=tgaga-dlog(xx10)*(Pgqqq(z1)+Pgggq(z1))*(fx1p(j)+fx1p(-j))
     &            *fx20(0)*msqb

      tgaga=tgaga-dlog(xx20)*(Pgqqq(z2)+Pgggq(z2))*(fx2p(j)+fx2p(-j))
     &            *fx10(0)*msqb


C    End of (gamma+gamma)*(gamma+gamma) term


C    Start (C+C)*(gamma+gamma)


c    Gamma first leg

      diffg1f=diffg1f-dlog(xx10)*(fx1p(j)+fx1p(-j))*Pgq(z1)

c    C second leg

      diffc2f=diffc2f-dlog(xx20)*(fx2p(j)+fx2p(-j))*Cgq(z2)

c    Gamma second leg

      diffg2f=diffg2f-dlog(xx20)*(fx2p(j)+fx2p(-j))*Pgq(z2)

c    C first leg

      diffc1f=diffc1f-dlog(xx10)*(fx1p(j)+fx1p(-j))*Cgq(z1)

c    C*gamma: first leg (ignore delta term in Cgg: taken into account in H1stf)


      tcga=tcga+CgqPqq(z1)*(-dlog(xx10))*(fx1p(j)+fx1p(-j))*fx20(0)*msqb 


c    C*gamma: second leg (ignore delta term in Cgg: taken into account in H1stf)


      tcga=tcga+CgqPqq(z2)*(-dlog(xx20))*(fx2p(j)+fx2p(-j))*fx10(0)*msqb 


CC    gamma2: qg channel


c    First leg

      tgamma2=tgamma2
     &       -dlog(xx10)*P2gq(z1)*(fx1p(j)+fx1p(-j))*fx20(0)*msqb 

c    Second leg

      tgamma2=tgamma2
     &       -dlog(xx20)*P2gq(z2)*(fx2p(j)+fx2p(-j))*fx10(0)*msqb 


 75   continue


      enddo

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

c    Check it !      

      tgaga=tgaga+2*msqb
     # *(flgq*diff10*diff20+flgq*diff1f*diff2f
     #   +diff10*diff2f+diff1f*diff20) 

c

c    gamma first leg, C second leg

      tcga=tcga+msqb*
     # (flgq*diffg10*diffc20+flgq*diffg1f*diffc2f
     #          +diffg10*diffc2f+diffg1f*diffc20)

c    gamma second leg, C first leg

      tcga=tcga+msqb*
     # (flgq*diffg20*diffc10+flgq*diffg2f*diffc1f
     #          +diffg20*diffc1f+diffg2f*diffc10)
      

CC   First order


      sig12=-0.5d0*A1g*tdelta


      sig11=-B1g*tdelta-tH1stF
! New Q scale dependence
     &     -A1g*tdelta*LQ


CC   Second order


       sig24=(A1g)**2/8*tdelta
       

       sig23=-beta0*A1g/3*tdelta-0.5d0*A1g*sig11


       sig22=0.5d0*(beta0*A1g*LR-A2g)*tdelta
     &     -0.5d0*A1g*(tH1st+LF*tH1stF)
     &     -0.5d0*(B1g-beta0)*sig11
     &     +0.5d0*B1g*tH1stF
     &     +0.5d0*tgaga
C    Add mur dependence from H1st
     &     +beta0*A1g*LR*tdelta
! New Q scale dependence
     &     + 0.5d0*A1g*LQ * ( - sig11 + 2d0*tH1stF
     &     + tdelta* ( - beta0 + B1g + 0.5d0*A1g*LQ ) )


       sig21=-beta0*LR*sig11-B1g*(tH1st+LF*tH1stF)
     &     -LF*tgaga-B2g*tdelta+beta0*tH1st-tcga-tgamma2
c     Include missing delta term from C*gamma (no factor 2 here !)
       sig21=sig21-C1ggdelta*tH1stF
C     Include missing term from contact term in 2 loop AP
       sig21=sig21-2*Delta2gg*tdelta
C     NEW: Include mur dependence from H1st
       sig21=sig21+2*beta0*LR*(B1g*tdelta+tH1stF)
! New Q scale dependence
       sig21=sig21+ LQ * ( sig11*(beta0-B1g-0.5d0*A1g*LQ)
     &      - A2g*tdelta
     &      + A1g*(2d0*beta0*LR*tdelta-tH1st+(LQ-LF)*tH1stF)
     &      + B1g*tH1stF + tgaga )


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


CC Include as/pi factors and sum O(as) and O(as^2) contributions

           sig1=sig12*LL2+sig11*LL1
           sig2=sig24*LL4+sig23*LL3+sig22*LL2+sig21*LL1
         

           sig1=sig1*(as0/pi)
           sig2=sig2*(as0/pi)**2

           if(order.eq.1)then
            xmsq(1)=-sig1
            else
            xmsq(1)=-(sig1+sig2)
           endif


CC Include iacobians

      xmsq(1)=xmsq(1)*xjacqt2*xjacq2*q2/shad/Vol


      countint=0d0
      xint=0d0


C Multiply by BORN phase space weight

        xmsq(1)=xmsq(1)*fluxborn*pswt0/BrnRat/2d0

! Multiply by the switching weight  'wtswitch'

        xmsq(1)=xmsq(1)*wtswitch

c---Add to total

        xint=xmsq(1)
        val=xmsq(1)*wgt

c---if we're binning, add to histo too
        if (bin) then
          call getptildejet(1,pjet)
          call dotem(nvec,pjet,s)
          val=val/dfloat(itmx)
C           call plotter(ptrans,val,1)
           call plotter(p,val,0)
        endif


      countint=xint
     
      xreal=xreal+xint*wgt/dfloat(itmx)
      xreal2=xreal2+(xint*wgt)**2/dfloat(itmx)

      else

        tdeltat=0d0
        tH1stFt=0d0
        tdeltat2=0d0
        tH1stFt2=0d0
        tdeltatb=0d0
        tH1stFtb=0d0


        sig11t=0d0
        sig12t=0d0
        
        sig11t2=0d0
        sig12t2=0d0
        
        sig11tb=0d0
        sig12tb=0d0
        
      if(gqonly)goto 72

C     Simplest term without convolutions
  
      tdeltat=tdeltat+fx10(0)*fx20(0)*msqbt 
      tdeltat2=tdeltat2+fx10(0)*fx20(0)*msqbt
      tdeltatb=tdeltatb+fx10(0)*fx20(0)*msqb 
      tdelta=tdelta+fx10(0)*fx20(0)*msqb   



C     H1st delta term
      
      tH1st=tH1st+2*C1ggdelta*fx10(0)*fx20(0)*msqb
      
c     gammagg: non delta terms, first leg    


      diff=-dlog(xx10)*((fx1p(0)-fx10(0)*xx10**beta)*3/(1-z1)
     &    +fx1p(0)*Pggreg(z1))

      tH1stFt=tH1stFt+diff*fx20(0)*msqbt
      tH1stFt2=tH1stFt2+diff*fx20(0)*msqbt
      tH1stFtb=tH1stFtb+diff*fx20(0)*msqb
      tH1stF=tH1stF+diff*fx20(0)*msqb
      tH1stFt=tH1stFt-3*D0int(xx10)*fx10(0)*fx20(0)*msqbt
      tH1stFt2=tH1stFt2-3*D0int(xx10)*fx10(0)*fx20(0)*msqbt
      tH1stFtb=tH1stFtb-3*D0int(xx10)*fx10(0)*fx20(0)*msqb
      tH1stF=tH1stF-3*D0int(xx10)*fx10(0)*fx20(0)*msqb
      

c     gammagg: non delta terms, second leg    

      diff=-dlog(xx20)*((fx2p(0)-fx20(0)*xx20**alfa)*3/(1-z2)
     &    +fx2p(0)*Pggreg(z2))

      tH1stFt=tH1stFt+diff*fx10(0)*msqbt
      tH1stFt2=tH1stFt2+diff*fx10(0)*msqbt
      tH1stFtb=tH1stFtb+diff*fx10(0)*msqb
      tH1stF=tH1stF+diff*fx10(0)*msqb
      tH1stFt=tH1stFt-3*D0int(xx20)*fx10(0)*fx20(0)*msqbt
      tH1stFt2=tH1stFt2-3*D0int(xx20)*fx10(0)*fx20(0)*msqbt
      tH1stFtb=tH1stFtb-3*D0int(xx20)*fx10(0)*fx20(0)*msqb
      tH1stF=tH1stF-3*D0int(xx20)*fx10(0)*fx20(0)*msqb

c     gammagg: delta term, both legs


      tH1stFt=tH1stFt+2*beta0*fx10(0)*fx20(0)*msqbt
      tH1stFt2=tH1stFt2+2*beta0*fx10(0)*fx20(0)*msqbt
      tH1stFtb=tH1stFtb+2*beta0*fx10(0)*fx20(0)*msqb
      tH1stF=tH1stF+2*beta0*fx10(0)*fx20(0)*msqb

 72   if(order.eq.1) goto 76

CC    (gamma+gamma)*(gamma+gamma) term

C     First part: one gamma for each leg: gluon channel

      diff10=-dlog(xx10)
     &  *(fx1p(0)-fx10(0)*xx10**beta)/(1-z1)
     &  - D0int(xx10)*fx10(0)

      diff10=3*diff10+beta0*fx10(0)
     &     -dlog(xx10)*fx1p(0)*Pggreg(z1)

      diff20=-dlog(xx20)
     &  *(fx2p(0)-fx20(0)*xx20**alfa)/(1-z2)
     &  - D0int(xx20)*fx20(0)

      diff20=3*diff20+beta0*fx20(0)
     &     -dlog(xx20)*fx2p(0)*Pggreg(z2)


C    Second: gamma*gamma: gluon channel

c    First leg

      diff=-dlog(xx10)*((fx1p(0)-fx10(0)*xx10**beta)
     &    *(D0gggg/(1-z1)+D1gggg*dlog(1-z1)/(1-z1))
     &      +fx1p(0)*(Pggggreg(z1)+Pgqqg(z1)))
     &    +(Deltagggg-D0gggg*D0int(xx10)-D1gggg*D1int(xx10))*fx10(0)


      tgaga=tgaga+diff*flgq*fx20(0)*msqb


c    Second leg

      diff=-dlog(xx20)*((fx2p(0)-fx20(0)*xx20**alfa)
     &    *(D0gggg/(1-z2)+D1gggg*dlog(1-z2)/(1-z2))
     &      +fx2p(0)*(Pggggreg(z2)+Pgqqg(z2)))
     &    +(Deltagggg-D0gggg*D0int(xx20)-D1gggg*D1int(xx20))*fx20(0)

      tgaga=tgaga+diff*flgq*fx10(0)*msqb



CC    Start  (C+C)*(gamma+gamma) term: diagonal part


c    gamma first leg, C second

      diffg10=-dlog(xx10)
     &  *((fx1p(0)-fx10(0)*xx10**beta)*3d0/(1-z1)+Pggreg(z1)*fx1p(0))
     &    +fx10(0)*(beta0-3*D0int(xx10))

      diffc20=C1ggdelta*fx20(0)

c    gamma second leg, C first

      diffg20=-dlog(xx20)
     &  *((fx2p(0)-fx20(0)*xx20**alfa)*3d0/(1-z2)+Pggreg(z2)*fx2p(0))
     &    +fx20(0)*(beta0-3*D0int(xx20))


      diffc10=C1ggdelta*fx10(0)

c    C*gamma: first leg (ignore delta term in Cgg: taken into account in H1stf)

      tcga=tcga+CgqPqg(z1)*(-dlog(xx10))*flgq*fx1p(0)*fx20(0)*msqb 

c    C*gamma: second leg (ignore delta term in Cgg: taken into account in H1stf)

      tcga=tcga+CgqPqg(z2)*(-dlog(xx20))*flgq*fx2p(0)*fx10(0)*msqb 

c    End of (C+C)*(gamma+gamma)


CC    gamma2: diagonal part

c     First leg

      diff=-dlog(xx10)
     &  *(fx1p(0)-fx10(0)*xx10**beta)/(1-z1)
     &  - D0int(xx10)*fx10(0)  

      tgamma2=tgamma2+(1.5d0*Kappa*diff-dlog(xx10)*P2gg(z1)*fx1p(0))
     &                *flgq*fx20(0)*msqb


c     Second leg

      diff=-dlog(xx20)
     &  *(fx2p(0)-fx20(0)*xx20**alfa)/(1-z2)
     &  - D0int(xx20)*fx20(0)  

      tgamma2=tgamma2+(1.5d0*Kappa*diff-dlog(xx20)*P2gg(z2)*fx2p(0))
     &                *flgq*fx10(0)*msqb


 76   continue


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
           
      do j=1,nf


C     H1st: Cgq, first leg


      tH1st=tH1st+(fx1p(j)+fx1p(-j))*Cgq(z1)
     & *(-dlog(xx10))*fx20(0)*msqb


C     H1st: Cgq, second leg

      
      tH1st=tH1st+(fx2p(j)+fx2p(-j))*Cgq(z2)
     & *(-dlog(xx20))*fx10(0)*msqb
    

C     H1st: muf dependence: Pgq, first leg


      tH1stFt=tH1stFt+(-dlog(xx10))
     & *(fx1p(j)+fx1p(-j))*Pgq(z1)*fx20(0)*msqbt
      tH1stFt2=tH1stFt2+(-dlog(xx10))
     & *(fx1p(j)+fx1p(-j))*Pgq(z1)*fx20(0)*msqbt
      tH1stFtb=tH1stFtb+(-dlog(xx10))
     & *(fx1p(j)+fx1p(-j))*Pgq(z1)*fx20(0)*msqb
      tH1stF=tH1stF+(-dlog(xx10))
     & *(fx1p(j)+fx1p(-j))*Pgq(z1)*fx20(0)*msqb


C     H1st: muf dependence: Pgq, second leg


      tH1stFt=tH1stFt+(-dlog(xx20))
     & *(fx2p(j)+fx2p(-j))*Pgq(z2)*fx10(0)*msqbt
      tH1stFt2=tH1stFt2+(-dlog(xx20))
     & *(fx2p(j)+fx2p(-j))*Pgq(z2)*fx10(0)*msqbt
      tH1stFtb=tH1stFtb+(-dlog(xx20))
     & *(fx2p(j)+fx2p(-j))*Pgq(z2)*fx10(0)*msqb
      tH1stF=tH1stF+(-dlog(xx20))
     & *(fx2p(j)+fx2p(-j))*Pgq(z2)*fx10(0)*msqb
  

CC    End of H1st

      if(order.eq.1) goto 77

CC    Now (gamma+gamma)*(gamma+gamma) term

C     First part: one gamma for each leg


      diff1f=diff1f-dlog(xx10)*Pgq(z1)*(fx1p(j)+fx1p(-j))

      diff2f=diff2f-dlog(xx20)*Pgq(z2)*(fx2p(j)+fx2p(-j))


C     Second part: gamma*gamma terms

c     Pij * Pjk = D1ijjk (log(1-z)/(1-z))_+ + D0ijjk/(1-z)_+ 
c              + Pijjk(z) + Deltaijjk delta(1-z)

      tgaga=tgaga-dlog(xx10)*(Pgqqq(z1)+Pgggq(z1))*(fx1p(j)+fx1p(-j))
     &            *fx20(0)*msqb

      tgaga=tgaga-dlog(xx20)*(Pgqqq(z2)+Pgggq(z2))*(fx2p(j)+fx2p(-j))
     &            *fx10(0)*msqb


C    End of (gamma+gamma)*(gamma+gamma) term


C    Start (C+C)*(gamma+gamma)


c    Gamma first leg

      diffg1f=diffg1f-dlog(xx10)*(fx1p(j)+fx1p(-j))*Pgq(z1)

c    C second leg

      diffc2f=diffc2f-dlog(xx20)*(fx2p(j)+fx2p(-j))*Cgq(z2)

c    Gamma second leg

      diffg2f=diffg2f-dlog(xx20)*(fx2p(j)+fx2p(-j))*Pgq(z2)

c    C first leg

      diffc1f=diffc1f-dlog(xx10)*(fx1p(j)+fx1p(-j))*Cgq(z1)

c    C*gamma: first leg (ignore delta term in Cgg: taken into account in H1stf)


      tcga=tcga+CgqPqq(z1)*(-dlog(xx10))*(fx1p(j)+fx1p(-j))*fx20(0)*msqb 


c    C*gamma: second leg (ignore delta term in Cgg: taken into account in H1stf)


      tcga=tcga+CgqPqq(z2)*(-dlog(xx20))*(fx2p(j)+fx2p(-j))*fx10(0)*msqb 


CC    gamma2: qg channel


c    First leg

      tgamma2=tgamma2
     &       -dlog(xx10)*P2gq(z1)*(fx1p(j)+fx1p(-j))*fx20(0)*msqb 

c    Second leg

      tgamma2=tgamma2
     &       -dlog(xx20)*P2gq(z2)*(fx2p(j)+fx2p(-j))*fx10(0)*msqb 


 77   continue


      enddo

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

c    Check it !      

      tgaga=tgaga+2*msqb
     # *(flgq*diff10*diff20+flgq*diff1f*diff2f
     #   +diff10*diff2f+diff1f*diff20) 

c

c    gamma first leg, C second leg

      tcga=tcga+msqb*
     # (flgq*diffg10*diffc20+flgq*diffg1f*diffc2f
     #          +diffg10*diffc2f+diffg1f*diffc20)

c    gamma second leg, C first leg

      tcga=tcga+msqb*
     # (flgq*diffg20*diffc10+flgq*diffg2f*diffc1f
     #          +diffg20*diffc1f+diffg2f*diffc10)
      

CC   First order


      sig12t=-0.5d0*A1g*tdeltat
      sig12t2=-0.5d0*A1g*tdeltat2
      sig12tb=-0.5d0*A1g*tdeltatb
      sig12=-0.5d0*A1g*tdelta


      sig11t=-B1g*tdeltat-tH1stFt
! New Q scale dependence
     &     -A1g*tdeltat*LQ
      sig11t2=-B1g*tdeltat2-tH1stFt2
! New Q scale dependence
     &     -A1g*tdeltat2*LQb
      sig11tb=-B1g*tdeltatb-tH1stFtb
! New Q scale dependence
     &     -A1g*tdeltatb*LQb
      sig11=-B1g*tdelta-tH1stF
! New Q scale dependence
     &     -A1g*tdelta*LQ


CC   Second order


       sig24=(A1g)**2/8*tdelta
       

       sig23=-beta0*A1g/3*tdelta-0.5d0*A1g*sig11


       sig22=0.5d0*(beta0*A1g*LR-A2g)*tdelta
     &     -0.5d0*A1g*(tH1st+LF*tH1stF)
     &     -0.5d0*(B1g-beta0)*sig11
     &     +0.5d0*B1g*tH1stF
     &     +0.5d0*tgaga
C    Add mur dependence from H1st
     &     +beta0*A1g*LR*tdelta
! New Q scale dependence
     &     + 0.5d0*A1g*LQ * ( - sig11 + 2d0*tH1stF
     &     + tdelta* ( - beta0 + B1g + 0.5d0*A1g*LQ ) )


       sig21=-beta0*LR*sig11-B1g*(tH1st+LF*tH1stF)
     &     -LF*tgaga-B2g*tdelta+beta0*tH1st-tcga-tgamma2
c     Include missing delta term from C*gamma (no factor 2 here !)
       sig21=sig21-C1ggdelta*tH1stF
C     Include missing term from contact term in 2 loop AP
       sig21=sig21-2*Delta2gg*tdelta
C     NEW: Include mur dependence from H1st
       sig21=sig21+2*beta0*LR*(B1g*tdelta+tH1stF)
! New Q scale dependence
       sig21=sig21+ LQ * ( sig11*(beta0-B1g-0.5d0*A1g*LQ)
     &      - A2g*tdelta
     &      + A1g*(2d0*beta0*LR*tdelta-tH1st+(LQ-LF)*tH1stF)
     &      + B1g*tH1stF + tgaga )


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


CC Include as/pi factors and sum O(as) and O(as^2) contributions
   
         sig1=sig12t*LL2+sig11t*LL1+
     &        sig12tb*LLb2+sig11tb*LLb1-
     &        sig12t2*LLb2-sig11t2*LLb1

         
         sig2=sig24*LL4+sig23*LL3+sig22*LL2+sig21*LL1
         

         sig1=sig1*(as0/pi)
         sig2=sig2*(as0/pi)**2

         if(order.eq.1)then
          xmsq(1)=-sig1
          else
          xmsq(1)=-(sig1+sig2*sigmat/sigmatb)
         endif


CC Include iacobians

      xmsq(1)=xmsq(1)*xjacqt2*xjacq2*q2/shad/Vol


      countint=0d0
      xint=0d0


C Multiply by BORN phase space weight

        xmsq(1)=xmsq(1)*fluxborn*pswt0/BrnRat/2d0

! Multiply by the switching weight  'wtswitch'

        xmsq(1)=xmsq(1)*wtswitch

c---Add to total

        xint=xmsq(1)
        val=xmsq(1)*wgt

c---if we're binning, add to histo too
        if (bin) then
          call getptildejet(1,pjet)
          call dotem(nvec,pjet,s)
          val=val/dfloat(itmx)
C           call plotter(ptrans,val,1)
           call plotter(p,val,0)
        endif


      countint=xint
     
      xreal=xreal+xint*wgt/dfloat(itmx)
      xreal2=xreal2+(xint*wgt)**2/dfloat(itmx)
      endif

      return



 999  countint=0d0
      ntotzero=ntotzero+1
      return

      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC gg splitting function (not normalized !)

      function Pgg(x)
      implicit none
      real *8 Pgg,x

      Pgg=1d0/(1-x)+1d0/x-2+x*(1-x)

      return
      end


CC gg splitting function: regular part (with asopi normalization)


      function Pggreg(z)
      implicit none
      real *8 Pggreg,z
      Pggreg=3*((1-2*z)/z+z*(1-z))
      return
      end

CC gq splitting function (with asopi normalization)

      function Pgq(z)
      implicit none
      real *8 Pgq,z
      Pgq=2d0/3*(1+(1-z)**2)/z
      return
      end




CC Cgq coefficient (with asopi normalization)

      function Cgq(z)
      implicit none
      real *8 Cgq,z
      Cgq=2d0/3*z
      return
      end



CC Integral of 1/(1-x) from 0 to z

      function D0int(z)
      implicit none
      real *8 D0int,z
      D0int=-dlog(1-z)
      return
      end

CC Integral of log(1-x)/(1-x) from 0 to z

      function D1int(z)
      implicit none
      real *8 D1int,z
      D1int=-0.5d0*dlog(1-z)**2
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                P*P convolutions
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      function Pggggreg(x) ! checked !
      implicit none
      real *8 Pggggreg,x
      real *8 Pggreg,beta0
      integer nf
      external Pggreg

      nf=5
      beta0=(33-2*nf)/12d0

      Pggggreg=-9*dlog(x)/(1-x)+2*beta0*Pggreg(x)
     &   +9*(3*(1-x)+11d0/3/x*(x**3-1d0)+2d0/3*dlog(1-x)*Pggreg(x)
     &   +dlog(x)*(x**2-3*x-1d0/x))

      return
      end


      function Pgggq(x) ! checked !
      implicit none
      real *8 Pgggq,x
      real *8 Pgq,beta0
      integer nf
      external Pgq

      nf=5
      beta0=(33-2*nf)/12d0

      Pgggq=2*((1+(1-x)**2)/x*dlog(1-x)-2*(1+x+1d0/x)*dlog(x)
     &    +4-31d0/6/x+x/2+2d0/3*x**2)+beta0*Pgq(x)

      return
      end

      function Pgqqq(x) ! checked !
      implicit none
      real *8 Pgqqq,x
      
      Pgqqq=4d0/9*((2-x)*dlog(x)+dlog(1-x)*(2*x+4/x-4)+2-x/2)
      
      return
      end

      function Pgqqg(x) ! checked !
      implicit none
      real *8 Pgqqg,x
      integer nf

      nf=5 
      Pgqqg=1d0/6*(1+4d0/3/x-x-4*x**2/3+2*(1+x)*dlog(x))

      Pgqqg=2*nf*Pgqqg

      return
      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                C*P convolutions
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      function CgqPqq(x) ! checked !
      implicit none
      real *8 CgqPqq,x
      
      CgqPqq=2d0/9*(2+x+4*x*dlog(1-x)-2*x*dlog(x))

      return
      end



      function CgqPqg(x) ! checked !
      implicit none
      real *8 CgqPqg,x
      integer nf

      nf=5       
      CgqPqg=1d0/6*(1+x-2*x**2+2*x*dlog(x))

      CgqPqg=2*nf*CgqPqg

      return
      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C           Two loop AP:  pqq of ESW is my 3/2 Pqq
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      function P2gg(x)
      implicit none
      real *8 P2gg,S2,pgg,x,pi
      integer nf
      external pgg,S2

      nf=5

      pi=3.14159265358979d0

      P2gg=2d0/3*nf*(-16+8*x+20d0/3*x**2+4d0/3/x-(6+10*x)*dlog(x)
     &    -(2+2*x)*dlog(x)**2)+1.5d0*nf*(2-2*x+26d0/9*(x**2-1d0/x)
     &    -4d0/3*(1+x)*dlog(x)-20d0/9*(1/x-2+x*(1-x)))
     &    +9*(27d0/2*(1-x)+67d0/9*(x**2-1d0/x)
     &        -(25d0/3-11d0/3*x+44d0/3*x**2)*dlog(x)
     &        +4*(1+x)*dlog(x)**2+2*pgg(-x)*S2(x)
     &    +(67d0/9-pi**2/3)*(1/x-2+x*(1-x))
     &     +(-4*dlog(x)*dlog(1-x)+dlog(x)**2)*pgg(x))
     

      P2gg=P2gg/4d0

      return
      end


      function P2gq(x)
      implicit none
      real *8 P2gq,Pgq,S2,x,logx,logomx,pi
      external Pgq,S2
      integer nf
     
      pi=3.14159265358979d0

      nf=5

      logx=dlog(x)
      logomx=dlog(1-x)

      P2gq=16d0/9*(-2.5d0-3.5d0*x+(2+3.5d0*x)*logx
     &     -(1-0.5d0*x)*logx**2-2*x*logomx
     &     -(3*logomx+logomx**2)*1.5d0*Pgq(x))
     &     +4d0*(28d0/9+65d0/18*x+44d0/9*x**2-(12+5*x+8d0/3*x**2)*logx
     &     +(4+x)*logx**2+2*x*logomx+S2(x)*1.5d0*Pgq(-x)
     &     +(0.5d0-2*logx*logomx+0.5d0*logx**2+11d0/3*logomx+logomx**2
     &     -pi**2/6)*1.5d0*Pgq(x))
     &     +2d0/3*nf*(-4d0*x/3-(20d0/9+4d0/3*logomx)*1.5d0*Pgq(x))


      P2gq=P2gq/4

      return
      end



C    S2: Eq. (4.114) ESW

      function S2(x)
      implicit none
      real *8 x,pi,S2,myli2
      external myli2      
      pi=3.14159265358979d0

      S2=-2*myli2(-x)+0.5d0*dlog(x)**2-2*dlog(x)*dlog(1+x)-pi**2/6
      return
      end
