
CC    Modified to do full NNLL+NNLO calculation
C
C     lowres is the resummed contribution
C     
C     realvirt is real (V + 2 partons) + virtual (V + 1 parton)

C     Number of calls reduced by a factor of ~2*10000 for lowres


      subroutine integrate(myinit,myitmx,myncall,mybin,xinteg,xerr)
************************************************************************
*                                                                      *
*  This routine should perform the sweeps of vegasnr                   *
*                                                                      *
*    Input parameters:                                                 *
*       myinit  :  the vegasnr routine entry point                     *
*       myitmx  :  the number of vegasnr sweeps                        *
*      myncall  :  the number of iterations per sweep                  *
*          bin  :  whether or not the results should be histogrammed   *
*                                                                      *
*    Returned variables:                                               *
*       xinteg  :  value of integration                                *
*         xerr  :  integration error                                   *
*                                                                      *
************************************************************************
      implicit none
      include 'gridinfo.f'
      include 'scale.f'
      include 'facscale.f'
      include 'vegas_common.f'
      integer myitmx,virtmyitmx,myncall,myinit,i,j,k
      logical mybin,bin
      double precision sig,sd,chi,sigr,sdr,sigdk,sddk,chidk,
     . xreal,xreal2,xinteg,xerr,adjust,myscale,myfacscale,ratioitmx
      character*4 part,mypart
      common/ratioitmx/ratioitmx
      common/part/part
      common/mypart/mypart
      common/bin/bin
      common/xreal/xreal,xreal2
      double precision lowint,virtint,realint,lowres,randummy,ran2
      double precision region(2*mxdim)
      integer order
      common/nnlo/order
      integer higgsdec,ndec
      common/higgsdec/higgsdec,ndec
      integer myncall0,minmyncall0,minmyncall,idum,rseed
      double precision realvirt2,realvirt4
      character*30 runstring
      common/runstring/runstring

      logical first,myreadin
      external lowres,virtint,realint
      common/rseed/rseed
      common/ranno/idum

      integer realvirtpart
      common/realvirtpart/realvirtpart

      external realvirt2,realvirt4

      data first/.true./
      save first


CC    For lowres the number of calls is divided
! Automatically increased, in case of too few calls
! minmycall0=minimum calls number for virtual part
! minmycall=minimum calls number for real part

      minmyncall0=400

      if(order.eq.1) then

      minmyncall=40000
      myncall0=IDINT(myncall/10000d0)
      if(myinit.eq.0) then
        if(myncall0.lt.minmyncall0) then
          myncall0=minmyncall0
        endif
        if(myncall.lt.minmyncall) then
          myncall=minmyncall
        endif
      else
        if(myncall0.lt.minmyncall0)myncall0=minmyncall0
        if(myncall.lt.minmyncall)myncall=minmyncall
      endif

      elseif(order.eq.2) then

      minmyncall=400000
      myncall0=IDINT(myncall/10000d0)
      if(myinit.eq.0) then
        if(myncall0.lt.minmyncall0) then
          myncall0=minmyncall0
        endif
        if(myncall.lt.minmyncall) then
          myncall=minmyncall
        endif
      else
        if(myncall0.lt.minmyncall0)myncall0=minmyncall0
        if(myncall.lt.minmyncall)myncall=minmyncall
      endif

      endif

CC


c--- Initialize all integration results to zero, so that the
c--- total of virt and real may be combined at the end for 'tota'
      sig=0d0
      sigr=0d0
      sigdk=0d0
      sd=0d0
      sdr=0d0
      sddk=0d0
      xreal=0d0
      xreal2=0d0
      
    

c--- Put the vegasnr parameters in the common block
C---  virtmyitmx is different to improve the computational speed; if you change here, you must change also in lowres.f and plotter.f

!      virtmyitmx=IDINT(myitmx/2d0)
      virtmyitmx=myitmx
      ratioitmx=dble(virtmyitmx)/(dble(myitmx))
      itmx=virtmyitmx
      ncall=myncall0
      bin=mybin
      

c--- Store value of part in mypart, which will be retained;
c--- also store value of scale in myscale, which will be retained;
c--- part and scale can be changed to make sure that the tota option works.
      mypart=part
      myscale=scale
      myfacscale=facscale
CC 
      myreadin=readin
CC

c--- If we're doing the tota integration, then set up the grid info
      if (mypart .eq. 'tota') then
        if (first .and. (myinit .eq. 1)) then
            call strcat(runstring,'_dvegas_virt.grid',ingridfile)
            myreadin=readin
        else
          if (first .eqv. .true.) then
            readin=.false.
            writeout=.true.
            call strcat(runstring,'_dvegas_virt.grid',outgridfile)
          else
            readin=.true.
            writeout=.false.
            call strcat(runstring,'_dvegas_virt.grid',ingridfile)
          endif
        endif
      endif

C Virt part contanis the resummed contribution

      if ((mypart .eq. 'virt') .or. (mypart .eq. 'tota'))  then
c--- set-up the random number generator with a negative seed
      if(myinit.eq.0) then
      idum=-abs(1+rseed)
      else
      idum=-abs(2+rseed)
      endif
      randummy=ran2()
      part='virt'
      realvirtpart=1
!      write(*,*)part,myncall0

C    Add two dimensions for convolutions
        ndim=ndim+2
        call boundregion(3,region)
        call vegasnr(region,3,lowres,myinit,myncall0,virtmyitmx,         !IDINT(myitmx/2d0),   ! myitmx/2: the lowres integration is fast convergent
     .              0,sig,sd,chi)
        ndim=ndim-2
      endif


      itmx=myitmx


      if(order.eq.0) goto 99


CC   Prepare the grid also for real only

c--- If we're doing the tota integration, then set up the grid info
        if ((mypart .eq. 'tota') .or. (mypart .eq. 'real')) then
c--- set-up the random number generator with a negative seed
      if(myinit.eq.0) then
      idum=-abs(3+rseed)
      else
      idum=-abs(4+rseed)
      endif
      randummy=ran2()



        if (first .and. (myinit .eq. 1)) then
c-- special input name for real grid
!strcat(str1,str2,str) concatenates str1 and str2 into str. Ignores trailing blanks of str1,str2
          call strcat(runstring,'_dvegas_real.grid',ingridfile)
          readin=myreadin
        else
          if (first .eqv. .true.) then
           readin=.false.
           writeout=.true.
           call strcat(runstring,'_dvegas_real.grid',outgridfile)
          else
            readin=.true.
            writeout=.false.
           call strcat(runstring,'_dvegas_real.grid',ingridfile)
          endif
        endif
      endif 
 
CC Here real and virtual are together, in MCFM they are separate


c--- Real integration should have three extra dimensions

      if ((mypart .eq. 'real').or.(mypart.eq.'tota')) then
        part='real'
        realvirtpart=-1

!        write(*,*)part,myncall
        ndim=ndim+6
        xreal=0d0
        xreal2=0d0
        call boundregion(ndim,region)

        if(higgsdec.eq.1) then
         call vegasnr(region,ndim,realvirt2,myinit,myncall,myitmx,
     .              0,sigr,sdr,chi)                                  !realvirt2:  H->2gamma
        else
         call vegasnr(region,ndim,realvirt4,myinit,myncall,myitmx,
     .              0,sigr,sdr,chi)                                  !realvirt4:  H->3456
        endif 
        ndim=ndim-6
        write(6,*)
        ncall=myncall
      endif

 99   continue

c--- calculate integration variables to be returned
      xinteg=sig+sigr+sigdk
      xerr=dsqrt(sd**2+sdr**2+sddk**2)

*    Returned variables:                                               *
*       xinteg  :  value of integration                                *
*         xerr  :  integration error                                   *
      
c--- return part and scale to their real values
      part=mypart
      scale=myscale
      first=.false.
      
      return
      end
      
      
      subroutine boundregion(idim,region)
c--- Initializes integration region [0,1] for each variable
c--- in the idim-dimensional integration range
      implicit none
      include 'mxdim.f'
      integer i,idim
      double precision region(2*mxdim)
      
      do i=1,idim
      region(i)=0d0
      region(i+idim)=1d0
      enddo
      
      return
      end
      
      
