      subroutine setup
      implicit none
      include 'constants.f'
      include 'virtonly.f'
      include 'realonly.f'
      include 'noglue.f'
      include 'lc.f'
      include 'cutoff.f'
      include 'maxwt.f'
      include 'masses.f'
      include 'process.f'
      include 'scale.f'
      include 'facscale.f'
      include 'zerowidth.f'
      include 'vzerowidth.f'
      include 'removebr.f'
      include 'clustering.f'
      include 'gridinfo.f'
      include 'limits.f'
      include 'alfacut.f'
      include 'pdfiset.f'
      include 'qcdcouple.f'
      include 'zcouple.f'
      include 'nlooprun.f'
      include 'rescoeff.f'
      include 'jetcuts.f'
      include 'dynamicscale.f'
      include 'dipolescale.f'

      include 'vegas_common.f'
      include 'nwz.f'
      include 'ewcharge.f'
      character *2 plabel(mxpart)
      common/plabel/plabel
      integer order,notag,nqcdjets,nqcdstart,isub,higgsdec,ndec,nd
     .        ,flaginitres,inorm,nwidth
      common/nwidth/nwidth
      common/nnlo/order
      common/inorm/inorm
      common/notag/notag
      common/nqcdjets/nqcdjets,nqcdstart
      common/isub/isub
      double precision BrnRat,gamgambr,wwbr,zzbr,br0,mHmin,mHmax
      common/BrnRat/BrnRat
      common/gamgambr/gamgambr,br0
      common/mlimits/mHmin,mHmax
      common/higgsdec/higgsdec,ndec
      double precision qtminvirt,qtminreal,qtmax1,qtmax2,qtsw,swqt
      common/qtcut/qtminvirt,qtminreal,qtmax1,qtmax2,qtsw
      double precision beta1,H2ggdelta,H2ggD0
      common/Hstcoeff/beta1,H2ggdelta,H2ggD0

      logical isol
      common/isol/isol

      logical int
      common/int/int

      logical dorebin
      common/dorebin/dorebin

      real *8 smur,smuf
      common/scalefactors/smur,smuf

CC     alphas evaluated at the static scale

      real *8 as0
      common/as0/as0

      character *50 prefix
      character *36 pdfstring
      integer nset
      common/prefix/nset,prefix
      common/pdfstring/pdfstring

      double precision a_param,b0p,a_paramb,b0pb
      COMMON/a_param/a_param,a_paramb,b0p,b0pb
      double precision C1ggextb,C1ggext
      common/C1coeff/C1ggextb,C1ggext

      character*4 part
      character*30 runstring

      character*30 namefull
      logical fulloutput
      common/fulloutput/fulloutput,namefull


      integer j,approxim
      logical makecuts,switchingmethod
      integer nmin,nmax,n2,n3
      integer ih1,ih2,itmx1,itmx2,ncall1,ncall2,idum,rseed
      double precision rtsmin,sroot,LT
      double precision Mwmin,Mwmax
      double precision Rcut,resfac
      double precision ran2,randummy
      double precision cmass,bmass,xmb,xmt !!!MIO
      double precision mass2,width2,mass3,width3
      double precision amz,alphas
      double precision brwen,brzee,brtau,brtop
      double precision mtop,mbot,sigmatb,sigmat
      double precision abisq,abisqnnlo,c1ggdeltaf,c1ggdeltaft
      
      character *3 str1
      character *8 str2
      character *38 str3
      character *50 string


      double precision resummscale,resummscaleb
      common/resummscale/resummscale,resummscaleb
      common/couple/amz
      
      common/breit/n2,n3,mass2,width2,mass3,width3
      
      common/nmin/nmin
      common/nmax/nmax
      common/rtsmin/rtsmin
      double precision xlam 
      COMMON/xlam/xlam

      common/part/part
      common/runstring/runstring
      common/energy/sroot
      common/density/ih1,ih2
      common/iterat/itmx1,ncall1,itmx2,ncall2
      common/ranno/idum
CH
      common/tbmass/mtop,mbot
      common/flag/approxim
      common/Born/sigmatb,sigmat
      common/rescale/resfac
CH
      common/Rcut/Rcut
      common/makecuts/makecuts
      common/qmass/cmass,bmass
      common/rseed/rseed

      common/flaginitres/flaginitres
      common/xm/xmb,xmt
      common/LT/LT

      integer mem
      character name*64
      common/name/name
      common/mem/mem



      save /ranno/

      flaginitres=0

      isol=.false.

      virtonly=.false.
      realonly=.false.

      noglue=.false.
      ggonly=.false.
      gqonly=.false.

      nmin=1
      nmax=2

      clustering=.false.
      colourchoice=0
      rtsmin=40d0
      cutoff=0.01d0


CC
      aii=1d0
      aif=1d0
      afi=1d0
      aff=1d0

CC Finite width effects for the Higgs boson            

      zerowidth=.true.

CC Finite width effects for W and Z decay

      vzerowidth=.false.


CC Switching prescription

      switchingmethod=.true.

C     Limits on invariant mass of Higgs decay products
C     (irrelevant if zerowidth=.true.)

      
      Mwmin=40d0
      Mwmax=7000d0

      inclusive=.true.
      algorithm='ktal'


CC   Parameters used to define jets

      ptjetmin=0d0
      etajetmin=0d0
      etajetmax=20d0

      Rcut=0.4d0

CC

      removebr=.false.

! Don't change the variable makecuts

      makecuts=.true.

CC    Adjust the grid at each iteration

      dorebin=.true.


CC    Read a previously saved grid

      readin=.false.

      writeout=.false.
      ingridfile=''
      outgridfile=''

CC    Read inputfile

      read(*,*) sroot
      read(*,*) ih1,ih2
      read(*,*) hmass
      read(*,*) resummscale
      read(*,*) resummscaleb
      read(*,*) smur,smuf ! renormalization and factorization scale factors
      read(*,*) dynamicscale
      read(*,*) order        
      read(*,*) higgsdec !decay mode
      read(*,*) part
      read(*,*) itmx1,ncall1
      read(*,*) itmx2,ncall2
      read(*,*) rseed              ! random number seed
      read(*,*) iset,nset          ! native: pdf set, eigenvector set      

CH
      read(*,*) mtop               ! mass of the top quark
      read(*,*) mbot               ! mass of the bottom quark
      read(*,*) approxim
CH
      read(*,*) name,mem           ! LHApdf: name=the specific PDFset name; mem=individual PDF member it has to be initialized
      read(*,*) runstring
      read(*,*) fulloutput,namefull

      a_param=hmass/resummscale
      a_paramb=hmass/resummscaleb

CH

      scale=smur*hmass
      facscale=smuf*hmass


CC    Set all factorization scales to facscale
CC    to avoid problems when dynamicscale=.false.

      do nd=0,40
       dipscale(nd)=facscale
      enddo


      if(fulloutput) open(unit=55,file=namefull,status='unknown')


      xmb=mbot
      xmt=mtop

CC    Large mtop aproximation in virtual: 
CC    normalization (0) mtop->infinity (1) full mt,mb dependence

      inorm=0

c--- initialize the pdf set
      nlooprun=0
      call pdfset

! Initialization for native PDFs, dummy for LHAPFD
      call lambda5qcd(xlam,iset)


CC    Cut on qt Higgs

      qtminvirt=0.0d0
      qtminreal=0.5d0


! Switching between matched and fixed-order calculation

      if(switchingmethod) then

! Estimation of the switching point between matched and fixed order
        if(order.eq.1)then
         swqt=0.5d0*hmass+(1.2d-3)*sroot*(2.5d0+a_param)
        else
         swqt=0.6d0*hmass+(2.8d-3)*sroot*a_param
        endif
        qtmax1= swqt-30d0
        qtmax2= swqt+30d0

      else

! Simple cut at 20% of the CME
!        qtmax1 = 1d3
        qtmax1 = sroot * 0.2d0
        qtmax2 = qtmax1

      endif

! OLD Switching between matched and fixed-order calculation
!      qtmax1 = (hmass+resummscale) * 0.5d0
!      qtmax2 = qtmax1 * 1.5d0


      qtsw =   qtmax2 - qtmax1


      wsqmin=Mwmin**2
      wsqmax=Mwmax**2

C     Check if the limits are compatible with sroot
C     The minum x cannot go below 10^(-5):
C     At the LHC the minimum invariant mass cannot go below 44.27 GeV

      if(wsqmin.lt.(sroot**2*1d-5)) wsqmin=(sroot**2*1d-5)
      if(wsqmax.gt.(sroot**2)) wsqmax=sroot**2


      do j=1,mxpart
      plabel(j)=''
      enddo


      plabel(1)='pp'
      plabel(2)='pp'

c--- the default behaviour is to remove no branching ratio

      BrnRat=1d0

      call coupling

      

      notag=0
      nqcdjets=0
      isub=0


      
      mb=0
    
CC    Compute Higgs BR ratios

C     br0 is tree level H->bbar BR which is needed here

      call sethparams(br0,gamgambr,wwbr,zzbr)
      case='ggfus1'
    
     
      if((ih1.eq.1).and.(ih2.eq.-1)) then
       str1='ppb'
      elseif((ih1.eq.1).and.(ih2.eq.1)) then
       str1='pp'
      else
       write(*,*)'Initial state not allowed'
       stop
      endif

      str2=' -> H -> ' 

CC    Here ndim is the number of dimensions for Born

      if(higgsdec.eq.1) then
C
C     H->2gamma
C
       ndec=2
       ndim=4    
       plabel(3)='tl'
       plabel(4)='ta'
       plabel(5)='pp'
       plabel(6)='pp'
       n2=0
       n3=1
       mass3=hmass
       width3=hwidth
       if (removebr) then
        Brnrat=br0
       else
        Brnrat=br0/gamgambr
       endif
!       write(*,300)brnrat,br0,gamgambr,br0/gamgambr
!  300	FORMAT ('2gamma', F15.10, F15.10, F15.12, F15.10)
      str3=' gamma(p3)+gamma(p4)'

      elseif(higgsdec.eq.2) then
C
C      H->2W->4l
C
       ndec=4
       ndim=10
       plabel(3)='nl'
       plabel(4)='ea'
       plabel(5)='el'
       plabel(6)='na'
       plabel(7)='pp'
       plabel(8)='pp'
       n2=1
       n3=1
       mass2=wmass
       width2=wwidth
       mass3=wmass
       width3=wwidth
       
       if(zerowidth.and.(hmass.lt.2*wmass).and.vzerowidth)then
        write(*,*)'MH < 2MW !'
        stop
       endif

       if (removebr) then
! Branch calcola i brnrat per i decadimenti di W e Z in leptoni
        call branch(brwen,brzee,brtau,brtop)
        BrnRat=brwen**2*wwbr
       endif

      str3=' WW -> nu(p3)+e+(p4)+e-(p5)+nubar(p6)'

      elseif(higgsdec.eq.31) then
C
C      H->2Z->mu-mu+e-e+
C
       ndec=4
       ndim=10

       l1=le
       r1=re
       l2=le
       r2=re

       plabel(3)='el'
       plabel(4)='ea'
       plabel(5)='ml'
       plabel(6)='ma'
       plabel(7)='pp'
       plabel(8)='pp'
       n2=1
       n3=1
       mass2=zmass
       width2=zwidth
       mass3=zmass
       width3=zwidth

       int=.false.

       str3=' ZZ -> mu-(p3)+mu+(p4)+e-(p5)+e+(p6)'
       
       if(zerowidth.and.(hmass.lt.2*zmass).and.vzerowidth) then
        write(*,*)'MH < 2MZ !'
        stop
       endif

       if (removebr) then
        call branch(brwen,brzee,brtau,brtop)
        BrnRat=2d0*brzee**2*zzbr ! factor of 2 for identical particles      
       endif

C
C      H->2Z->e-e+e-e+
C

       elseif(higgsdec.eq.32) then

       ndec=4
       ndim=10

       l1=le
       r1=re
       l2=le
       r2=re

       plabel(3)='el'
       plabel(4)='ea'
       plabel(5)='el'
       plabel(6)='ea'
       plabel(7)='pp'
       plabel(8)='pp'
       n2=1
       n3=1
       mass2=zmass
       width2=zwidth
       mass3=zmass
       width3=zwidth


       str3=' ZZ -> e-(p3)+e+(p4)+e-(p5)+e+(p6)'

       if((hmass.lt.2*zmass).and.vzerowidth.eqv..true.) then
       write(*,*)'MH < 2MZ !'
       stop
       endif
       int=.true.   

      else
       write(*,*)'Wrong decay channel'
       stop
      endif

CCCCCCCCCCCCC

      call strcat(str1,str2,string)
      call strcat(string,str3,string)

     
      call cstring(string)      
     

      write(6,*)'C                                                   C'

      if(order.eq.1) then
      write(6,*)'C       Computing NLL+NLO cross section for         C'
      elseif(order.eq.2) then
      write(6,*)'C       Computing NNLL+NNLO cross section for       C'
      else
      write(6,*)'Order can be 1 or 2 !'
       stop
      endif
  
      write(6,*)'C                                                   C' 
      write(6,*)'C',string,' C'
      write(6,*)'C                                                   C' 
      write(6,96)sroot
      write(6,*)'C                                                   C'
      write(6,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC' 
      write(6,*)

 96   format(' C           at  Sqrt(s)=',f8.2,' GeV                C')

!      write(55,*)'( ',string
        write(55,876)string
 876    FORMAT('( ',30a)
      nqcdjets=0
    

      call ckmfill(nwz)

    

CCCCCCCCCCCCCCCCCC


c--- set-up the random number generator with a negative seed
      idum=-abs(rseed)
      randummy=ran2()

c--- initialize masses for alpha_s routine
      cmass=dsqrt(mcsq)
      bmass=mbot


c--- check that we have a valid value of 'part'
      if ( (part .ne. 'real') .and.
     .     (part .ne. 'virt') .and. (part .ne. 'tota') ) then
          write(6,*) 'part=',part,' is not a valid option'
          stop     
      endif      

C--- Initialization alpha_s
      aass=alphas(scale,amz,nlooprun)
      ason2pi=aass/twopi
      ason4pi=aass/fourpi
      gsq=fourpi*aass
      musq=scale**2

C    alphas at the static scale (it won't change with dynamic scale)

      as0=aass

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC    Resummation coefficients

      beta0=(33-2*nf)/12d0

      beta1=(153d0-19*nf)/24d0

      Kappa=67/6d0-(pi**2)/2d0-5d0/9d0*nf

      A1g=3d0
      A2g=0.5d0*A1g*Kappa
      B1g=-2*beta0

! Resummation limits for the off-shell-higgs-mass

      nwidth=100
      mHmax=hmass+dfloat(nwidth)*hwidth
      mHmin=hmass-dfloat(nwidth)*hwidth


!      if(.not. zerowidth)then

! Limits for off-shell higgs mass (for numerical stability)
       if( mHmax .gt. (hmass* 3d0) ) then
!          write(*,*)'Fat Higgs', mHmax,' -> ',hmass*3d0
          mHmax=hmass*3d0
       endif
       if( mHmin .lt. (hmass/3d0) ) then
!          write(*,*)'Fat Higgs', mHmin,' -> ',hmass/3d0
          mHmin=hmass/3d0
       endif

!      endif

C     B2g from qt code (checked !)

      B2g=9*(23/24d0+(11*pi**2)/18d0-3*Z3/2d0)+
     /    2*nf/3d0-3*nf*(1/12d0+pi**2/9d0)-11/2d0

      

C     Delta term in c1gg coefficient
CH
      C1ggdelta=(11+3*pi**2)/4d0
      if(approxim.eq.0)then
        C1ggdeltaex=(11+3*pi**2)/4d0
      elseif(approxim.eq.1)then
       C1ggdeltaex=c1ggdeltaf(0,hmass,mtop,mbot)
      elseif(approxim.eq.2)then
       C1ggdeltaex=c1ggdeltaf(0,hmass,mtop,mbot)
       C1ggdeltaext=c1ggdeltaft(0,hmass,mtop,mbot)
       C1ggextb=c1ggdeltaf(0,hmass,mtop,mbot)
       C1ggext=c1ggdeltaft(0,hmass,mtop,mbot)
       C1ggdeltaextb=C1ggdeltaex-C1ggdeltaext
      endif
CH
C     Delta term in P2gg splitting function (as/pi normalization)

      Delta2gg=9*(8d0/3+3*Z3)-2d0/3*nf-2*nf

      Delta2gg=Delta2gg/4d0

CC    Coefficients of D0 and D1 in P*P (as/pi normalization)

      D0gggg=6*beta0
      D1gggg=18d0

CC    Coefficients of delta(1-z) in P*P

      Deltagggg=beta0**2-3d0/2*pi**2

C     H2gg contribution: coefficient of delta(1-z)

      LT=2*dlog(hmass/mtop)

      H2ggdelta=11399d0/144+19d0/8*LT+133*Pi**2/8+13d0/16*Pi**4
     #          -55d0/2*Z3+nf*(-1189d0/144+2d0*LT/3-5*Pi**2/12)

      LT=2d0*LT

C     H2gg contribution: coefficient of D0(z)

      H2ggD0=-101d0/3+14d0*nf/9d0+63d0/2*Z3

CH
      sigmatb=abisq(mtop**2/hmass**2,mbot**2/hmass**2)
      sigmat=abisqnnlo(mtop**2/hmass**2)
      if (approxim.ne.0) then
       resfac=sigmat
      elseif(approxim.eq.0) then
       resfac=1d0
      endif
CH

      
      return

      end
      
