      subroutine writeinfo(unitno,xsec,xsec_err)
************************************************************************
*   Routine to write out run information to a desired unit             *
************************************************************************
      implicit none
      include 'maxwt.f'
      include 'masses.f'
      include 'facscale.f'
      include 'scale.f'
      include 'zerowidth.f'
      include 'flags.f'
      include 'clustering.f'
      include 'gridinfo.f'
      include 'limits.f'
      include 'pdfiset.f'
      integer unitno
      include 'dynamicscale.f'
      double precision xsec,xsec_err
      
      character*4 part
      character*30 runstring,extension,total
      character*50 prefix
      logical creatent,dswhisto,makecuts
      integer nproc,ih1,ih2,itmx1,itmx2,ncall1,ncall2,rseed
      integer order,nset,approxim
      double precision sqrts
      double precision Rcut
      double precision leptpt,leptrap,misspt,Rjlmin,Rllmin,delyjjmin,
     . leptpt2,leptrap2,gammpt,gammrap,gammcone,gammcut
      integer lbjscheme
      logical jetsopphem
      double precision resummscale,resummscaleb,mtop,mbot
      common/resummscale/resummscale,resummscaleb
      double precision smur,smuf
      common/scalefactors/smur,smuf

      double precision qtminvirt,qtminreal,qtmax1,qtmax2,qtsw
      common/qtcut/qtminvirt,qtminreal,qtmax1,qtmax2,qtsw
      common/tbmass/mtop,mbot
      common/flag/approxim
 
      common/outputflags/creatent,dswhisto

      common/nnlo/order
      common/part/part
      common/runstring/runstring
      common/energy/sqrts
      common/density/ih1,ih2
      common/iterat/itmx1,ncall1,itmx2,ncall2
      common/prefix/nset,prefix
    
      
      common/Rcut/Rcut
      common/makecuts/makecuts
      common/leptcuts/leptpt,leptrap,misspt,Rjlmin,Rllmin,delyjjmin,
     . leptpt2,leptrap2,gammpt,gammrap,gammcone,gammcut,
     . lbjscheme,jetsopphem

      common/rseed/rseed
      extension='.top'
      call strcat(runstring,extension,total)

      write(unitno,*) '( ./td -b ',total! ,'.top'<<otherwise>> 'td < test.top'
      write(unitno,*) 'set device postscript sideways'
      write(unitno,*) '( Cross-section is: ',xsec,'+/-',xsec_err,')'
      write(unitno,*)
      write(unitno,*) '( Run corresponds to this input file)'
      write(unitno,*)
      write(unitno,*) '(sqrts=     ',sqrts
      write(unitno,*) '(ih1= ',ih1,',  ih2= ',ih2
      write(unitno,*) '(Mh:        ',hmass
      write(unitno,*) '(Q1=         ',resummscale
      write(unitno,*) '(Q2=         ',resummscaleb
      write(unitno,*) '(factorization scale factor=',smuf
      write(unitno,*) '(renormalization scale factor=',smur
      write(unitno,*) '(qt switch from ',qtmax1,' to ',qtmax2
      write(unitno,*) '(dynamicscale=     ',dynamicscale
      write(unitno,*) '(order=     ',order
      write(unitno,*) '(part=      ',part
      write(unitno,*) '(itmx1=     ',itmx1
      write(unitno,*) '(ncall1=    ',ncall1
      write(unitno,*) '(itmx2=     ',itmx2
      write(unitno,*) '(ncall2=    ',ncall2
      write(unitno,*) '(rnd seed=  ',rseed
      write(unitno,*) '(iset=      ',iset
      write(unitno,*) '(nset=      ',nset
      write(unitno,*) '(approxim=      ',approxim
      write(unitno,*) '(mtop=      ',mtop
      write(unitno,*) '(mbot=      ',mbot
      write(unitno,*) '(runstring= ',runstring
      write(unitno,*)

      return
      
      end
      
      
