c Written by Daniel de Florian. Last update 7/07/2010
C Modified by Damiano Tommasini in 2011

C COMPUTES THE QT RESUMMATION AND NLO EXPANSION INCLUDING RAPIDITY
C  USES DOUBLE MELLIN INVERSION 
C Gives dsigma^(res)/dqt/dy

       subroutine resumm(resummed,subtraction,qhiggs,y,qtt,iscale)
       IMPLICIT DOUBLE PRECISION (A-I,L-Z)
       INTEGER N, IINIP,  NVP, ISET, NAORD, NNF, inf, ih,flag1,IER
       double precision ALPHASNEW
       integer isetproton,icoll,ih1,ih2,inorm,approxim,iscale
       integer cc, iord, flagrealcomplex,imod,mord,kk,flaginitres

CH
       double precision c1ggdeltaf,c1ggdeltaft
CH
C Parameters for Bessel quadratures
       character name*25
       integer lenaw
       parameter (lenaw = 8000)
       parameter (tiny = 1.0d-307)
       dimension aw(0 : lenaw - 1)
       COMMON/QUADRATURES/aw

       real *8 qhiggs,y,qtt,abisq,resummed,subtraction
       double precision abisqnnlo
       EXTERNAL abisq,abisqnnlo
       COMMON/isetproton/isetproton
       COMMON/collider/ih1,ih2
       COMMON / SCALES / Q2i, Q2MUR, Q2MUF
       COMMON / COUPL  / ALPQF, ALPQR, ALPQFB
       COMMON / CONT   / C, CO, SI, AX
       COMMON / ETA / ETA
       COMMON/ETAlim/ETAmax,etamin
       COMMON / NAORD / NAORD
       COMMON/xlam/xlam
       COMMON / INTINIP / IINIP
       COMMON/NFLAVORS/nnF
       COMMON/order/iord
       COMMON/morder/mord
       COMMON/aass/aass
       COMMON/flagrealcomplex/flagrealcomplex
       COMMON/modified/imod
       COMMON/flag1/flag1
       COMMON/a_param/a_param,a_paramb,b0p,b0pb
       COMMON/binteg/phi2,min,max
       COMMON/sigma0/sigma0

      INTEGER ihc1,ihc2,forder
      real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      double precision resummscale,resummscaleb,sigmatb,sigmat
      common/resummscale/resummscale,resummscaleb
      include 'nlooprun.f'
!      include 'const.h'
         integer nf
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn
     #         Gamma2g,dg2,C1ggnex,C1ggntb,C1ggnt,
     #                            C1ggextb,C1ggext
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #    A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex,
     #                                    C1ggntb,C1ggnt
       common/C1coeff/C1ggextb,C1ggext
       common/data/pi,II
      include 'masses.f'

      common/pdfiset/iset
      common/prefix/nset,prefix
      common/nnlo/forder
      common/energy/ssroot
      common/density/ihc1,ihc2
      common/flaginitres/flaginitres
      common/xm/xmb,xmt
      common/inorm/inorm
      common/flag/approxim
      common/Born/sigmatb,sigmat
      common/xborn/xnormt,xnormtb

      real *8 smur,smuf
      common/scalefactors/smur,smuf      


       data gevpb/3.8937966d8/
       flagrealcomplex=1

C      Set static renormalization and factorization scale

       mur=smur*hmass
       muf=smuf*hmass

C Initialization for Gauss inversion 
       call INITO 

C READ input variables
       q=qhiggs      ! Higgs mass


       if (flaginitres.eq.0)  then
         flag1=forder ! order of calculation: NLL+LO (1) NNLL+NLO (2)

c      PDF Choice
         isetproton=iset
! Number of loops, default: given by the PDFs set
!         nnnloop=nlooprun   !flag1+1
!         call lambda5qcd(xlam,isetproton)
       write(*,*)'xlam=',xlam,'nloop',nlooprun


c   Choose pp or ppbar collider
         ih1=ihc1
         ih2=ihc2
       endif

c      CM energy
         SQS=ssroot


      imod=1
      IINIP = 0
      pi=dacos(-1d0)
      nf=5
      nnf=nf
      CA=3d0
      Cf=4/3d0
      TR=1/2d0
      Euler=0.57721566d0
      Z2=1.644934d0
      Z3=1.202057d0
      b0=2*dexp(-Euler)
      if (iscale.eq.0) then
       b0p=b0*a_param
      else
       b0p=b0*a_paramb
      endif
CH      b0pb=b0*a_paramb
      beta0=(33-2*nf)/12d0
      beta1=(153-19*nf)/24d0
      beta2=2857/128d0-5033*nf/1152d0+325*nf**2/3456d0
c......gluon coefficients
      A1g=CA
      A2g=CA/2d0*(67/6d0-(pi**2)/2d0-5d0/9*nf)
      A3g=CA*(13.81-2.15*nf-nf**2/108d0)
      Gamma2g = 4d0*CA*(CA**2 *(245d0/6d0 - 134d0*pi**2/27d0
     . + 11d0*Pi**4 /45d0 + 22d0*Z3/3d0) + CA*TR*nf*(-418d0/27d0
     . + 40d0*Pi**2/27d0 - 56d0*Z3/3d0) + CF*TR*nf*(-55d0/3d0 + 16d0
     . * Z3) - 16d0/27d0 * TR**2 * nf**2)

      dg2 = CA*(CA*(808d0/27d0 - 28d0*Z3) - 224d0/27d0*TR*nf)

      A3g = Gamma2g + 2d0 *(4d0*Beta0) * dg2
      A3g = A3g/64d0
!      write(*,*)A3g

      B1g=-(11*CA-2*nf)/6d0
c flag4=1 !
         B2g=CA**2*(23/24d0+(11*pi**2)/18d0-3*Z3/2d0)+
     /        Cf*nf/2d0-CA*nf*(1/12d0+pi**2/9d0)-11/8d0*Cf*CA 
         C1ggn=(pi**2/2d0+11/2d0+pi**2)/2d0
         if(approxim.eq.0)then
          C1ggnex=(pi**2/2d0+11/2d0+pi**2)/2d0
         elseif(approxim.eq.1)then
          C1ggnex=c1ggdeltaf(0,qhiggs,xmt,xmb)
         elseif(approxim.eq.2 .and. iscale.eq.0)then
          C1ggnex=C1ggext
         elseif(approxim.eq.2 .and. iscale.eq.1)then
          C1ggntb=C1ggextb
          C1ggnt=C1ggext
         endif
      
C

c.....Here you choose normalization:
!      inorm=0   ! mt=infinity
!      inorm=1   ! mt=exact

      gf=1.16637d-5
      arg1=(xmt/q)**2
      arg2=(xmb/q)**2
      
      if(approxim.eq.0)then
       factor=gf/288d0/pi/dsqrt(2d0)
      elseif(approxim.eq.1)then
       factor=gf/288d0/pi/dsqrt(2d0)*sigmat
      elseif(approxim.eq.2 .and. iscale.eq.0)then
       factor=gf/288d0/pi/dsqrt(2d0)*sigmat
      elseif(approxim.eq.2 .and. iscale.eq.1)then
       factortb=gf/288d0/pi/dsqrt(2d0)*sigmatb
       factort=gf/288d0/pi/dsqrt(2d0)*sigmat
      endif
      
      


      if(flag1.eq.1) then
       mord=1 ! Matching at LO
       iord=0 ! LO evolution
       naord=1
      elseif(flag1.eq.2) then
       mord=2 ! Matching at NLO
       iord=1 ! NLO evolution
       naord=2
      endif

       q2=q**2
       q2i=q2
C squared of resummation scale (used for the evolution) 
      if (iscale.eq.0) then
       q2s=q2/a_param**2
      else
       q2s=q2/a_paramb**2
      endif      

       X=Q2/SQS**2
       sroot=sqs 
       shad=sroot**2
C...PARAMETERS OF THE INTEGRATION CONTOUR IN THE COMPLEX N PLANE :
       AX=DLOG(X)
C      Kinematical limit
       etam=-0.5*dlog(x)
C Scales           
       mur2=mur**2
       muf2=muf**2
c
       q2mur=mur2
       q2muf=muf2

C...COUPLING CONSTANTS AT INPUT SCALE = ALPHAS/4/PI
C   ALPQF = ALPHA AT RESUMMATION SCALE (used to start evolution,
C                                        rest at fixed order)
C   ALPQR = ALPHA AT RENORMALIZATION SCALE
       ALPQF=ALPHASNEW(Q2s)
       ALPQR=ALPHASNEW(Q2mur)       
C aass = ALPHAS/PI
       aass = ALPQR*4d0


       if (flaginitres.eq.0)  then  
C Call fitting routine
       CALL fiteador(x,muf2,etam)
C      CALL initialization subroutine for PDFS and Anomalous dimensions
       CALL INITOFIT

C define points for quadratures integration
       call intdeoini(lenaw, tiny, 1.0d-5, aw)

       flaginitres=1

       endif          ! flaginitres

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC       
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC       
C
C introduce qt and eta from here   
C START Phase Space generation from here!!!!
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC       
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Notice that "Higgs Mass" will also change when producing the Phase Space
C


       qt=qtt
       eta=y
       qt2=qt**2


       if((eta.gt.etam).or.(eta.lt.-etam)) then
        write(*,*) "warning y lim => res=0d0"
        stop
       endif



C Evaluate kinematics and logs       
       call evaluatekin(eta,qt,q2)

C Normalization
c.....mtop->infinity limit: CHANGE BORN result
C Introduce flag to separate decay channels
c.....Please note here you need as, not as/pi or as/4pi!!!!!!
      if(iscale.eq.0)then
       sigma0=factor*gevpb*(alpqr*4d0*pi)**2
       xnorm=sigma0*x*qt/2d0
      elseif(iscale.eq.1)then
       sigma0tb=factortb*gevpb*(alpqr*4d0*pi)**2
       sigma0t=factort*gevpb*(alpqr*4d0*pi)**2
       xnormtb=sigma0tb*x*qt/2d0
       xnormt=sigma0t*x*qt/2d0
      endif


C xsection provides the born xsection computed using exact pdfs
       xborn=xsection(ax,eta,muf,isetproton,ih1,ih2)
C xsection2 provides the born xsection computed using approx. pdfs
       xborn2=xsection2(ax,eta,muf,isetproton,ih1,ih2)
C Normalize PDF's to born
       xnormal=xborn/xborn2
C Avoid problems at extreme kinematics (and eventual divisions by 0!)     
       if ((xnormal.gt.1.15).or.(xnormal.lt.0.85)) xnormal=1d0



C COMPUTE SUBTRACTION TERM
! Can activate 'inv' function, updated the merging with montecarlo
!      call inv(subs,eta)
!      subtraction=subs*xnorm  *1d3          !!We want cross section in fb as in hnnlo
      subtraction=1d0

C COMPUTE RESUMMED CONTRIBUTION (b integral)
      if(iscale.eq.0)then
       call resummation(resu,iscale)
       resummed=resu*xnorm*xnormal *1d3      !!We want cross section in fb as in hnnlo
      elseif(iscale.eq.1)then
       call resummation(resutb,iscale)
CH       call resummation(resut,2)
       resummed=resutb*xnormal *1d3      !!We want cross section in fb as in hnnlo
      endif

C FIXED ORDER calculation, commented to improve speed
! Cannot activate 'higgsqty' function, not updated the merging with hnnlo
!       call higgsqty(ris,eta,eta,naord)

!       write(6,130)qt,eta,resummed,subtraction,ris,
!     .    resummed-subtraction+ris
      
       close(11)

      return
       END
C


       Subroutine resummation(resu,iscale)
       IMPLICIT DOUBLE PRECISION (A - Z)
       integer lenaw,iscale
       parameter (lenaw = 8000)
       dimension aw(0 : lenaw - 1)
       external INVRES,INVRESB,INVREST
       COMMON/transverse/qt
       COMMON/QUADRATURES/aw

C We use INTDEO to improve the computational speed
C Sometimes it fails, when happen we try to integrate with different routines

C Compute integral using quadratures for Oscillating functions
C as described in intde2.f
       if(iscale.eq.0)then
       call INTDEO(invres, 0.0d0, qt, aw, resu, errt)

       if(resu.ne.resu) then ! If INTDEO fails, we try with ADZINT
!         write(*,*)'intdep fails, qt=',qt
C COMPUTE RESUMMED CONTRIBUTION (b integral)
         AERR=0D-1
c relative error 2D-5 seems to be OK, if you use 5D-5 the program is 30% faster
         RERR=5D-5
C Min and Max values for b-integration
         min=1d-5
         max=3d0

         RESU= ADZINT(INVRES, MIN, MAX, AERR, RERR, ERREST, IER, 0, 0)

         if(resu.ne.resu) then ! If also ADZINT fails, we try with ADPINT

!      	    write(*,*)'adzint fails, qt=',qt
            RESU=ADPINT(INVRES, MIN, MAX, AERR, RERR, ERREST, IER)

!            if(resu.ne.resu) then
!              write(*,*)'WARNING RESUMMATION! qt=',qt
!              resu=0d0
!            endif

         endif

       endif
       elseif(iscale.eq.1)then
       call INTDEO(invresb, 0.0d0, qt, aw, resu, errt)

       if(resu.ne.resu) then ! If INTDEO fails, we try with ADZINT
!         write(*,*)'intdep fails, qt=',qt
C COMPUTE RESUMMED CONTRIBUTION (b integral)
         AERR=0D-1
c relative error 2D-5 seems to be OK, if you use 5D-5 the program is 30% faster
         RERR=5D-5
C Min and Max values for b-integration
         min=1d-5
         max=3d0

         RESU= ADZINT(INVRESB, MIN, MAX, AERR, RERR, ERREST, IER, 0, 0)

         if(resu.ne.resu) then ! If also ADZINT fails, we try with ADPINT

!      	    write(*,*)'adzint fails, qt=',qt
            RESU=ADPINT(INVRESB, MIN, MAX, AERR, RERR, ERREST, IER)

!            if(resu.ne.resu) then
!              write(*,*)'WARNING RESUMMATION! qt=',qt
!              resu=0d0
!            endif

         endif

       endif 
       endif

       return
       end


      

       SUBROUTINE INV (res,eta)    
       IMPLICIT DOUBLE PRECISION (A - Z)
       DOUBLE PRECISION  WN(136),WZ(8),Zs(8),DOWN(17),UP(17)
       COMPLEX*16 CCp,CCm, Np(136),Nm(136)
       COMPLEX*16 XNM1,XNM2,XN1,XN2,CEX1,CEX2,HCRN,INT1,INT2
       INTEGER NMAX, I1, I2, NMAX1, NMAX2
       COMMON / WEIGHTS2 / WN
       COMMON / MOMS2    / Np,Nm,CCp,CCm
       COMMON / CONT   / C, CO, SI, AX
                   
          NMAX=70         
          RES = 0D0
          FUN = 0.D0
c  AX=Log[z1*z2]
C eta=1/2 (log[z1]-Log[z2])
       AX1 = (AX+2*ETA)/2d0 
       AX2 = (AX-2*ETA)/2d0 
        xx1=dExp(ax1)
        xx2=dExp(ax2)
       xnormal=1d0
c to avoid issues at x>0.87d0 (very large rapidities) suppress the result       
        if (xx1.gt.0.87d0) xnormal=(1-xx1)**3/(1-0.87d0)**3
        if (xx2.gt.0.87d0) xnormal=(1-xx2)**3/(1-0.87d0)**3



        IF ( xX1 .LE. 0.001 ) THEN                          
          NMAX1 = 40                 ! zmax = 2 
       ELSE IF ( xX1 .LE. 0.05 ) THEN                   
          NMAX1 = 40                 ! zmax = 4  
       ELSE IF ( Xx1 .LE. 0.2 ) THEN                   
          NMAX1 = 56                 ! zmax = 8  
       ELSE IF ( xX1 .LE. 0.4 ) THEN                   
          NMAX1 = 72                 ! zmax = 12 
       ELSE IF ( xX1 .LE. 0.7 ) THEN                   
          NMAX1 = 88                 ! zmax = 18 
       ELSE                                                          
          NMAX1 = 136                ! zmax = 36
       END IF                  
 
        IF ( xX2 .LE. 0.001 ) THEN                          
          NMAX2 = 40                 ! zmax = 2 
       ELSE IF ( xX2 .LE. 0.05 ) THEN                   
          NMAX2 = 40                 ! zmax = 4  
       ELSE IF ( xX2 .LE. 0.2 ) THEN                   
          NMAX2 = 56                 ! zmax = 8  
       ELSE IF ( xX2 .LE. 0.4 ) THEN                   
          NMAX2 = 72                 ! zmax = 12 
       ELSE IF ( xX2 .LE. 0.7 ) THEN                   
          NMAX2 = 88                 ! zmax = 18 
       ELSE                                                          
          NMAX2 = 136                ! zmax = 36
       END IF                 
       
C          NMAX1 = 136                ! zmax = 36
C          NMAX2 = 136                ! zmax = 36
       
       DO 100 I1 = 1, NMAX1
          DO 10 I2 = 1, NMAX2
C COMPUTE POSITIVE BRANCH
       XN1  = Np(I1)
       XNM1 = - XN1 * AX1
       CEX1 = EXP (XNM1) / 3.1415927 * CCp
       XN1 = XN1 + 1. 
       XN2  = Np(I2)
       XNM2 = - XN2 * AX2
       CEX2 = EXP (XNM2) / 3.1415927 * CCp

       CALL INTERSUSnew (HCRN, I1, I2, 1)
       INT1= (HCRN * CEX1 * CEX2) * WN(I1) * WN(I2)

C COMPUTE NEGATIVE BRANCH
       XN1  = Np(I1)
       XNM1 = - XN1 * AX1
       CEX1 = EXP (XNM1) / 3.1415927 * CCp
       XN1 = XN1 + 1.
       XN2  = Nm(I2)
       XNM2 = - XN2 * AX2
       CEX2 = EXP (XNM2) / 3.1415927 * CCm
C                
       CALL INTERSUSnew (HCRN, I1, I2, -1)
       INT2= (HCRN * CEX1 * CEX2)* WN(I1) * WN(I2)
C      
        FZ=-DBLE( 1./2*(DREAL(INT1-INT2))) 
C
        FUN= FUN + FZ 

  10     CONTINUE
  100     CONTINUE
         RES=  fun * xnormal
        RETURN                           
        END
        
        
       FUNCTION INVres (b)    
       IMPLICIT DOUBLE PRECISION (A - Z)
       INTEGER NMAX, I1, I2,nmax1,nmax2
       DOUBLE PRECISION  WN(136),WZ(8),Zs(8),DOWN(17),UP(17)
       COMPLEX*16 CCp,CCm, Np(136),Nm(136),scale2,sudak,S,factorfin
       COMPLEX*16 XNM1,XNM2,XN1,XN2,CEX1,CEX2,HCRN,INT1,INT2,bb
       COMMON / CONT   / C, CO, SI, AX
       COMMON / ETA / ETA
       COMMON / WEIGHTS2 / WN
       COMMON / MOMS2    / Np,Nm,CCp,CCm
       COMMON/a_param/a_param,a_paramb,b0p,b0pb
       COMMON/transverse/qt
       external S
       
       scale2=cmplx(b0p**2/b**2,0d0)
       bb=cmplx(b,0d0)
C USES BESSEL FUNCTION SINCE INTEGRATION IS DONE ALONG THE REAL AXIS
       xj0= 2*dbesj0((qt*b))
       sudak=S(bb,0)
       factorfin=bb*xj0*sudak

          NMAX=30         
          INVRES = 0D0
          FUN = 0.D0

c  AX=Log[z1*z2]
C eta=1/2 (log[z1]-Log[z2])
        AX1 = (AX+2*ETA)/2d0 
        AX2 = (AX-2*ETA)/2d0 
        xx1=dExp(ax1)
        xx2=dExp(ax2)
!        write(*,*)'ax ',Ax,ETA,xx1,xx2,factorfin
        IF ( xX1 .LE. 0.001 ) THEN                          
          NMAX1 = 40                 ! zmax = 2 
       ELSE IF ( xX1 .LE. 0.05 ) THEN                   
          NMAX1 = 40                 ! zmax = 4  
       ELSE IF ( Xx1 .LE. 0.2 ) THEN                   
          NMAX1 = 56                 ! zmax = 8  
       ELSE IF ( xX1 .LE. 0.4 ) THEN                   
          NMAX1 = 72                 ! zmax = 12 
       ELSE IF ( xX1 .LE. 0.7 ) THEN                   
          NMAX1 = 88                 ! zmax = 18 
       ELSE                                                          
          NMAX1 = 136                ! zmax = 36
       END IF                  
 
        IF ( xX2 .LE. 0.001 ) THEN                          
          NMAX2 = 40                 ! zmax = 2
       ELSE IF ( xX2 .LE. 0.05 ) THEN                   
          NMAX2 = 40                 ! zmax = 4  
       ELSE IF ( xX2 .LE. 0.2 ) THEN                   
          NMAX2 = 56                 ! zmax = 8  
       ELSE IF ( xX2 .LE. 0.4 ) THEN                   
          NMAX2 = 72                 ! zmax = 12 
       ELSE IF ( xX2 .LE. 0.7 ) THEN                   
          NMAX2 = 88                 ! zmax = 18 
       ELSE                                                          
          NMAX2 = 136                ! zmax = 36
       END IF                  

C          NMAX1 = 136                ! zmax = 36
C          NMAX2 = 136                ! zmax = 36

       DO 100 I1 = 1, NMAX1
          DO 10 I2 = 1, NMAX2

C COMPUTE POSITIVE BRANCH
       XN1  = Np(I1)
       XNM1 = - XN1 * AX1
       CEX1 = EXP (XNM1) / 3.1415927 * CCp
       XN1 = XN1 + 1. 
       XN2  = Np(I2)
       XNM2 = - XN2 * AX2
       CEX2 = EXP (XNM2) / 3.1415927 * CCp
       CALL INTERESnew (HCRN, I1, I2, 1 ,SCALE2,0)
       INT1= (HCRN * CEX1 * CEX2) * WN(I1) * WN(I2) * factorfin
C COMPUTE NEGATIVE BRANCH
       XN1  = Np(I1)
       XNM1 = - XN1 * AX1
       CEX1 = EXP (XNM1) / 3.1415927 * CCp
       XN1 = XN1 + 1.
       XN2  = Nm(I2)
       XNM2 = - XN2 * AX2
       CEX2 = EXP (XNM2) / 3.1415927 * CCm
       CALL INTERESnew (HCRN, I1, I2, -1, SCALE2,0)
       INT2= (HCRN * CEX1 * CEX2)* WN(I1) * WN(I2) * factorfin
C       
        FZ=-DBLE( 1./2*(DREAL(INT1-INT2))) 
        FZ=-DBLE( 1./2*(INT1-INT2)) 
        FUN= FUN + FZ 
  10     CONTINUE
  100     CONTINUE
         INVRES=  (fun )  
        RETURN
        END

       FUNCTION INVresb (b)    
       IMPLICIT DOUBLE PRECISION (A - Z)
       INTEGER NMAX, I1, I2,nmax1,nmax2
       DOUBLE PRECISION  WN(136),WZ(8),Zs(8),DOWN(17),UP(17)
       COMPLEX*16 CCp,CCm, Np(136),Nm(136),scale2,sudak,S,factorfin
       COMPLEX*16 XNM1,XNM2,XN1,XN2,CEX1,CEX2,HCRN,INT1,INT2,bb
       COMMON / CONT   / C, CO, SI, AX
       COMMON / ETA / ETA
       COMMON / WEIGHTS2 / WN
       COMMON / MOMS2    / Np,Nm,CCp,CCm
       COMMON/a_param/a_param,a_paramb,b0p,b0pb
       COMMON/transverse/qt
       external S
       
       scale2=cmplx(b0p**2/b**2,0d0)
       bb=cmplx(b,0d0)
C USES BESSEL FUNCTION SINCE INTEGRATION IS DONE ALONG THE REAL AXIS
       xj0= 2*dbesj0((qt*b))
       sudak=S(bb,1)
       factorfin=bb*xj0*sudak

          NMAX=30         
          INVRESB = 0D0
          FUN = 0.D0

c  AX=Log[z1*z2]
C eta=1/2 (log[z1]-Log[z2])
        AX1 = (AX+2*ETA)/2d0 
        AX2 = (AX-2*ETA)/2d0 
        xx1=dExp(ax1)
        xx2=dExp(ax2)
!        write(*,*)'ax ',Ax,ETA,xx1,xx2,factorfin
        IF ( xX1 .LE. 0.001 ) THEN                          
          NMAX1 = 40                 ! zmax = 2 
       ELSE IF ( xX1 .LE. 0.05 ) THEN                   
          NMAX1 = 40                 ! zmax = 4  
       ELSE IF ( Xx1 .LE. 0.2 ) THEN                   
          NMAX1 = 56                 ! zmax = 8  
       ELSE IF ( xX1 .LE. 0.4 ) THEN                   
          NMAX1 = 72                 ! zmax = 12 
       ELSE IF ( xX1 .LE. 0.7 ) THEN                   
          NMAX1 = 88                 ! zmax = 18 
       ELSE                                                          
          NMAX1 = 136                ! zmax = 36
       END IF                  
 
        IF ( xX2 .LE. 0.001 ) THEN                          
          NMAX2 = 40                 ! zmax = 2
       ELSE IF ( xX2 .LE. 0.05 ) THEN                   
          NMAX2 = 40                 ! zmax = 4  
       ELSE IF ( xX2 .LE. 0.2 ) THEN                   
          NMAX2 = 56                 ! zmax = 8  
       ELSE IF ( xX2 .LE. 0.4 ) THEN                   
          NMAX2 = 72                 ! zmax = 12 
       ELSE IF ( xX2 .LE. 0.7 ) THEN                   
          NMAX2 = 88                 ! zmax = 18 
       ELSE                                                          
          NMAX2 = 136                ! zmax = 36
       END IF                  

C          NMAX1 = 136                ! zmax = 36
C          NMAX2 = 136                ! zmax = 36

       DO 100 I1 = 1, NMAX1
          DO 10 I2 = 1, NMAX2

C COMPUTE POSITIVE BRANCH
       XN1  = Np(I1)
       XNM1 = - XN1 * AX1
       CEX1 = EXP (XNM1) / 3.1415927 * CCp
       XN1 = XN1 + 1. 
       XN2  = Np(I2)
       XNM2 = - XN2 * AX2
       CEX2 = EXP (XNM2) / 3.1415927 * CCp
       CALL INTERESnew (HCRN, I1, I2, 1 ,SCALE2,1)
       INT1= (HCRN * CEX1 * CEX2) * WN(I1) * WN(I2) * factorfin
C COMPUTE NEGATIVE BRANCH
       XN1  = Np(I1)
       XNM1 = - XN1 * AX1
       CEX1 = EXP (XNM1) / 3.1415927 * CCp
       XN1 = XN1 + 1.
       XN2  = Nm(I2)
       XNM2 = - XN2 * AX2
       CEX2 = EXP (XNM2) / 3.1415927 * CCm
       CALL INTERESnew (HCRN, I1, I2, -1, SCALE2,1)
       INT2= (HCRN * CEX1 * CEX2)* WN(I1) * WN(I2) * factorfin
C       
        FZ=-DBLE( 1./2*(DREAL(INT1-INT2))) 
        FZ=-DBLE( 1./2*(INT1-INT2)) 
        FUN= FUN + FZ 
  10     CONTINUE
  100     CONTINUE
         INVRESB=  (fun )  
        RETURN
        END

        
       SUBROUTINE INTERSUSnew (HCRN, I1,I2,isign)
       IMPLICIT DOUBLE COMPLEX (A - Z)
       DIMENSION FP1(9), fp2(9), FN(15)
       DOUBLE PRECISION aass
       COMPLEX*16 CCp,CCm, Np(136),Nm(136)
       INTEGER I,J,imod,order,mord,I1,I2,isign,IH1,IH2,iscale

       COMMON/aass/aass
       COMMON/morder/mord
       COMMON/COEFF/BETA0N,BETA1N,BETA2N,A1GN,A2GN,A3GN,B1GN,B2GN,H1G
 !      include 'const.h'
         integer nf
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #             A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn
     #                                       ,C1ggnex
       common/data/pi,II
!End sostit. const.h

       real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
       common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
       real *8 a_param,a_paramb,b0p,b0pb,xlog0,xlog1,xlog2,xlog3,
     .         xxlog0,xxlog1,xxlog2,xxlog3
       COMMON/a_param/a_param,a_paramb,b0p,b0pb
       COMMON/logs/xxlog0,xxlog1,xxlog2,xxlog3
       COMMON/modified/imod
       COMMON / MOMS2    / Np,Nm,CCp,CCm
       COMMON/collider/ih1,ih2
C

       if(isign.eq.1) THEN
       XN1=Np(I1)
       XN2=Np(I2)
       ELSE  
       XN1=Np(I1)
       XN2=Nm(I2)
       endif
*  U   UB   D   DB   S   C    B    G 
*  1    2   3   4    5   6    7    8 
       CALL RENOSUS (FP1, XN1, I1, 1, 1,
     .  gamma1qq_1, gamma1qg_1, gamma1gq_1, gamma1gg_1, 
     .  gamma2qq_1, gamma2qg_1, gamma2gq_1, gamma2gg_1,
     .  C1QQ_1,C1QG_1,C1GQ_1,C1GG_1)
       CALL RENOSUS (FP2, XN2, I2, ISIGN, 2,
     .  gamma1qq_2, gamma1qg_2, gamma1gq_2, gamma1gg_2, 
     .  gamma2qq_2, gamma2qg_2, gamma2gq_2, gamma2gg_2,
     .  C1QQ_2,C1QG_2,C1GQ_2,C1GG_2)

        if (ih1.eq.-1) then
            UTEMP=FP1(1)
            DTEMP=FP1(3)
            FP1(1)=FP1(2)
            FP1(2)=UTEMP
            FP1(3)=FP1(4)
            FP1(4)=DTEMP
         ENDIF
         
        if (ih2.eq.-1) then
            UTEMP=FP2(1)
            DTEMP=FP2(3)
            FP2(1)=FP2(2) 
            FP2(2)=UTEMP
            FP2(3)=FP2(4) 
            FP2(4)=DTEMP
         ENDIF                  
                  
       GGN = FP1(8)*FP2(8) 
       QGN =(FP1(1)+FP1(2)+FP1(3)+FP1(4)+2*FP1(5)+2*FP1(6)+2*FP1(7))
     .           *FP2(8)
       GQN =(FP2(1)+FP2(2)+FP2(3)+FP2(4)+2*FP2(5)+2*FP2(6)+2*FP2(7))
     .           *FP1(8) 
       QQBNi = FP1(1)*FP2(2) + FP1(3)*FP2(4) + 2* FP1(5)*FP2(5) + 
     .  2*FP1(6)*FP2(6) + 2*FP1(7)*FP2(7)+ FP2(1)*FP1(2)+ FP2(3)*FP1(4)
       QQNi = FP1(1)*FP2(1) + FP1(2)*FP2(2)+FP2(3)*FP1(3)+ FP2(4)*FP1(4)
     .     + 2*FP1(5)*FP2(5) + 2*FP1(6)*FP2(6) + 2*FP1(7)*FP2(7)
       QQPN1 =  FP1(1)*(FP2(3)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(3)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
     .         + FP1(2)*(FP2(4)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(4)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
      QQPN2 =  FP2(1)*(FP1(3)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(3)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
     .         + FP2(2)*(FP1(4)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(4)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
       QQPBN1 =  FP1(2)*(FP2(3)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(4)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
     .         +FP1(1)*(FP2(4)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(3)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
       QQPBN2 = FP2(2)*(FP1(3)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(4)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
     .         + FP2(1)*(FP1(4)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(3)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
       QQN =QQBNi + QQNi + QQPN1  + QQPN2 +  QQPBN1 + QQPBN2 

c.....NOW a DEPENDENCE: JUST REDEFINITION OF LOGS HERE ! 

      if (imod.eq.1) then
       xla = log(a_param)
       xlog3 = xxlog3 + 6*xla*xxlog2 + 12*xla**2*xxlog1+8*xla**3*xxlog0
       xlog2 = xxlog2 + 4*xla*xxlog1 + 4*xla**2*xxlog0
       xlog1 = xxlog1 + 2*xla*xxlog0
       xlog0 = xxlog0
      else
       xlog3 = xxlog3
       xlog2 = xxlog2
       xlog1 = xxlog1
       xlog0 = xxlog0
      endif

c LO
      SIGMA1gg=A1gN*xlog1+ (B1gN+gamma1gg_1+gamma1gg_2)*xlog0
      SIGMA1qg=(gamma1gq_1)*xlog0
      SIGMA1gq=(gamma1gq_2)*xlog0
      SIGMA1qq=0d0

c NLO      
      SIGMA2qq=-2*(gamma1gq_1 * gamma1gq_2 )* xlog1 +
     /       ((gamma1gq_1*C1GQ_2 + gamma1gq_2*C1GQ_1  
     /      - 2*(gamma1gq_1 * gamma1gq_2 )*DLOG(muf2/q2)))*xlog0

       SIGMA2qg=-3./2*A1gN*gamma1gq_1*xlog2 +
     /    ((beta0N-2*B1gN-A1gN*DLOG(muf2/q2))*gamma1gq_1+ A1gN*C1GQ_1
     /    -2*gamma1gq_1*gamma1gg_2-gamma1gq_1*gamma1qq_1
     /    -gamma1gg_1*gamma1gq_1)* xlog1 +
     /  (gamma2gq_1 + (3*beta0N*DLOG(mur2/q2)-B1gN*DLOG(muf2/q2))
     /     *gamma1gq_1
     /   +(B1gN-beta0N)*C1GQ_1+
     /   (-2*gamma1gq_1*gamma1gg_2-gamma1gq_1*gamma1qq_1
     /    -gamma1gg_1*gamma1gq_1)*DLOG(muf2/q2)+ H1g*gamma1gq_1
     /  +gamma1qq_1*C1GQ_1 + gamma1gq_1*C1gg_1 + gamma1gg_2*C1GQ_1 +
     /    gamma1gq_1*C1GG_2 )*xlog0

      SIGMA2gq=-3./2*A1gN*gamma1gq_2*xlog2 +
     /    ((beta0N-2*B1gN-A1gN*DLOG(muf2/q2))*gamma1gq_2+ A1gN*C1GQ_2
     /    -2*gamma1gq_2*gamma1gg_1-gamma1gq_2*gamma1qq_2
     /    -gamma1gg_2*gamma1gq_2)* xlog1 +
     /  (gamma2gq_2 + (3*beta0N*DLOG(mur2/q2)-B1gN*DLOG(muf2/q2))
     /     *gamma1gq_2
     /   +(B1gN-beta0N)*C1GQ_2+
     /   (-2*gamma1gq_2*gamma1gg_1-gamma1gq_2*gamma1qq_2
     /    -gamma1gg_2*gamma1gq_2)*DLOG(muf2/q2)+ H1g*gamma1gq_2
     /  +gamma1qq_2*C1GQ_2 + gamma1gq_2*C1gg_2 + gamma1gg_1*C1GQ_2 +
     /    gamma1gq_2*C1GG_1 )*xlog0

      SIGMA2gg=(-1/2d0*A1gN**2)*xlog3 +
     /       (A1gN*(beta0N-3/2d0*B1gN)-3/2d0*A1gN*
     /       (gamma1gg_1+gamma1gg_2))*xlog2 +
     /  (A1gN*(C1GG_1+C1GG_2)-A1gN*DLOG(muf2/q2)*(gamma1gg_1+gamma1gg_2)
     /   -2*B1gN*(gamma1gg_1+gamma1gg_2)
     /  +A2gN+beta0N*B1gN-B1gN**2+3*beta0N*A1gN*DLOG(mur2/q2)+
     /   beta0N*(gamma1gg_1+gamma1gg_2)-2*nf*gamma1gq_1*gamma1qg_1
     /   -2*nf*gamma1gq_2*gamma1qg_2-2*gamma1gg_1*gamma1gg_2
     /   -gamma1gg_1**2 - gamma1gg_2**2)* xlog1 
     /   +(C1gg_1*gamma1gg_2 + C1gg_2*gamma1gg_1 + 
     /    B1gN*(C1gg_1+C1gg_2- (gamma1gg_1+gamma1gg_2)*DLOG(muf2/q2))
     /    +3*beta0N*DLOG(mur2/q2)*(gamma1gg_1+gamma1gg_2) 
     /   -2*gamma1gg_1*gamma1gg_2 *DLOG(muf2/q2)
     /   -beta0N*(C1GG_1+C1GG_2)+
     /   (C1GG_1*gamma1gg_1+2*nf*C1Gq_1*gamma1qg_1 +
     /    C1GG_2*gamma1gg_2+2*nf*C1Gq_2*gamma1qg_2)  
     /   -DLOG(muf2/q2)*(gamma1gg_1*gamma1gg_1+
     /    2*nf*gamma1gq_1*gamma1qg_1+ gamma1gg_2*gamma1gg_2+
     /    2*nf*gamma1gq_2*gamma1qg_2)
     /    +B2gN+gamma2gg_1+gamma2gg_2+2*Z3*A1gN**2
     /    +3*beta0N*B1gN*DLOG(mur2/q2))*xlog0
     /    +   H1g*(A1gN*xlog1+(B1gN+gamma1gg_1+gamma1gg_2)*xlog0)


       SIGMA1=(GGN*SIGMA1gg + QGN*SIGMA1qg + GQN*SIGMA1gq )
       SIGMA2=(GGN*SIGMA2gg + QGN*SIGMA2qg + GQN*SIGMA2gq +QQN*SIGMA2QQ)
C
       SIGMA = aass/2 * SIGMA1 
C
       if(mord.eq.2) then
       SIGMA=SIGMA + aass**2/4 * SIGMA2
       endif 
C       
       hcrn=SIGMA
       RETURN
       END


       SUBROUTINE INTERESnew (HCRN, I1,I2, isign,SCALE2,iscale)
       IMPLICIT DOUBLE COMPLEX (A - Z)
       DIMENSION FP1(9), fp2(9), FN(15)
       DOUBLE PRECISION  ALPQF, ALPQR
       DOUBLE PRECISION aass         !,amt
       COMPLEX*16 CCp,CCm, Np(136),Nm(136)
       INTEGER I,J,flag1,I1,I2,isign,ih1,ih2
       COMMON/aass/aass
       COMMON / COUPL  / ALPQF, ALPQR
       COMMON/COEFF/BETA0N,BETA1N,BETA2N,A1GN,A2GN,A3GN,B1GN,B2GN,H1G
 !      COMMON/amt/amt
 !      include 'const.h'
         integer nf,approxim,iscale
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex,
     #                                         C1ggntb,C1ggnt 
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                               C1ggnex,C1ggntb,C1ggnt
       common/data/pi,II
!fine sostituz const.h

       real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
       common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
       real *8 a_param,a_paramb,b0p,b0pb,xlog0,xlog1,xlog2,xlog3,
     .         xxlog0,xxlog1,xxlog2,xxlog3,pcf,loga
       COMMON/a_param/a_param,a_paramb,b0p,b0pb
       COMMON/logs/xxlog0,xxlog1,xxlog2,xxlog3
       COMMON/flag1/flag1
       COMMON / MOMS2    / Np,Nm,CCp,CCm
       COMMON/collider/ih1,ih2
       COMMON/exponent/aexp,aexpB
       common/flag/approxim
       common/xborn/xnormt,xnormtb
       double precision xnormt,xnormtb
C

       if(isign.eq.1) THEN
       XN1=Np(I1)
       XN2=Np(I2)
       ELSE  
       XN1=Np(I1)
       XN2=Nm(I2)
       endif

*  U   UB   D   DB   S   C    B    G 
*  1    2   3   4    5   6    7    8
       CALL RENO2 (FP1, XN1, I1,1, 1, ALPQF, SCALE2, ALPQ,
     .  gamma1qq_1, gamma1qg_1, gamma1gq_1, gamma1gg_1, 
     .  gamma2qq_1, gamma2qg_1, gamma2gq_1, gamma2gg_1,
     .  C1QQ_1,C1QG_1,C1GQ_1,C1GG_1,C1GG_1EX,C1GG_1EXT,C1GG_1EXTB,
     .  H2QQ_1,H2QG_1,H2GQ_1,H2GG_1,G1N_1,iscale)

       CALL RENO2 (FP2, XN2, I2, ISIGN, 2, ALPQF, SCALE2, ALPQ,
     .  gamma1qq_2, gamma1qg_2, gamma1gq_2, gamma1gg_2, 
     .  gamma2qq_2, gamma2qg_2, gamma2gq_2, gamma2gg_2,
     .  C1QQ_2,C1QG_2,C1GQ_2,C1GG_2,C1GG_2EX,C1GG_2EXT,C1GG_2EXTB,
     .  H2QQ_2,H2QG_2,H2GQ_2,H2GG_2,G1N_2,iscale)
C
        if (ih1.eq.-1) then
            UTEMP=FP1(1)
            DTEMP=FP1(3)
            FP1(1)=FP1(2)
            FP1(2)=UTEMP
            FP1(3)=FP1(4)
            FP1(4)=DTEMP
         ENDIF
         
        if (ih2.eq.-1) then
            UTEMP=FP2(1)
            DTEMP=FP2(3)
            FP2(1)=FP2(2)
            FP2(2)=UTEMP
            FP2(3)=FP2(4)
            FP2(4)=DTEMP
         ENDIF                 

       GGN = FP1(8)*FP2(8)
       QGN =(FP1(1)+FP1(2)+FP1(3)+FP1(4)+2*FP1(5)+2*FP1(6)+2*FP1(7))
     .           *FP2(8)
       GQN =(FP2(1)+FP2(2)+FP2(3)+FP2(4)+2*FP2(5)+2*FP2(6)+2*FP2(7))
     .           *FP1(8) 
       QQBNi = FP1(1)*FP2(2) + FP1(3)*FP2(4) + 2* FP1(5)*FP2(5) + 
     .  2*FP1(6)*FP2(6) + 2*FP1(7)*FP2(7)+ FP2(1)*FP1(2)+ FP2(3)*FP1(4)
       QQNi = FP1(1)*FP2(1) + FP1(2)*FP2(2)+FP2(3)*FP1(3)+ FP2(4)*FP1(4)
     .     + 2*FP1(5)*FP2(5) + 2*FP1(6)*FP2(6) + 2*FP1(7)*FP2(7)
       QQPN1 =  FP1(1)*(FP2(3)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(3)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
     .         + FP1(2)*(FP2(4)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(4)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
      QQPN2 =  FP2(1)*(FP1(3)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(3)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
     .         + FP2(2)*(FP1(4)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(4)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
       QQPBN1 =  FP1(2)*(FP2(3)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(4)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
     .         +FP1(1)*(FP2(4)+FP2(5)+FP2(6)+FP2(7))+
     .           FP1(3)*(FP2(5)+FP2(6)+FP2(7))+
     .            FP1(5)*(FP2(6)+FP2(7)) +  FP1(6)*FP2(7)
       QQPBN2 = FP2(2)*(FP1(3)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(4)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
     .         + FP2(1)*(FP1(4)+FP1(5)+FP1(6)+FP1(7))+
     .           FP2(3)*(FP1(5)+FP1(6)+FP1(7))+
     .            FP2(5)*(FP1(6)+FP1(7)) +  FP2(6)*FP1(7)
       QQN =QQBNi + QQNi + QQPN1  + QQPN2 +  QQPBN1 + QQPBN2 



       CGQ_1=alpq*2d0*C1gq_1
       CGQ_2=alpq*2d0*C1gq_2
       if(iscale.eq.0)then
        loga=log(a_param)
       else
        loga=log(a_paramb)
       endif
       pcf=2d0

 
c begin NLL

       if(flag1.eq.1 .and. iscale.eq.0) then 
            
       H1st=H1g+C1gg_1ex+C1gg_2ex
       Hgg=1d0+aass/2d0*(H1st+4d0*beta0*dlog(mur2/q2))
     .   -aass/2d0*(gamma1gg_1+gamma1gg_2)*(dlog(muf2/q2)+2d0*loga)
     .   +aass/2d0*(-4d0*loga)*(B1g+A1g*loga)

       Hgq_1 = Cgq_1 +(aass/2d0)*(-gamma1gq_1)*(dlog(muf2/q2)+2d0*loga)
       Hgq_2 = Cgq_2 +(aass/2d0)*(-gamma1gq_2)*(dlog(muf2/q2)+2d0*loga)
       Hqq=0d0
       
       endif
     

       if(iscale.ne.0) then 
            
       H1stt=H1g+C1gg_1ext+C1gg_2ext
       Hggt=1d0+aass/2d0*(H1stt+4d0*beta0*dlog(mur2/q2))
     .   -aass/2d0*(gamma1gg_1+gamma1gg_2)*(dlog(muf2/q2)+2d0*loga)
     .   +aass/2d0*(-4d0*loga)*(B1g+A1g*loga)

       H1sttb=H1g+C1gg_1extb+C1gg_2extb
       Hggtb=1d0+aass/2d0*(H1sttb+4d0*beta0*dlog(mur2/q2))
     .   -aass/2d0*(gamma1gg_1+gamma1gg_2)*(dlog(muf2/q2)+2d0*loga)
     .   +aass/2d0*(-4d0*loga)*(B1g+A1g*loga)

       Hgq_1 = Cgq_1 +(aass/2d0)*(-gamma1gq_1)*(dlog(muf2/q2)+2d0*loga)
       Hgq_2 = Cgq_2 +(aass/2d0)*(-gamma1gq_2)*(dlog(muf2/q2)+2d0*loga)
       Hqq=0d0
      
       endif
c     END NLL

C
C Atencion   gq_1 means QG initial state
C            gq_2 means GQ initial state
C
       if(flag1.eq.2 .and. iscale.eq.0) then

       H1stgg=(H1g+C1gg_1ex+C1gg_2ex+4*beta0*dlog(mur2/q2))
     .   -(gamma1gg_1+gamma1gg_2)*(dlog(muf2/q2)+2*loga)
     .   +(-4*loga)*(B1g+A1g*loga)

      H1stgq_1 = C1gq_1 +(-gamma1gq_1)*(dlog(muf2/q2)+2*loga)
      H1stgq_2 = C1gq_2 +(-gamma1gq_2)*(dlog(muf2/q2)+2*loga)
      H1stqq=0d0

C  All *4 because of normalization (aass/2pi)^2 en lugar de aass/pi
C normalization of aass/2pi  implies  gamma^1->gamma^1/2
C                                   C^1, H^1 -> C^1/2, H^1/2 
C                                   gamma^2-> gamma^2/4
C                              beta,A,B -> beta,A,B are in aass/pi already


C     H2 coefficients without spin correlations
C average of H2gg  over legs1 and legs 2
       H2stgg= 4d0 *( H2GG_1 - CA**2 *G1N_1*G1N_1 + 
     .                H2GG_2 - CA**2 *G1N_2*G1N_2 )/2D0
C Actually No need to correct for N dependence of C1*C2 term because N-indep. 
C but do it anyway
       H2stgg = H2stgg - ( C1gg_1 * C1gg_1 + C1gg_2 * C1gg_2)/2
     .        +   C1gg_1 * C1gg_2


       H2stgq_1= 4d0 *( H2GQ_1 - CA*CF *G1N_1*G1N_1) 
       H2stgq_2= 4d0 *( H2GQ_2 - CA*CF *G1N_2*G1N_2)
       
C not needed!!       
C       H2stqq= 4d0 *( H2QQ_1 - CF**2 *G1N_1*G1N_1 + 
C     .                H2QQ_2 - CF**2 *G1N_2*G1N_2 )/2D0
C Correct for N-dependence of C1*C2, the result of first line should be 0!!
C       H2stqq = H2stqq - ( C1gq_1 * C1gq_1 + C1gq_2 * C1gq_2)/2
C     .        +   C1gq_1 * C1gq_2
C CHECK : OK! 

C C2 coefficient (aass/2pi normalization)
       C2gq_1 = H2stgq_1 - C1gq_1 * C1gg_1 
       C2gq_2 = H2stgq_2 - C1gq_2 * C1gg_2 
       

       H2stgg = H2stgg + 4d0*(
     .  + 1d0/6d0*A1g*beta0*8d0*loga**3  
     .  + 1d0/2d0*4d0*loga**2*(A2g-beta0*(B1g+2d0*A1g*loga 
     .                  +gamma1gg_1/2d0 +gamma1gg_2/2d0 ))     
     .  - 2d0*loga*(B2g+2d0*A2g*loga-beta0*(C1gg_1+C1gg_2)/2d0 +
     .               gamma2gg_1/4d0 + gamma2gg_2/4d0 )
     .  + beta0/2d0*(gamma1gg_1+gamma1gg_2)/2d0*log(q2/muf2)**2
     .  + (gamma2gg_1+gamma2gg_2)/4d0*log(q2/muf2)
     .  - H1stgg/2d0*beta0*dlog(q2/mur2)
     .  + 1d0/2d0*(H1stgg+H1g+C1gg_1+C1gg_2)/2d0*(
     .       (gamma1gg_1+gamma1gg_2)/2d0*(log(q2/muf2)-2d0*loga)
     .        -((B1g+A1g*loga)*2d0*loga+pcf*beta0*log(q2/mur2)))
     . +1d0/4d0*(H1stgq_1+C1gq_1)*gamma1qg_1/2*(log(q2/muf2)-2d0*loga)
     . +1d0/4d0*(H1stgq_2+C1gq_2)*gamma1qg_2/2*(log(q2/muf2)-2d0*loga)
     .  - pcf*(1d0/2d0*(beta0*log(q2/mur2))**2+beta1*log(q2/mur2))
     .          ) 
      
       H2stgq_1 = C2gq_1 + C1gq_1 * C1gg_2 
     .      + 4d0*(  
     .      + 1d0/2d0*beta0*4d0*loga**2*(-gamma1gq_1/2d0)
     .      - 2d0*loga*(-beta0 * C1gq_1/2d0 + gamma2gq_1/4d0)
     .      + 1d0/2d0*beta0*dlog(q2/muf2)**2*(gamma1gq_1/2d0)
     .      + gamma2gq_1/4d0*dlog(q2/muf2)
     .      - beta0*dlog(q2/mur2)*H1stgq_1/2d0
     .      + 1d0/2d0*(H1stgg + H1g + C1gg_1 + C1gg_2)/2d0*
     .             (dlog(q2/muf2)-2*loga) * gamma1gq_1/2d0
     .      + 1d0/2d0 * ( H1stgq_1 + C1gq_1)/2d0 *
     .       ((dlog(q2/muf2)-2d0*loga) *(gamma1gg_2 + gamma1qq_1 )/2d0
     .         -((B1g+A1g*loga)*2d0*loga+ pcf*beta0*dlog(q2/mur2) ))
     .                ) 
     
       H2stgq_2 = C2gq_2 + C1gq_2 * C1gg_1 
     .      + 4d0*(  
     .      + 1d0/2d0*beta0*4d0*loga**2*(-gamma1gq_2/2d0)
     .      - 2d0*loga*(-beta0 * C1gq_2/2d0 + gamma2gq_2/4d0)
     .      + 1d0/2d0*beta0*dlog(q2/muf2)**2*(gamma1gq_2/2d0)
     .      + gamma2gq_2/4d0*dlog(q2/muf2)
     .      - beta0*dlog(q2/mur2)*H1stgq_2/2d0
     .      + 1d0/2d0*(H1stgg + H1g + C1gg_2 + C1gg_1)/2d0*
     .             (dlog(q2/muf2)-2*loga) * gamma1gq_2/2d0
     .      + 1d0/2d0 * ( H1stgq_2 + C1gq_2)/2d0 *
     .       ((dlog(q2/muf2)-2d0*loga) *(gamma1gg_1 + gamma1qq_2 )/2d0
     .         -((B1g+A1g*loga)*2d0*loga+ pcf*beta0*dlog(q2/mur2) ))
     .                )       

       H2stqq = C1gq_2*C1gq_1 - 4d0*(1d0/2d0*(dlog(muf2/q2)+2d0*loga)*
     .   ( (H1stgq_1 + C1gq_1 )/2d0*gamma1gq_2/2d0 + 
     .     (H1stgq_2 + C1gq_2 )/2d0*gamma1gq_1/2d0 ) )
     

       Hgg = (1d0+aass/2d0*H1stgg+(aass/2d0)**2*H2stgg)
     .       +aass**2*CA*CA*G1N_1*G1N_2*aexp*aexp
     
       Hgq_1 = ( aass/2d0*H1stgq_1+(aass/2d0)**2*H2stgq_1)*
     .         aexp*aexpB**(aass/2d0*(C2gq_1/C1gq_1-C1gg_1))  
     .      +aass**2*CA*CF*G1N_1*G1N_2*aexp*aexp
     
       Hgq_2 = ( aass/2d0*H1stgq_2+(aass/2d0)**2*H2stgq_2)*
     .         aexp*aexpB**(aass/2d0*(C2gq_2/C1gq_2-C1gg_2))  
     .      +aass**2*CA*CF*G1N_1*G1N_2*aexp*aexp

       Hqq = (aass/2d0)**2*H2stqq
     .         *aexp*aexpB**(aass/2d0*(C2gq_1/C1gq_1-C1gg_1))  
     .         *aexp*aexpB**(aass/2d0*(C2gq_2/C1gq_2-C1gg_2))  
     .      +aass**2*CF*CF*G1N_1*G1N_2*aexp*aexp

         endif

!       HCRN = GGN ! (only for LL)
       if(iscale.eq.0)then
        HCRN = Hgg*GGN + QGN*Hgq_1 + GQN*Hgq_2 + QQN*Hqq
       else
        HCRN = (Hggtb*GGN + QGN*Hgq_1 + GQN*Hgq_2 + QQN*Hqq)*xnormtb
     .         -(Hggt*GGN + QGN*Hgq_1 + GQN*Hgq_2 + QQN*Hqq)*xnormt
       endif
       RETURN
       END



C
C PROVIDES MOMENTS OF DENSITIES AT A GIVEN SCALE (INCLUDES EVOLUTION)
C AND ANOMALOUS DIMENSIONS
C EVERYTHING IN MELLIN SPACE
C
       SUBROUTINE RENO2 (FN, XN, I, ISIGN, IBEAM, ALPS, SCALE2, ALPQ,
     .  gamma1qq, gamma1qg, gamma1gq, gamma1gg, 
     .  gamma2qq, gamma2qg, gamma2gq, gamma2gg,
     .  C1QQ,C1QG,C1GQ,C1GG,C1GGEX,C1GGEXT,C1GGEXTB,
     .  H2QQ,H2QG,H2GQ,H2GG,G1N,iscale)

       IMPLICIT DOUBLE COMPLEX (A - Z)
       DIMENSION FN(9)
       DOUBLE PRECISION XL, XL1, S, ALP, ALPS, ALPQF, ALPQR   
       INTEGER F, nnF, NAORD, I, ISIGN, IBEAM, IFIT
         COMPLEX*16 UVP(136,30),DVP(136,30),USP(136,30),DSP(136,30),
     .         SSP(136,30),GLP(136,30),CHP(136,30),BOP(136,30)
       COMPLEX*16 UVM(136,30),DVM(136,30),USM(136,30),DSM(136,30),
     .           SSM(136,30),GLM(136,30),CHM(136,30),BOM(136,30)
       COMPLEX*16 UVP2(136,30),DVP2(136,30),USP2(136,30),DSP2(136,30),
     .           SSP2(136,30),GLP2(136,30),CHP2(136,30),BOP2(136,30)
       COMPLEX*16 UVM2(136,30),DVM2(136,30),USM2(136,30),DSM2(136,30),
     .           SSM2(136,30),GLM2(136,30),CHM2(136,30),BOM2(136,30)
          
       COMPLEX*16 QQIP(136),QGFP(136), GQIP(136), GGIP(136), GGFP(136),
     1            NS1MIP(136), NS1PIP(136), NS1FP(136),QQ1FP(136), 
     2       QG1FP(136), GQ1IP(136), GQ1FP(136), GG1IP(136), GG1FP(136) 
       COMPLEX*16 QQIM(136),QGFM(136), GQIM(136), GGIM(136), GGFM(136),
     1           NS1MIM(136), NS1PIM(136), NS1FM(136),QQ1FM(136), 
     2       QG1FM(136), GQ1IM(136), GQ1FM(136), GG1IM(136), GG1FM(136)

       COMPLEX*16 H2QQp(136),H2QGp(136),H2GQp(136),H2GGp(136)
       COMPLEX*16 H2QQm(136),H2QGm(136),H2GQm(136),H2GGm(136)
     
       COMMON / ANOMP/QQIp, QGFp, GQIp, GGIp, GGFp, NS1MIp, NS1PIp, 
     1          NS1Fp, QQ1Fp, QG1Fp, GQ1Ip, GQ1Fp, GG1Ip, GG1Fp
       COMMON / ANOMM/QQIm, QGFm, GQIm, GGIm, GGFm, NS1MIm, NS1PIm, 
     1          NS1Fm, QQ1Fm, QG1Fm, GQ1Im, GQ1Fm, GG1Im, GG1Fm
       COMMON / DISTP1/ UVP,DVP,USP,DSP,SSP,GLP,CHP,BOP
       COMMON / DISTM1/ UVM,DVM,USM,DSM,SSM,GLM,CHM,BOM
       COMMON / DISTP2/ UVP2,DVP2,USP2,DSP2,SSP2,GLP2,CHP2,BOP2
       COMMON / DISTM2/ UVM2,DVM2,USM2,DSM2,SSM2,GLM2,CHM2,BOM2
       COMMON / NAORD / NAORD
       COMMON/NFLAVORS/nnF
       COMMON/COEFF/BETA0N,BETA1N,BETA2N,A1GN,A2GN,A3GN,B1GN,B2GN,H1G
       COMMON/ IFIT/ IFIT
       COMMON / H2COEF /H2QQp,H2QGp,H2GQp,H2GGp,H2QQm,H2QGm,H2GQm,H2GGm
 !      include 'const.h'
         integer nf,approxim,iscale
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex,
     #                                     C1ggntb,C1ggnt
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                                C1ggnex,C1ggntb,C1ggnt
       common/data/pi,II
       common/flag/approxim
!fine sostituz const.h


c.....this is because SIGMA IS NORMALIZED TO AASS/2*PI
c.....while our coefficients are normalized to AASS/PI
      beta0N=beta0*2d0
      beta1N=beta1*4d0
      beta2N=beta2*8d0
      A1gN=A1g*2d0
      A2gN=A2g*4d0
      A3gN=A3g*8d0
      B1gN=B1g*2d0
      B2gN=B2g*4d0
      A1qN=A1q*2d0
      A2qN=A2q*4d0
      A3qN=A3q*8d0
      B1qN=B1q*2d0
      B2qN=B2q*4d0

      
       IF (IBEAM.EQ.1) THEN

       IF (ISIGN.EQ.1) THEN
        UVI = UVp(I,IFIT)
        DVI = DVp(I,IFIT)
        USI = USp(I,IFIT)
        DSI = DSp(I,IFIT)
        SSI = SSp(I,IFIT)
        GLI = GLp(I,IFIT)
        CHI = CHp(I,IFIT)
        BOI = BOp(I,IFIT)

        QQI = QQIp(I) 
        QGF = QGFp(I) 
        GQI = GQIp(I) 
        GGI = GGIp(I) 
        GGF = GGFp(I) 
        NS1MI = NS1MIp(I)  
        NS1PI = NS1PIp(I) 
        NS1F = NS1Fp(I)            
        QQ1F = QQ1Fp(I) 
        QG1F = QG1Fp(I) 
        GQ1I = GQ1Ip(I) 
        GQ1F = GQ1Fp(I) 
        GG1I = GG1Ip(I) 
        GG1F = GG1Fp(I) 


        H2QQ = H2QQp(I)
        H2QG = H2QGp(I)
        H2GQ = H2GQp(I)
        H2GG = H2GGp(I)


        ELSE 
        UVI = UVm(I,IFIT)
        DVI = DVm(I,IFIT)
        USI = USm(I,IFIT)
        DSI = DSm(I,IFIT)
        SSI = SSm(I,IFIT)
        GLI = GLm(I,IFIT)
        CHI = CHm(I,IFIT)
        BOI = BOm(I,IFIT)
        
        QQI = QQIm(I) 
        QGF = QGFm(I)
        GQI = GQIm(I)
        GGI = GGIm(I)
        GGF = GGFm(I)
        NS1MI = NS1MIm(I)
        NS1PI = NS1PIm(I)
        NS1F = NS1Fm(I)            
        QQ1F = QQ1Fm(I) 
        QG1F = QG1Fm(I) 
        GQ1I = GQ1Im(I) 
        GQ1F = GQ1Fm(I) 
        GG1I = GG1Im(I) 
        GG1F = GG1Fm(I) 

        H2QQ = H2QQm(I)
        H2QG = H2QGm(I)
        H2GQ = H2GQm(I)
        H2GG = H2GGm(I)
                     
         ENDIF      

       ELSEIF (IBEAM.EQ.2) THEN
       IF (ISIGN.EQ.1) THEN
        UVI = UVp2(I,IFIT)
        DVI = DVp2(I,IFIT)
        USI = USp2(I,IFIT)
        DSI = DSp2(I,IFIT)
        SSI = SSp2(I,IFIT)
        GLI = GLp2(I,IFIT)
        CHI = CHp2(I,IFIT)
        BOI = BOp2(I,IFIT)

        QQI = QQIp(I) 
        QGF = QGFp(I) 
        GQI = GQIp(I) 
        GGI = GGIp(I) 
        GGF = GGFp(I) 
        NS1MI = NS1MIp(I)  
        NS1PI = NS1PIp(I) 
        NS1F = NS1Fp(I)            
        QQ1F = QQ1Fp(I) 
        QG1F = QG1Fp(I) 
        GQ1I = GQ1Ip(I) 
        GQ1F = GQ1Fp(I) 
        GG1I = GG1Ip(I) 
        GG1F = GG1Fp(I) 

        H2QQ = H2QQp(I)
        H2QG = H2QGp(I)
        H2GQ = H2GQp(I)
        H2GG = H2GGp(I)
    
        ELSE 
        UVI = UVm2(I,IFIT)
        DVI = DVm2(I,IFIT)
        USI = USm2(I,IFIT)
        DSI = DSm2(I,IFIT)
        SSI = SSm2(I,IFIT)
        GLI = GLm2(I,IFIT)
        CHI = CHm2(I,IFIT)
        BOI = BOm2(I,IFIT)
        
        QQI = QQIm(I) 
        QGF = QGFm(I)
        GQI = GQIm(I)
        GGI = GGIm(I)
        GGF = GGFm(I)
        NS1MI = NS1MIm(I)
        NS1PI = NS1PIm(I)
        NS1F = NS1Fm(I)            
        QQ1F = QQ1Fm(I) 
        QG1F = QG1Fm(I) 
        GQ1I = GQ1Im(I) 
        GQ1F = GQ1Fm(I) 
        GG1I = GG1Im(I) 
        GG1F = GG1Fm(I) 

        H2QQ = H2QQm(I)
        H2QG = H2QGm(I)
        H2GQ = H2GQm(I)
        H2GG = H2GGm(I)
                     
         ENDIF      
       ELSE
        write(6,*)"wrong IBEAM in RENOSUS= ",IBEAM
        STOP
       ENDIF      
       
       
      UVN = UVI
      DVN = DVI
      NS3N = UVI + 2*USI - DVI - 2.*DSI
      NS8N = UVI + 2*USI + DVI + 2.*DSI - 4.*SSI
      GLN = GLI
      SIN = UVI + DVI + 2*USI + 2*DSI
     .     + 2*SSI + 2*CHI + 2*BOI 
      NS15N = UVI + DVI + 2*USI + 2*DSI + 2*SSI - 6*CHI
      NS24N = UVI + DVI + 2*USI + 2*DSI +
     .     2*SSI + 2*CHI - 8*BOI
      NS35N = SIN
 
      IF (nnf.eq.3) then
        SIN = UVI + DVI + 2*USI + 2*DSI + 2*SSI 
        NS15N = SIN
        NS24N = SIN
        NS35N = SIN
      ENDIF
      F = 5

*... alphasl gives the LL/NLL evolution of alpha from Qres=Q/a_param to
*                                                     q2=bo^2/b^2
* alps=alpha(Qres)=alpQF
      alpq= alps * alphasl(scale2,iscale)

      XL = ALPS / ALPQ 
      ALP=ALPQ 
       S   = LOG (XL)
       XL1 = 1.- XL
C SELECT ORDER FOR EVOLUTION LO/NLO
      ALPr= ALP * cmplx(1d0,0d0)*(NAORD-1)

       CALL ANOM (ANS, AM, AP, AL, BE, AB, RMIN, RPLUS, RQQ, RQG,
     1            RGQ, RGG, C2Q, C2G, CDYQ, CDYG, XN, F,
     2            QQI, QGF, GQI, GGI, GGF, NS1MI, NS1PI, NS1F,
     3            QQ1F, QG1F, GQ1I, GQ1F, GG1I, GG1F, C2QI, C2GF,
     4            CDYQI, CDYGI)


       ENS = EXP (-ANS*S)
C
       EM  = EXP (-AM*S)
       EP  = EXP (-AP*S)
       AC  = 1.- AL
       EMP = EXP (S * (-AM+AP))
       EPM = EXP (S * (+AM-AP))
       NMP = 1.- AM + AP
       NPM = 1.- AP + AM
       DMQQ =  AL * RQQ + BE * RGQ
       DMQG =  AL * RQG + BE * RGG
       DMGQ =  AB * RQQ + AC * RGQ
       DMGG =  AB * RQG + AC * RGG
       DPQQ =  AC * RQQ - BE * RGQ
       DPQG =  AC * RQG - BE * RGG
       DPGQ = -AB * RQQ + AL * RGQ
       DPGG = -AB * RQG + AL * RGG
       RMMQQ =   AL * DMQQ + AB * DMQG
       RMMQG =   BE * DMQQ + AC * DMQG
       RMMGQ =   AL * DMGQ + AB * DMGG
       RMMGG =   BE * DMGQ + AC * DMGG
       RMPQQ =  (AC * DMQQ - AB * DMQG) / NMP
       RMPQG = (-BE * DMQQ + AL * DMQG) / NMP
       RMPGQ =  (AC * DMGQ - AB * DMGG) / NMP
       RMPGG = (-BE * DMGQ + AL * DMGG) / NMP
       RPMQQ =  (AL * DPQQ + AB * DPQG) / NPM
       RPMQG =  (BE * DPQQ + AC * DPQG) / NPM
       RPMGQ =  (AL * DPGQ + AB * DPGG) / NPM
       RPMGG =  (BE * DPGQ + AC * DPGG) / NPM
       RPPQQ =   AC * DPQQ - AB * DPQG
       RPPQG =  -BE * DPQQ + AL * DPQG
       RPPGQ =   AC * DPGQ - AB * DPGG
       RPPGG =  -BE * DPGQ + AL * DPGG

C...EVOLUTION OF LIGHT PARTON DENSITIES
         UVN  = UVN  * ENS * (1.+  ALPr * XL1 * RMIN)
         DVN  = DVN  * ENS * (1.+  ALPr * XL1 * RMIN)
         NS3N = NS3N * ENS * (1.+  ALPr * XL1 * RPLUS)
         NS8N = NS8N * ENS * (1.+  ALPr * XL1 * RPLUS)
C
       SG = SIN
       GL = GLN
       SIN = EM * ((AL + ALPr * (RMMQQ * XL1 + RMPQQ * (EPM-XL)))* SG
     1           + (BE + ALPr * (RMMQG * XL1 + RMPQG * (EPM-XL))) * GL)
     2     + EP * ((AC + ALPr * (RPPQQ * XL1 + RPMQQ * (EMP-XL))) * SG
     3           +(-BE + ALPr * (RPPQG * XL1 + RPMQG * (EMP-XL))) * GL)
       GLN = EM * ((AB + ALPr * (RMMGQ * XL1 + RMPGQ * (EPM-XL))) * SG
     1           + (AC + ALPr * (RMMGG * XL1 + RMPGG * (EPM-XL))) * GL)
     2     + EP *((-AB + ALPr * (RPPGQ * XL1 + RPMGQ * (EMP-XL))) * SG
     3           + (AL + ALPr * (RPPGG * XL1 + RPMGG * (EMP-XL))) * GL)
C
      NS15N = NS15N * ENS * (1.+  ALPr * XL1 * RPLUS)
      NS24N = NS24N * ENS * (1.+  ALPr * XL1 * RPLUS)
      NS35N = SIN

C...  FLAVOUR DECOMPOSITION OF THE QUARK SEA :
      SSN = (10.* SIN + 2.* NS35N + 3.* NS24N + 5.* NS15N - 20.* NS8N)
     1     / 120.
      DSN = (10.* SIN + 2.* NS35N + 3.* NS24N + 5.* NS15N + 10.* NS8N
     1     - 30.* NS3N - 60.* DVN) / 120.
      USN = (10.* SIN + 2.* NS35N + 3.* NS24N + 5.* NS15N + 10.* NS8N
     1     + 30.* NS3N - 60.* UVN) / 120.
      CHN = (UVN + DVN + 2*USN + 2*DSN + 2*SSN - NS15N)/6.
      BON = (UVN + DVN + 2*USN + 2*DSN + 2*SSN + 2*CHN - NS24N)/8.
      
      if (nnf.eq.3) then        !GRV
         SSN= (20.* SIN - 20.* NS8N)/120.
         DSN = (20.* SIN + 10.* NS8N - 30.* NS3N - 60.* DVN) / 120.
         USN = (20.* SIN + 10.* NS8N + 30.* NS3N - 60.* UVN) / 120.
         CHN=CMPLX(0D0,0D0)
         BON=CMPLX(0D0,0D0)
      endif

C NORMALIZED ANOMALOUS DIMENSIONS AND COEFFICIENTS
      gamma1qq=-1d0*(QQI/4d0)
      gamma1qg=-1d0*(QGF/8d0)
      gamma1gq=-1d0*(GQI/4d0)
      gamma1gg=-1d0*((GGI+nf*GGF)/4d0)
      gamma2qq=-1d0*(((NS1PI+nf*NS1F)+nf*QQ1F)/8d0)
      gamma2qg=-1d0*(QG1F/16d0)
      gamma2gq=-1d0*((GQ1I+nf*GQ1F)/8d0)
      gamma2gg=-1d0*((GG1I+nf*GG1F)/8d0)


      G1N=1d0/XN/(XN-1)
      C1QG=1d0/((XN+1)*(XN+2))
      C1GQ=4/3d0/(XN+1)
         C1qq=2*pi**2/3d0-16/3d0+4/3d0/(XN*(XN+1))
         C1gg=pi**2/2d0+11/2d0+pi**2
      if(iscale.eq.0)then
        C1ggex=C1ggnex*2d0
      else
        C1ggextb=C1ggntb*2d0
        C1ggext=C1ggnt*2d0
      endif
         H1g=0d0
         H1q=0d0

*...  OUTPUT  
*  U   UB   D   DB   S   C    B    G 
*  1    2   3   4    5   6    7    8 

      FN(1) = UVN + USN
      FN(2) = USN
      FN(3) = DVN + DSN
      FN(4) = DSN
      FN(5) = SSN
      FN(6) = CHN
      FN(7) = BON
      FN(8) = GLN
      FN(9) = 0D0
       RETURN
       END



C
C PROVIDES MOMENTS OF DENSITIES AT INITIAL SCALES AND ANOMALOUS DIMENSIONS
C EVERYTHING IN MELLIN SPACE
C
       SUBROUTINE RENOSUS (FN, XN, I, ISIGN, IBEAM,
     .  gamma1qq, gamma1qg, gamma1gq, gamma1gg, 
     .  gamma2qq, gamma2qg, gamma2gq, gamma2gg,
     .  C1QQ,C1QG,C1GQ,C1GG)
       IMPLICIT DOUBLE COMPLEX (A - Z)
       DIMENSION FN(9)
       INTEGER F,I,ISIGN,IBEAM,IFIT
       COMPLEX*16 Np(136),Nm(136)
         COMPLEX*16 UVP(136,30),DVP(136,30),USP(136,30),DSP(136,30),
     .         SSP(136,30),GLP(136,30),CHP(136,30),BOP(136,30)
       COMPLEX*16 UVM(136,30),DVM(136,30),USM(136,30),DSM(136,30),
     .           SSM(136,30),GLM(136,30),CHM(136,30),BOM(136,30)
       COMPLEX*16 UVP2(136,30),DVP2(136,30),USP2(136,30),DSP2(136,30),
     .           SSP2(136,30),GLP2(136,30),CHP2(136,30),BOP2(136,30)
       COMPLEX*16 UVM2(136,30),DVM2(136,30),USM2(136,30),DSM2(136,30),
     .           SSM2(136,30),GLM2(136,30),CHM2(136,30),BOM2(136,30)

       COMPLEX*16 QQIP(136),QGFP(136), GQIP(136), GGIP(136), GGFP(136),
     1            NS1MIP(136), NS1PIP(136), NS1FP(136),QQ1FP(136), 
     2       QG1FP(136), GQ1IP(136), GQ1FP(136), GG1IP(136), GG1FP(136) 
       COMPLEX*16 QQIM(136),QGFM(136), GQIM(136), GGIM(136), GGFM(136),
     1           NS1MIM(136), NS1PIM(136), NS1FM(136),QQ1FM(136), 
     2       QG1FM(136), GQ1IM(136), GQ1FM(136), GG1IM(136), GG1FM(136)
     
       COMMON / ANOMP/QQIp, QGFp, GQIp, GGIp, GGFp, NS1MIp, NS1PIp, 
     1          NS1Fp, QQ1Fp, QG1Fp, GQ1Ip, GQ1Fp, GG1Ip, GG1Fp
       COMMON / ANOMM/QQIm, QGFm, GQIm, GGIm, GGFm, NS1MIm, NS1PIm, 
     1          NS1Fm, QQ1Fm, QG1Fm, GQ1Im, GQ1Fm, GG1Im, GG1Fm
     
       COMMON / DISTP1/ UVP,DVP,USP,DSP,SSP,GLP,CHP,BOP
       COMMON / DISTM1/ UVM,DVM,USM,DSM,SSM,GLM,CHM,BOM
       COMMON / DISTP2/ UVP2,DVP2,USP2,DSP2,SSP2,GLP2,CHP2,BOP2
       COMMON / DISTM2/ UVM2,DVM2,USM2,DSM2,SSM2,GLM2,CHM2,BOM2
       
       COMMON/NFLAVORS/F
       COMMON/COEFF/BETA0N,BETA1N,BETA2N,A1GN,A2GN,A3GN,B1GN,B2GN,H1G
       COMMON / MOMS2    / Np,Nm,CCP,CCm
       COMMON/ IFIT/ IFIT
 !      include 'const.h'
         integer nf
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                                           C1ggnex
       common/data/pi,II
!fine sostituz const.h


c.....this is because SIGMA IS NORMALIZED TO AASS/2*PI
c.....while our coefficients are normalized to AASS/PI
      beta0N=beta0*2d0
      beta1N=beta1*4d0
      beta2N=beta2*8d0
      A1gN=A1g*2d0
      A2gN=A2g*4d0
      A3gN=A3g*8d0
      B1gN=B1g*2d0
      B2gN=B2g*4d0
      A1qN=A1q*2d0
      A2qN=A2q*4d0
      A3qN=A3q*8d0
      B1qN=B1q*2d0
      B2qN=B2q*4d0


       IF (IBEAM.EQ.1) THEN

       IF (ISIGN.EQ.1) THEN
        UVN = UVp(I,IFIT)
        DVN = DVp(I,IFIT)
        USN = USp(I,IFIT)
        DSN = DSp(I,IFIT)
        SSN = SSp(I,IFIT)
        GLN = GLp(I,IFIT)
        CHN = CHp(I,IFIT)
        BON = BOp(I,IFIT)
        
        QQI = QQIp(I) 
        QGF = QGFp(I) 
        GQI = GQIp(I) 
        GGI = GGIp(I) 
        GGF = GGFp(I) 
        NS1MI = NS1MIp(I)  
        NS1PI = NS1PIp(I) 
        NS1F = NS1Fp(I)            
        QQ1F = QQ1Fp(I) 
        QG1F = QG1Fp(I) 
        GQ1I = GQ1Ip(I) 
        GQ1F = GQ1Fp(I) 
        GG1I = GG1Ip(I) 
        GG1F = GG1Fp(I) 
       
       ELSE 
        UVN = UVm(I,IFIT)
        DVN = DVm(I,IFIT)
        USN = USm(I,IFIT)
        DSN = DSm(I,IFIT)
        SSN = SSm(I,IFIT)
        GLN = GLm(I,IFIT)
        CHN = CHm(I,IFIT)
        BON = BOm(I,IFIT)
        
        QQI = QQIm(I) 
        QGF = QGFm(I)
        GQI = GQIm(I)
        GGI = GGIm(I)
        GGF = GGFm(I)
        NS1MI = NS1MIm(I)
        NS1PI = NS1PIm(I)
        NS1F = NS1Fm(I)            
        QQ1F = QQ1Fm(I) 
        QG1F = QG1Fm(I) 
        GQ1I = GQ1Im(I) 
        GQ1F = GQ1Fm(I) 
        GG1I = GG1Im(I) 
        GG1F = GG1Fm(I) 
                     
       ENDIF

       ELSEIF (IBEAM.EQ.2) THEN
       IF (ISIGN.EQ.1) THEN
        UVN = UVp2(I,IFIT)
        DVN = DVp2(I,IFIT)
        USN = USp2(I,IFIT)
        DSN = DSp2(I,IFIT)
        SSN = SSp2(I,IFIT)
        GLN = GLp2(I,IFIT)
        CHN = CHp2(I,IFIT)
        BON = BOp2(I,IFIT)
        
        QQI = QQIp(I) 
        QGF = QGFp(I) 
        GQI = GQIp(I) 
        GGI = GGIp(I) 
        GGF = GGFp(I) 
        NS1MI = NS1MIp(I)  
        NS1PI = NS1PIp(I) 
        NS1F = NS1Fp(I)            
        QQ1F = QQ1Fp(I) 
        QG1F = QG1Fp(I) 
        GQ1I = GQ1Ip(I) 
        GQ1F = GQ1Fp(I) 
        GG1I = GG1Ip(I) 
        GG1F = GG1Fp(I) 
       
       ELSE 
        UVN = UVm2(I,IFIT)
        DVN = DVm2(I,IFIT)
        USN = USm2(I,IFIT)
        DSN = DSm2(I,IFIT)
        SSN = SSm2(I,IFIT)
        GLN = GLm2(I,IFIT)
        CHN = CHm2(I,IFIT)
        BON = BOm2(I,IFIT)
        
        QQI = QQIm(I) 
        QGF = QGFm(I)
        GQI = GQIm(I)
        GGI = GGIm(I)
        GGF = GGFm(I)
        NS1MI = NS1MIm(I)
        NS1PI = NS1PIm(I)
        NS1F = NS1Fm(I)            
        QQ1F = QQ1Fm(I) 
        QG1F = QG1Fm(I) 
        GQ1I = GQ1Im(I) 
        GQ1F = GQ1Fm(I) 
        GG1I = GG1Im(I) 
        GG1F = GG1Fm(I) 
                     
       ENDIF

       ELSE
        write(6,*)"wrong IBEAM in RENOSUS= ",IBEAM
        STOP
       ENDIF
       

       CALL ANOM (ANS, AM, AP, AL, BE, AB, RMIN, RPLUS, RQQ, RQG,
     1            RGQ, RGG, C2Q, C2G, CDYQ, CDYG, XN, F,
     2            QQI, QGF, GQI, GGI, GGF, NS1MI, NS1PI, NS1F,
     3            QQ1F, QG1F, GQ1I, GQ1F, GG1I, GG1F, C2QI, C2GF,
     4            CDYQI, CDYGI)
      
      gamma1qq=-1d0*(QQI/4d0)
      gamma1qg=-1d0*(QGF/8d0)
      gamma1gq=-1d0*(GQI/4d0)
      gamma1gg=-1d0*((GGI+nf*GGF)/4d0)
      gamma2qq=-1d0*(((NS1PI+nf*NS1F)+nf*QQ1F)/8d0)
      gamma2qg=-1d0*(QG1F/16d0)
      gamma2gq=-1d0*((GQ1I+nf*GQ1F)/8d0)
      gamma2gg=-1d0*((GG1I+nf*GG1F)/8d0)

      C1QG=1d0/((XN+1)*(XN+2))
      C1GQ=4/3d0/(XN+1)
         C1qq=2*pi**2/3d0-16/3d0+4/3d0/(XN*(XN+1)) !Drell-Yan
         C1gg=pi**2/2d0+11/2d0+pi**2               !Higgs
         H1g=0d0
         H1q=0d0

*...  OUTPUT  
*  U   UB   D   DB   S   C    B    G 
*  1    2   3   4    5   6    7    8 

      FN(1) = UVN + USN
      FN(2) = USN
      FN(3) = DVN + DSN
      FN(4) = DSN
      FN(5) = SSN
      FN(6) = CHN
      FN(7) = BON
      FN(8) = GLN
      FN(9) = 0D0
       RETURN
       END






C
C...ANOMALOUS DIMENSIONS FOR LEADING AND NEXT TO LEADING ORDER
C...EVOLUTION OF PARTON DENSITIES AND WILSON COEFFICIENTS FOR
C...NLO STRUCTURE FUNCTIONS :
       SUBROUTINE ANOM (ANS, AM, AP, AL, BE, AB, RMIN, RPLUS, RQQ, RQG,
     1                  RGQ, RGG, C2Q, C2G, CDYQ, CDYG, XN, FR,
     2                  QQI, QGF, GQI, GGI, GGF, NS1MI, NS1PI, NS1F,
     3                  QQ1F, QG1F, GQ1I, GQ1F, GG1I, GG1F, C2QI, C2GF,
     4                  CDYQI, CDYGI)
       IMPLICIT DOUBLE COMPLEX (A - Z)
       DOUBLE PRECISION B0, B1, B02, B10
       INTEGER N, F, FR, nnf
       COMMON /SCHEME/ N
C...ANOMALOUS DIMENSIONS AND RELATED QUANTITIES IN LEADING ORDER :
      COMMON/NFLAVORS/nnF
       F = FR
       if (nnf.eq.3) F = 3

       N = 1
       B0 = 11.- 2./3.* FR
       B02 = 2.* B0
       QQ = QQI
       QG = F * QGF
       GQ = GQI
       GG = GGI + F * GGF
       SQ = SQRT ((GG - QQ) * (GG - QQ) + 4.* QG * GQ)
       GP = 0.5 * (QQ + GG + SQ)
       GM = 0.5 * (QQ + GG - SQ)
       ANS = QQ / B02
       AM = GM / B02
       AP = GP / B02
       AL = (QQ - GP) / (GM - GP)
       BE = QG / (GM - GP)
       AB = GQ / (GM - GP)
C...NEXT TO LEADING ORDER : ANOMALOUS DIMENSIONS AND WILSON COEFFICIENTS
C...IN THE MS-BAR FACTORIZATION SCHEME OF BARDEEN ET AL. (1981) :
       NS1M = NS1MI + F * NS1F
       NS1P = NS1PI + F * NS1F
       QQ1 = NS1P + F * QQ1F
       QG1 = F * QG1F
       GQ1 = GQ1I + F * GQ1F
       GG1 = GG1I + F * GG1F
       C2Q = C2QI
       C2G = F * C2GF
       CDYQ = CDYQI
       CDYG = CDYGI
C...CHANGE TO THE SCHEME OF ALTARELLI ET AL. (1979) FOR N = 2 OR TO THE
C...DIS SCHEME FOR N = 3 :
       IF (N .EQ. 2) THEN
          DEL = -0.5 * QG
          C2G = C2G + DEL
          QQ1 = QQ1 - DEL * GQ
          QG1 = QG1 + DEL * (QQ - GG - B02 - QG)
          GQ1 = GQ1 + DEL * GQ
          GG1 = GG1 + DEL * (GQ + B02)
       ELSE IF (N .EQ. 3) THEN
          NS1P = NS1P + B02 * C2Q
          NS1M = NS1M + B02 * C2Q
          QQ1 = QQ1 + C2Q * (QG + B02) + C2G * GQ
          QG1 = QG1 + C2Q * QG + C2G * (GG - QQ + QG + B02)
          GQ1 = GQ1 - C2Q * (QQ - GG + GQ + B02) - C2G * GQ
          GG1 = GG1 - C2Q * QG - C2G * (GQ + B02)
          C2Q = 0.
          C2G = 0.
       END IF
       XN1 = XN + 1.
C       C3Q = C2Q - 8./3.* (1./ XN + 1./ XN1)
C       CLQ = 16./ (3.* XN1)
C       CLG = 8.* F / (XN1 * (XN + 2.))
C...COMBINATIONS OF ANOMALOUS DIMENSIONS FOR NLO - SINGLET EVOLUTION :
       B1 = 102 - 38./3.* FR
       B10 = B1 / B0
       RMIN = (NS1M - QQ * B10) / B02
       RPLUS = (NS1P - QQ * B10) / B02
       RQQ = (QQ1 - QQ * B10) / B02
       RQG = (QG1 - QG * B10) / B02
       RGQ = (GQ1 - GQ * B10) / B02
       RGG = (GG1 - GG * B10) / B02
       RETURN
       END
C
C
C...CALCULATION OF ANOMALOUS DIMENSIONS AND WILSON COEFFICIENTS
C...UP TO THEIR DEPENDENCE OF THE NUMBER OF ACTIVE FLAVOURS F :
       SUBROUTINE ANCALC (QQI, QGF, GQI, GGI, GGF, NS1MI, NS1PI, NS1F,
     1                    QQ1F, QG1F, GQ1I, GQ1F, GG1I, GG1F, XN)
       IMPLICIT DOUBLE COMPLEX (A - Z)
       DOUBLE PRECISION ZETA2, ZETA3,  Q2, Q2MUR, Q2MUF
c       COMMON / SCALES / Q2, Q2MUR, Q2MUF
C
c       LMQ = LOG(Q2/Q2MUF)

       XNS = XN * XN
       XN1 = XN + 1.
       XN2 = XN + 2.
       XNM = XN - 1.
C...LEADING ORDER :
       CPSI = PSIFN (XN1) + 0.577216
       QQI = (8./3.) * (-3.- 2./(XN * XN1) + 4.* CPSI)
       QGF = -4.* (XNS + XN +2.) / (XN * XN1 * XN2)
       GQI = -(16./3.) * (XNS + XN + 2.) / (XN * XN1 * XNM)
       GGI = -22.- 24./(XN * XNM) - 24./(XN1 * XN2) + 24.* CPSI
       GGF = 4./3.
C...NEXT OT LEADING ORDER :
       XNT = XNS * XN
       XNFO = XNT * XN
       XN1S = XN1 * XN1
       XN1T = XN1S * XN1
C...ANALYTIC CONTINUATIONS OF N-SUMS AS GIVEN IN GLUECK ET AL. (1990) :
       ZETA2 = 1.644934
       ZETA3 = 1.202057
       CPSI1 = ZETA2 - PSIFN1 (XN1)
*       CPSI2 = 0.5 * PSIFN2 (XN1) - ZETA2
*       SPMOM = 1.01/XN1 - 0.846/XN2 + 1.155/(XN+3.) - 1.074/(XN+4.) +
*     1         0.55/(XN+5.)
       SPMOM = 1.004D0 / XN1 - 0.846D0 / XN2 + 1.342D0 / (XN+3.) -
     1         1.532D0 / (XN+4.) + 0.839D0 / (XN+5.)
       SLC = -5./8.* ZETA3
       SLV = - ZETA2/2.* (PSIFN (XN1/2.) - PSIFN (XN/2.))
     1       + CPSI/XNS + SPMOM
       SSCHLM = SLC - SLV
       SSTR2M = ZETA2 - PSIFN1 (XN1/2.)
       SSTR3M = 0.5 * PSIFN2 (XN1/2.) + ZETA3
       SSCHLP = SLC + SLV
       SSTR2P = ZETA2 - PSIFN1 (XN2/2.)
       SSTR3P = 0.5 * PSIFN2 (XN2/2.) + ZETA3
C...NON-SINGLET PIECES AS GIVEN IN CURCI ET AL. (1980) :
       NS1MA = 16.* CPSI * (2.* XN + 1.) / (XNS * XN1S) +
     1         16.* (2.* CPSI - 1./(XN * XN1)) * ( CPSI1 - SSTR2M ) +
     2         64.* SSCHLM + 24.* CPSI1 - 3. - 8.* SSTR3M -
     3         8.* (3.* XNT + XNS -1.) / (XNT * XN1T) +
     4         16.* (2.* XNS + 2.* XN +1.) / (XNT * XN1T)
       NS1PA = 16.* CPSI * (2.* XN + 1.) / (XNS * XN1S) +
     1         16.* (2.* CPSI - 1./(XN * XN1)) * ( CPSI1 - SSTR2P ) +
     2         64.* SSCHLP + 24.* CPSI1 - 3. - 8.* SSTR3P -
     3         8.* (3.* XNT + XNS -1.) / (XNT * XN1T) -
     4         16.* (2.* XNS + 2.* XN +1.) / (XNT * XN1T)
       NS1B = CPSI * (536./9. + 8.* (2.* XN + 1.) / (XNS * XN1S)) -
     1        (16.* CPSI + 52./3.- 8./(XN * XN1)) * CPSI1 - 43./6. -
     2        (151.* XNFO + 263.* XNT + 97.* XNS + 3.* XN + 9.) *
     3        4./ (9.* XNT * XN1T)
       NS1C = -160./9.* CPSI + 32./3.* CPSI1 + 4./3. +
     1        16.* (11.* XNS + 5.* XN - 3.) / (9.* XNS * XN1S)
       NS1MI = -2./9.* NS1MA + 4.* NS1B
       NS1PI = -2./9.* NS1PA + 4.* NS1B
       NS1F = 2./3. * NS1C
C...SINGLET PIECES AS GIVEN IN FLORATOS ET AL. (1981) :
       XNFI = XNFO * XN
       XNSI = XNFI * XN
       XNSE = XNSI * XN
       XNE = XNSE * XN
       XNN = XNE * XN
       XNMS = XNM * XNM
       XN2S = XN2 * XN2
       XN2T = XN2S * XN2
       QQ1F = (5.* XNFI + 32.* XNFO + 49.* XNT + 38.* XNS + 28.* XN
     1          + 8.) / (XNM * XNT * XN1T * XN2S) * (-32./3.)
       QG1A = (-2.* CPSI * CPSI + 2.* CPSI1 - 2.* SSTR2P)
     1          * (XNS + XN + 2.) / (XN * XN1 * XN2)
     2        + (8.* CPSI * (2.* XN + 3.)) / (XN1S * XN2S)
     3        + 2.* (XNN + 6.* XNE + 15. * XNSE + 25.* XNSI + 36.* XNFI
     4          + 85.* XNFO + 128.* XNT + 104.* XNS + 64.* XN + 16.)
     5          / (XNM * XNT * XN1T * XN2T)
       QG1B = (2.* CPSI * CPSI - 2.* CPSI1 + 5.) * (XNS + XN + 2.)
     1          / (XN * XN1 * XN2)   -   4.* CPSI / XNS
     2        + (11.* XNFO + 26.* XNT + 15.* XNS + 8.* XN + 4.)
     3          / (XNT * XN1T * XN2)
       QG1F = - 12.* QG1A - 16./3.* QG1B
       GQ1A = (-2.* CPSI * CPSI + 10.* CPSI - 2.* CPSI1)
     1          * (XNS + XN + 2.) / (XNM * XN * XN1)  -  4.* CPSI / XN1S
     2        - (12.* XNSI + 30.* XNFI + 43.* XNFO + 28.* XNT - XNS
     3          - 12.* XN - 4.) / (XNM * XNT * XN1T)
       GQ1B = (CPSI * CPSI + CPSI1 - SSTR2P) * (XNS + XN + 2.)
     1          / (XNM * XN * XN1)
     2        - CPSI * (17.* XNFO + 41.* XNS - 22.* XN - 12.)
     3          / (3.* XNMS * XNS * XN1)
     4        + (109.* XNN + 621.* XNE + 1400.* XNSE + 1678.* XNSI
     5          + 695.* XNFI - 1031.* XNFO - 1304.* XNT - 152.* XNS
     6          + 432.* XN + 144.) / (9.* XNMS * XNT * XN1T * XN2S)
       GQ1C = (CPSI - 8./3.) * (XNS + XN + 2.) / (XNM * XN * XN1)
     1        + 1./ XN1S
       GQ1I = - 64./9.* GQ1A - 32.* GQ1B
       GQ1F = - 64./9.* GQ1C
       GG1A = 16./9.* (38.* XNFO + 76.* XNT + 94.* XNS + 56.* XN + 12.)
     1          / (XNM * XNS * XN1S * XN2)   -   160./9.* CPSI + 32./3.
       GG1B = (2.* XNSI + 4.* XNFI + XNFO - 10.* XNT - 5.* XNS - 4.* XN
     1          - 4.) * 16. / (XNM * XNT * XN1T * XN2)   +   8.
       GG1C = (2.* XNFI + 5.* XNFO + 8.* XNT + 7.* XNS - 2.* XN - 2.)
     1          * 64.* CPSI / (XNMS * XNS * XN1S * XN2S)
     2        + 536./9.* CPSI - 64./3.
     3        + 32.* SSTR2P * (XNS + XN + 1.) / (XNM * XN * XN1 * XN2)
     4        - 16.* CPSI * SSTR2P + 32.* SSCHLP - 4.* SSTR3P
     5        - 4.* (457.* XNN + 2742.* XNE + 6040.* XNSE + 6098.* XNSI
     6          + 1567.* XNFI - 2344.* XNFO - 1632.* XNT + 560.* XNS
     7          + 1488.* XN + 576.) / (9.* XNMS * XNT * XN1T * XN2T)
       GG1I = 9.* GG1C
       GG1F = 3./2.* GG1A + 2./3.* GG1B

C...WILSON COEFFICIENTS :
c       C2QI = 4./3.* (2.* CPSI * CPSI - 2.* CPSI1 + 3.* CPSI - 9.
c     1       - 2.* CPSI / (XN * XN1) + 3./ XN + 4./ XN1 + 2./ XNS)
c       C2QI = C2QI - LMQ * QQI/2.      
c       C2GF = - 2.* (CPSI * (XNS + XN + 2.) / (XN * XN1 * XN2)
c     1       + 1./ XN - 1./ XNS - 6./ XN1 + 6./ XN2)
c       C2GF = C2GF - LMQ * QGF/2.    
C... DRELL-YAN COEFFICIENTS :
c       CDYQI = 4./3. * (-8. + 8.*ZETA2 + 2./XNS + 2./XN1S - 
c     1                   4.*CPSI/XN/XN1 + 4.*CPSI*CPSI +
c     2                   (3. + 2./XN/XN1 - 4.*CPSI)*LMQ )
c       CDYGI = 1./2. * ( (4. + 14.*XN + 22.*XNS + 11.*XNT + XNFO)/
c     1                   (XNS*XN1S*XN2S) - 
c     2                    2.*(2. + XN + XNS)*CPSI/(XN*XN1*XN2) +
c     3                   (1./XN - 2./XN1 + 2./XN2)*LMQ )       
       RETURN
       END
C
C

C
C
C...PSI - FUNCTION FOR COMPLEX ARGUMENT
       DOUBLE COMPLEX FUNCTION PSIFN (Z)
       DOUBLE COMPLEX Z, ZZ, RZ, DZ, SUB
       SUB = CMPLX (0.,0.)
       ZZ = Z
  1    CONTINUE
       IF (DREAL (ZZ) .LT. 10.) THEN
         SUB = SUB - 1./ ZZ
         ZZ = ZZ + 1.
         GOTO 1
       END IF
       RZ = 1./ ZZ
       DZ = RZ * RZ
       PSIFN = SUB + LOG(ZZ) - RZ/2.- DZ/2520. * ( 210.+ DZ * (-21.+
     1         10.*DZ ))
       RETURN
       END
C
C
C...FIRST DERIVATIVE OF THE PSI - FUNCTION FOR COMPLEX ARGUMENT :
       DOUBLE COMPLEX FUNCTION PSIFN1 (Z)
       DOUBLE COMPLEX Z, ZZ, RZ, DZ, SUB
       SUB = CMPLX (0.,0.)
       ZZ = Z
  1    CONTINUE
       IF (DREAL (ZZ) .LT. 10.) THEN
         SUB = SUB + 1./ (ZZ * ZZ)
         ZZ = ZZ + 1.
         GOTO 1
       END IF
       RZ = 1./ ZZ
       DZ = RZ * RZ
       PSIFN1 = SUB + RZ + DZ/2. * ( 1 + RZ/630. * ( 210.- DZ * ( 42.-
     1         DZ * ( 30.- 42.*DZ ))))
       RETURN
       END
C
C
C...SECOND DERIVATIVE OF THE PSI - FUNCTION FOR COMPLEX ARGUMENT :
       DOUBLE COMPLEX FUNCTION PSIFN2 (Z)
       DOUBLE COMPLEX Z, ZZ, RZ, DZ, SUB
       SUB = CMPLX (0.,0.)
       ZZ = Z
  1    CONTINUE
       IF (DREAL (ZZ) .LT. 10.) THEN
         SUB = SUB - 2./ (ZZ * ZZ * ZZ)
         ZZ = ZZ + 1.
         GOTO 1
       END IF
       RZ = 1./ ZZ
       DZ = RZ * RZ
       PSIFN2 = SUB - DZ/60. * ( 60.+ RZ * ( 60.+ RZ * ( 30.- DZ *
     1         ( 10.- DZ * ( 10.- DZ * ( 18.- 50.* DZ ))))))
       RETURN
       END
C
C
C...BETA FUNCTION FOR COMPLEX ARGUMENT :
       DOUBLE COMPLEX FUNCTION CBETA (Z1, Z2)
       IMPLICIT DOUBLE COMPLEX (A - Z)
       LNGAM (X) = (X - 0.5) * LOG (X) - X + 0.91893853 + 1./(12.* X)
     1              * (1.- 1./(30.* X*X) * (1.- 1./(3.5 * X*X)
     2              * (1.- 4./(3.* X*X))))
       SUB = CMPLX (0., 0.)
       ZZ1 = Z1
  1    CONTINUE
       IF ( DREAL (ZZ1) .LT. 15.) THEN
          SUB = SUB + LOG ((ZZ1+Z2) / ZZ1)
          ZZ1 = ZZ1 + 1.
          GOTO 1
       END IF
       ZZ2 = Z2
  2    CONTINUE
       IF ( DREAL (ZZ2) .LT. 15.) THEN
          SUB = SUB + LOG ((ZZ1+ZZ2) / ZZ2)
          ZZ2 = ZZ2 + 1.
          GOTO 2
       END IF
       LG1 = LNGAM (ZZ1)
       LG2 = LNGAM (ZZ2)
       LG12 = LNGAM (ZZ1 + ZZ2)
       CBETA = EXP (LG1 + LG2 - LG12 + SUB)
       RETURN
       END
*


      function alphasl(nq2,iscale)
c.....reference scale is factorization scale: muf2=muf**2
      implicit real*8(a-h,o-z)
      double complex xlambda,aa1,all,alphasl,qq,t,xlt,bstar,b,blog
      double complex nq2,aexp,aexpB
      integer flagrealcomplex,imod,iord,iscale
      COMMON/order/iord
      COMMON/aass/aass
      COMMON/flagrealcomplex/flagrealcomplex
      COMMON/modified/imod
      COMMON/a_param/a_param,a_paramb,b0p,b0pb
      COMMON/exponent/aexp,aexpB
      real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2,loga
      common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
!      include 'const.h'
         integer nf
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                                           C1ggnex
       common/data/pi,II
!fine sostituz const.h


c.....Here computes NLL expression for alphas
c     here nq2=b0^2/b^2 and the result is now  alpha(nq2)/alpha(Qres)  

c     HERE CHANGE: order of alphas related to order of evolution
      if(iord.eq.1) then
      xlp=1
      elseif(iord.eq.0) then
      xlp=0
      endif

      b=(b0p**2/nq2)**(0.5)
      blim=b0p*(1/q)*exp(1/(2*aass*beta0)) ! avoid Landau pole 
      bstar=b
      if(iscale.eq.0)then
       loga=log(a_param)
      else
       loga=log(a_paramb)
      endif

c.....choose bstar (b) for real axis (complex plane) integration
      if (flagrealcomplex.eq.0) bstar=b/sqrt(1+(b**2)/(blim**2))

      if (imod.eq.1) blog=log( (q*bstar/b0p)**2 + 1) !modified sudakov
      if (imod.eq.0) blog= log( (q*bstar/b0p)**2 )    !normal sudakov

      xlambda=beta0*aass*blog

c     HERE now a dependence (without constant term)!
      aa1=log(1-xlambda)+aass*xlp*
     .      (beta1/beta0*log(1-xlambda)/(1-xlambda) 
     .       + beta0*xlambda/(1-xlambda)*log(q2/mur2)
     .       -2*beta0*xlambda*loga/(1-xlambda)   )
      alphasl=Exp(-aa1)
      
c.....Now compute the factors
c.....needed to resum the logs which multiply the N-dependent part
c.....of the C coefficients
c  the limit below implies xlambda<1/2 and then aa2<= 1      
c      blim=b0p*(1/q)*exp(1/(2*aass*beta0)) 
c      blim=b0p*(1/q)*exp(1/(4*aass*beta0))
C Set a limit to avoid very large values of b (= very small scales ~1/b)
!       blim=0.5d0

      if (flagrealcomplex.eq.0) bstar=b/sqrt(1+(b**2)/(blim**2))
      if (imod.eq.1) blog=log( (q*bstar/b0p)**2 + 1) !modified sudakov
      if (imod.eq.0) blog= log( (q*bstar/b0p)**2 )    !normal sudakov

      xlambda=beta0*aass*blog

c     HERE now a dependence (without constant term)!
      aa1=log(1-xlambda)+aass*xlp*
     .      (beta1/beta0*log(1-xlambda)/(1-xlambda) 
     .       + beta0*xlambda/(1-xlambda)*log(q2/mur2) 
     .       -2d0*beta0*xlambda*loga/(1-xlambda)   )
      aexp=Exp(-aa1)      


c.....This function computes the factor Exp(lambda/(1-lambda))
c.....needed to resum the logs which multiply the N-dependent part
c.....of the C coefficients

      aa2= xlambda/(1- xlambda)
      aexpB=Exp(aa2)     
      
      return
      end
      

!      function alphaslBold(nq2)
c.....reference scale is factorization scale: muf2=muf**2
!      implicit real*8(a-h,o-z)
!      double complex xlambda,aa1,all,alphasl,qq,t,xlt,bstar,b,blog
!      double complex nq2,alphaslB
!      integer flagrealcomplex,imod,iord
!      COMMON/order/iord
!      COMMON/aass/aass
!      COMMON/flagrealcomplex/flagrealcomplex
!      COMMON/modified/imod
!      COMMON/a_param/a_param,b0p
!         integer nf
!       real* 8 Euler,Z2,Z3
!       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
!     #               A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn
!       real *8 pi
!       complex *16 II
!       common/nf/nf
!       common/Euler/Euler
!       common/Zeta/Z2,Z3
!       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
!     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn
!       common/data/pi,II

!      real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
!      common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2

c.....This function computes the factor Exp(lambda/(1-lambda))
c.....needed to resum the logs which multiply the N-dependent part
c.....of the C coefficients

!      b=(b0p**2/nq2)**(0.5)
!      blim=(1/q)*exp(1/(2*aass*beta0))
!      bstar=b

c.....choose bstar (b) for real axis (complex plane) integration
!      if (flagrealcomplex.eq.0) bstar=b/sqrt(1+(b**2)/(blim**2))

!      if (imod.eq.1) blog=log( (q*bstar/b0p)**2 + 1) !modified sudakov
!      if (imod.eq.0) blog= log( (q*bstar/b0p)**2 )    !normal sudakov

!      xlambda=beta0*aass*blog

c     HERE now a dependence (without constant term)!
!      aa1= xlambda/(1- xlambda)
!      alphaslBold=Exp(-aa1)
c
!      return
!      end





C     Computes the moments of pdfs for beam 1
      SUBROUTINE F0MOMENTS1(N,UV,DV,US,DS,SS,GL,CH,BO)
      implicit DOUBLE COMPLEX (A-Z)
      integer flagi,IK,NFITMAX
      double precision A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      double precision A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      double precision A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US 
      double precision A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      double precision A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      double precision A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      double precision A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      double precision A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      dimension UV(30),DV(30),US(30),DS(30),SS(30),GL(30),CH(30),BO(30)
c
       dimension A1UV(30),A2UV(30),A3UV(30),A4UV(30),
     .       A5UV(30),A6UV(30),A7UV(30),A8UV(30)
       dimension A1DV(30),A2DV(30),A3DV(30),A4DV(30),
     .       A5DV(30),A6DV(30),A7DV(30),A8DV(30)
       dimension A1US(30),A2US(30),A3US(30),A4US(30),
     .       A5US(30),A6US(30),A7US(30),A8US(30)
       dimension A1DS(30),A2DS(30),A3DS(30),A4DS(30),
     .       A5DS(30),A6DS(30),A7DS(30),A8DS(30)
       dimension A1SS(30),A2SS(30),A3SS(30),A4SS(30),
     .       A5SS(30),A6SS(30),A7SS(30),A8SS(30)
       dimension A1GL(30),A2GL(30),A3GL(30),A4GL(30),
     .       A5GL(30),A6GL(30),A7GL(30),A8GL(30)
       dimension A1CH(30),A2CH(30),A3CH(30),A4CH(30),
     .       A5CH(30),A6CH(30),A7CH(30),A8CH(30)
       dimension A1BO(30),A2BO(30),A3BO(30),A4BO(30),
     .       A5BO(30),A6BO(30),A7BO(30),A8BO(30)
c
      double precision GE,ZETA2,ZETA3,PI,aa 
      COMMON/ CUV1/ A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      COMMON/ CDV1/ A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      COMMON/ CUS1/ A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      COMMON/ CDS1/ A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      COMMON/ CSS1/ A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      COMMON/ CGL1/ A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      COMMON/ CCH1/ A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      COMMON/ CBO1/ A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      COMMON/expp/aa
      COMMON/NFITMAX/NFITMAX
 
      data GE/ 0.577216d0 /
      data ZETA2/1.64493d0 / 
      data ZETA3/1.20206d0 /
      data PI/3.1415926536d0 /
      AAA=CMPLX(aa,0.d0)

      DO IK=1,NFITMAX
C     U-VALENCE
      CA1=CMPLX(A1UV(ik),0.d0)
      CA2=CMPLX(A2UV(ik),0.d0)
      CA3=CMPLX(A3UV(ik),0.d0)
      CA4=CMPLX(A4UV(ik),0.d0)
      CA5=CMPLX(A5UV(ik),0.d0)
      CA6=CMPLX(A6UV(ik),0.d0)
      CA7=CMPLX(A7UV(ik),0.d0)
      CA8=CMPLX(A8UV(ik),0.d0)
      UV(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     D-VALENCE
      CA1=CMPLX(A1DV(ik),0.d0)
      CA2=CMPLX(A2DV(ik),0.d0)
      CA3=CMPLX(A3DV(ik),0.d0)
      CA4=CMPLX(A4DV(ik),0.d0)
      CA5=CMPLX(A5DV(ik),0.d0)
      CA6=CMPLX(A6DV(ik),0.d0)
      CA7=CMPLX(A7DV(ik),0.d0)
      CA8=CMPLX(A8DV(ik),0.d0)
      DV(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     U-BAR
      CA1=CMPLX(A1US(ik),0.d0)
      CA2=CMPLX(A2US(ik),0.d0)
      CA3=CMPLX(A3US(ik),0.d0)
      CA4=CMPLX(A4US(ik),0.d0)
      CA5=CMPLX(A5US(ik),0.d0)
      CA6=CMPLX(A6US(ik),0.d0)
      CA7=CMPLX(A7US(ik),0.d0)
      CA8=CMPLX(A8US(ik),0.d0)
      US(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     D-BAR
      CA1=CMPLX(A1DS(ik),0.d0)
      CA2=CMPLX(A2DS(ik),0.d0)
      CA3=CMPLX(A3DS(ik),0.d0)
      CA4=CMPLX(A4DS(ik),0.d0)
      CA5=CMPLX(A5DS(ik),0.d0)
      CA6=CMPLX(A6DS(ik),0.d0)
      CA7=CMPLX(A7DS(ik),0.d0)
      CA8=CMPLX(A8DS(ik),0.d0)
      DS(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     S-BAR
      CA1=CMPLX(A1SS(ik),0.d0)
      CA2=CMPLX(A2SS(ik),0.d0)
      CA3=CMPLX(A3SS(ik),0.d0)
      CA4=CMPLX(A4SS(ik),0.d0)
      CA5=CMPLX(A5SS(ik),0.d0)
      CA6=CMPLX(A6SS(ik),0.d0)
      CA7=CMPLX(A7SS(ik),0.d0)
      CA8=CMPLX(A8SS(ik),0.d0)
      SS(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     GLUON
      CA1=CMPLX(A1GL(ik),0.d0)
      CA2=CMPLX(A2GL(ik),0.d0)
      CA3=CMPLX(A3GL(ik),0.d0)
      CA4=CMPLX(A4GL(ik),0.d0)
      CA5=CMPLX(A5GL(ik),0.d0)
      CA6=CMPLX(A6GL(ik),0.d0)
      CA7=CMPLX(A7GL(ik),0.d0)
      CA8=CMPLX(A8GL(ik),0.d0)
      GL(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     CHARM
      CA1=CMPLX(A1CH(ik),0.d0)
      CA2=CMPLX(A2CH(ik),0.d0)
      CA3=CMPLX(A3CH(ik),0.d0)
      CA4=CMPLX(A4CH(ik),0.d0)
      CA5=CMPLX(A5CH(ik),0.d0)
      CA6=CMPLX(A6CH(ik),0.d0)
      CA7=CMPLX(A7CH(ik),0.d0)
      CA8=CMPLX(A8CH(ik),0.d0)
      CH(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     BOTTOM
      CA1=CMPLX(A1BO(ik),0.d0)
      CA2=CMPLX(A2BO(ik),0.d0)
      CA3=CMPLX(A3BO(ik),0.d0)
      CA4=CMPLX(A4BO(ik),0.d0)
      CA5=CMPLX(A5BO(ik),0.d0)
      CA6=CMPLX(A6BO(ik),0.d0)
      CA7=CMPLX(A7BO(ik),0.d0)
      CA8=CMPLX(A8BO(ik),0.d0)
      BO(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
      ENDDO
      RETURN
      END      
      
      
      
C     Computes the moments of pdfs for beam 2
      SUBROUTINE F0MOMENTS2(N,UV,DV,US,DS,SS,GL,CH,BO)
      implicit DOUBLE COMPLEX (A-Z)
      integer flagi,IK,NFITMAX
      double precision A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      double precision A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      double precision A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US 
      double precision A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      double precision A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      double precision A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      double precision A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      double precision A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      dimension UV(30),DV(30),US(30),DS(30),SS(30),GL(30),CH(30),BO(30)
c
       dimension A1UV(30),A2UV(30),A3UV(30),A4UV(30),
     .       A5UV(30),A6UV(30),A7UV(30),A8UV(30)
       dimension A1DV(30),A2DV(30),A3DV(30),A4DV(30),
     .       A5DV(30),A6DV(30),A7DV(30),A8DV(30)
       dimension A1US(30),A2US(30),A3US(30),A4US(30),
     .       A5US(30),A6US(30),A7US(30),A8US(30)
       dimension A1DS(30),A2DS(30),A3DS(30),A4DS(30),
     .       A5DS(30),A6DS(30),A7DS(30),A8DS(30)
       dimension A1SS(30),A2SS(30),A3SS(30),A4SS(30),
     .       A5SS(30),A6SS(30),A7SS(30),A8SS(30)
       dimension A1GL(30),A2GL(30),A3GL(30),A4GL(30),
     .       A5GL(30),A6GL(30),A7GL(30),A8GL(30)
       dimension A1CH(30),A2CH(30),A3CH(30),A4CH(30),
     .       A5CH(30),A6CH(30),A7CH(30),A8CH(30)
       dimension A1BO(30),A2BO(30),A3BO(30),A4BO(30),
     .       A5BO(30),A6BO(30),A7BO(30),A8BO(30)
c
      double precision GE,ZETA2,ZETA3,PI,aa 
      COMMON/ CUV2/ A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      COMMON/ CDV2/ A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      COMMON/ CUS2/ A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      COMMON/ CDS2/ A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      COMMON/ CSS2/ A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      COMMON/ CGL2/ A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      COMMON/ CCH2/ A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      COMMON/ CBO2/ A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      COMMON/expp/aa
      COMMON/NFITMAX/NFITMAX
 
      data GE/ 0.577216d0 /
      data ZETA2/1.64493d0 / 
      data ZETA3/1.20206d0 /
      data PI/3.1415926536d0 /
      AAA=CMPLX(aa,0.d0)

      DO IK=1,NFITMAX
C     U-VALENCE
      CA1=CMPLX(A1UV(ik),0.d0)
      CA2=CMPLX(A2UV(ik),0.d0)
      CA3=CMPLX(A3UV(ik),0.d0)
      CA4=CMPLX(A4UV(ik),0.d0)
      CA5=CMPLX(A5UV(ik),0.d0)
      CA6=CMPLX(A6UV(ik),0.d0)
      CA7=CMPLX(A7UV(ik),0.d0)
      CA8=CMPLX(A8UV(ik),0.d0)
      UV(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     D-VALENCE
      CA1=CMPLX(A1DV(ik),0.d0)
      CA2=CMPLX(A2DV(ik),0.d0)
      CA3=CMPLX(A3DV(ik),0.d0)
      CA4=CMPLX(A4DV(ik),0.d0)
      CA5=CMPLX(A5DV(ik),0.d0)
      CA6=CMPLX(A6DV(ik),0.d0)
      CA7=CMPLX(A7DV(ik),0.d0)
      CA8=CMPLX(A8DV(ik),0.d0)
      DV(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     U-BAR
      CA1=CMPLX(A1US(ik),0.d0)
      CA2=CMPLX(A2US(ik),0.d0)
      CA3=CMPLX(A3US(ik),0.d0)
      CA4=CMPLX(A4US(ik),0.d0)
      CA5=CMPLX(A5US(ik),0.d0)
      CA6=CMPLX(A6US(ik),0.d0)
      CA7=CMPLX(A7US(ik),0.d0)
      CA8=CMPLX(A8US(ik),0.d0)
      US(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     D-BAR
      CA1=CMPLX(A1DS(ik),0.d0)
      CA2=CMPLX(A2DS(ik),0.d0)
      CA3=CMPLX(A3DS(ik),0.d0)
      CA4=CMPLX(A4DS(ik),0.d0)
      CA5=CMPLX(A5DS(ik),0.d0)
      CA6=CMPLX(A6DS(ik),0.d0)
      CA7=CMPLX(A7DS(ik),0.d0)
      CA8=CMPLX(A8DS(ik),0.d0)
      DS(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     S-BAR
      CA1=CMPLX(A1SS(ik),0.d0)
      CA2=CMPLX(A2SS(ik),0.d0)
      CA3=CMPLX(A3SS(ik),0.d0)
      CA4=CMPLX(A4SS(ik),0.d0)
      CA5=CMPLX(A5SS(ik),0.d0)
      CA6=CMPLX(A6SS(ik),0.d0)
      CA7=CMPLX(A7SS(ik),0.d0)
      CA8=CMPLX(A8SS(ik),0.d0)
      SS(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     GLUON
      CA1=CMPLX(A1GL(ik),0.d0)
      CA2=CMPLX(A2GL(ik),0.d0)
      CA3=CMPLX(A3GL(ik),0.d0)
      CA4=CMPLX(A4GL(ik),0.d0)
      CA5=CMPLX(A5GL(ik),0.d0)
      CA6=CMPLX(A6GL(ik),0.d0)
      CA7=CMPLX(A7GL(ik),0.d0)
      CA8=CMPLX(A8GL(ik),0.d0)
      GL(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     CHARM
      CA1=CMPLX(A1CH(ik),0.d0)
      CA2=CMPLX(A2CH(ik),0.d0)
      CA3=CMPLX(A3CH(ik),0.d0)
      CA4=CMPLX(A4CH(ik),0.d0)
      CA5=CMPLX(A5CH(ik),0.d0)
      CA6=CMPLX(A6CH(ik),0.d0)
      CA7=CMPLX(A7CH(ik),0.d0)
      CA8=CMPLX(A8CH(ik),0.d0)
      CH(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     BOTTOM
      CA1=CMPLX(A1BO(ik),0.d0)
      CA2=CMPLX(A2BO(ik),0.d0)
      CA3=CMPLX(A3BO(ik),0.d0)
      CA4=CMPLX(A4BO(ik),0.d0)
      CA5=CMPLX(A5BO(ik),0.d0)
      CA6=CMPLX(A6BO(ik),0.d0)
      CA7=CMPLX(A7BO(ik),0.d0)
      CA8=CMPLX(A8BO(ik),0.d0)
      BO(ik)=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
      ENDDO
      RETURN
      END      
      

c computes pdfs for beam 1 in the approximated result at muf
      SUBROUTINE DISTRIBUTIONS1(X,U,D,US,DS,SS,GL,CH,BO)
      implicit NONE
      double precision A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      double precision A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      double precision A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US 
      double precision A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      double precision A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      double precision A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      double precision A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      double precision A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
c
       dimension A1UV(30),A2UV(30),A3UV(30),A4UV(30),
     .       A5UV(30),A6UV(30),A7UV(30),A8UV(30)
       dimension A1DV(30),A2DV(30),A3DV(30),A4DV(30),
     .       A5DV(30),A6DV(30),A7DV(30),A8DV(30)
       dimension A1US(30),A2US(30),A3US(30),A4US(30),
     .       A5US(30),A6US(30),A7US(30),A8US(30)
       dimension A1DS(30),A2DS(30),A3DS(30),A4DS(30),
     .       A5DS(30),A6DS(30),A7DS(30),A8DS(30)
       dimension A1SS(30),A2SS(30),A3SS(30),A4SS(30),
     .       A5SS(30),A6SS(30),A7SS(30),A8SS(30)
       dimension A1GL(30),A2GL(30),A3GL(30),A4GL(30),
     .       A5GL(30),A6GL(30),A7GL(30),A8GL(30)
       dimension A1CH(30),A2CH(30),A3CH(30),A4CH(30),
     .       A5CH(30),A6CH(30),A7CH(30),A8CH(30)
       dimension A1BO(30),A2BO(30),A3BO(30),A4BO(30),
     .       A5BO(30),A6BO(30),A7BO(30),A8BO(30)
c     
      double precision aa,UV,DV,US,DS,SS,GL,CH,BO,U,D,X 
      double precision UTEMP,DTEMP
      INTEGER I,ih1,ih2
      COMMON/ CUV1/ A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      COMMON/ CDV1/ A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      COMMON/ CUS1/ A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      COMMON/ CDS1/ A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      COMMON/ CSS1/ A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      COMMON/ CGL1/ A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      COMMON/ CCH1/ A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      COMMON/ CBO1/ A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      COMMON/expp/aa
      COMMON/ IFIT/ I
      COMMON/collider/ih1,ih2

       
      UV=A1UV(I)*x**A2UV(I)*(1-x)**A3UV(I)*(1+A4UV(I)*x+A5UV(I)*x**(0.5)
     .     +A6UV(I)*x**(1.5)+A7UV(I)*X**2 + A8UV(I)*X**(aa))
      DV=A1DV(I)*x**A2DV(I)*(1-x)**A3DV(I)*(1+A4DV(I)*x+A5DV(I)*x**(0.5)
     .     +A6DV(I)*x**(1.5)+A7DV(I)*X**2 + A8DV(I)*X**(aa))

      US=A1US(I)*x**A2US(I)*(1-x)**A3US(I)*(1+A4US(I)*x+A5US(I)*x**(0.5)
     .     +A6US(I)*x**(1.5)+A7US(I)*X**2 + A8US(I)*X**(aa))
      DS=A1DS(I)*x**A2DS(I)*(1-x)**A3DS(I)*(1+A4DS(I)*x+A5DS(I)*x**(0.5)
     .     +A6DS(I)*x**(1.5)+A7DS(I)*X**2 + A8DS(I)*X**(aa))

       U=UV+US
       D=DV+DS

      SS=A1SS(I)*x**A2SS(I)*(1-x)**A3SS(I)*(1+A4SS(I)*x+A5SS(I)*x**(0.5)
     .     +A6SS(I)*x**(1.5)+A7SS(I)*X**2 + A8SS(I)*X**(aa))

      GL=A1GL(I)*x**A2GL(I)*(1-x)**A3GL(I)*(1+A4GL(I)*x+A5GL(I)*x**(0.5)
     .     +A6GL(I)*x**(1.5)+A7GL(I)*X**2 + A8GL(I)*X**(aa))

      CH=A1CH(I)*x**A2CH(I)*(1-x)**A3CH(I)*(1+A4CH(I)*x+A5CH(I)*x**(0.5)
     .     +A6CH(I)*x**(1.5)+A7CH(I)*X**2 + A8CH(I)*X**(aa))

      BO=A1BO(I)*x**A2BO(I)*(1-x)**A3BO(I)*(1+A4BO(I)*x+A5BO(I)*x**(0.5)
     .     +A6BO(I)*x**(1.5)+A7BO(I)*X**2 + A8BO(I)*X**(aa))


       if (ih1.eq.-1) then
c pbar  u<->ubar  d<->dbar       
       UTEMP=U
       U=US
       US=UTEMP

       DTEMP=D
       D=DS
       DS=DTEMP
         
       endif

       RETURN
       END


c computes pdfs for beam 2 in the approximated result at muf
      SUBROUTINE DISTRIBUTIONS2(X,U,D,US,DS,SS,GL,CH,BO)
      implicit NONE
      double precision A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      double precision A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      double precision A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US 
      double precision A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      double precision A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      double precision A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      double precision A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      double precision A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
c
       dimension A1UV(30),A2UV(30),A3UV(30),A4UV(30),
     .       A5UV(30),A6UV(30),A7UV(30),A8UV(30)
       dimension A1DV(30),A2DV(30),A3DV(30),A4DV(30),
     .       A5DV(30),A6DV(30),A7DV(30),A8DV(30)
       dimension A1US(30),A2US(30),A3US(30),A4US(30),
     .       A5US(30),A6US(30),A7US(30),A8US(30)
       dimension A1DS(30),A2DS(30),A3DS(30),A4DS(30),
     .       A5DS(30),A6DS(30),A7DS(30),A8DS(30)
       dimension A1SS(30),A2SS(30),A3SS(30),A4SS(30),
     .       A5SS(30),A6SS(30),A7SS(30),A8SS(30)
       dimension A1GL(30),A2GL(30),A3GL(30),A4GL(30),
     .       A5GL(30),A6GL(30),A7GL(30),A8GL(30)
       dimension A1CH(30),A2CH(30),A3CH(30),A4CH(30),
     .       A5CH(30),A6CH(30),A7CH(30),A8CH(30)
       dimension A1BO(30),A2BO(30),A3BO(30),A4BO(30),
     .       A5BO(30),A6BO(30),A7BO(30),A8BO(30)
c     
      double precision aa,UV,DV,US,DS,SS,GL,CH,BO,U,D,X 
      double precision UTEMP,DTEMP
      INTEGER I,ih1,ih2
      COMMON/ CUV2/ A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      COMMON/ CDV2/ A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      COMMON/ CUS2/ A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      COMMON/ CDS2/ A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      COMMON/ CSS2/ A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      COMMON/ CGL2/ A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      COMMON/ CCH2/ A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      COMMON/ CBO2/ A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      COMMON/expp/aa
      COMMON/ IFIT/ I
      COMMON/collider/ih1,ih2
       
      
      UV=A1UV(I)*x**A2UV(I)*(1-x)**A3UV(I)*(1+A4UV(I)*x+A5UV(I)*x**(0.5)
     .     +A6UV(I)*x**(1.5)+A7UV(I)*X**2 + A8UV(I)*X**(aa))
      DV=A1DV(I)*x**A2DV(I)*(1-x)**A3DV(I)*(1+A4DV(I)*x+A5DV(I)*x**(0.5)
     .     +A6DV(I)*x**(1.5)+A7DV(I)*X**2 + A8DV(I)*X**(aa))

      US=A1US(I)*x**A2US(I)*(1-x)**A3US(I)*(1+A4US(I)*x+A5US(I)*x**(0.5)
     .     +A6US(I)*x**(1.5)+A7US(I)*X**2 + A8US(I)*X**(aa))
      DS=A1DS(I)*x**A2DS(I)*(1-x)**A3DS(I)*(1+A4DS(I)*x+A5DS(I)*x**(0.5)
     .     +A6DS(I)*x**(1.5)+A7DS(I)*X**2 + A8DS(I)*X**(aa))

       U=UV+US
       D=DV+DS

      SS=A1SS(I)*x**A2SS(I)*(1-x)**A3SS(I)*(1+A4SS(I)*x+A5SS(I)*x**(0.5)
     .     +A6SS(I)*x**(1.5)+A7SS(I)*X**2 + A8SS(I)*X**(aa))

      GL=A1GL(I)*x**A2GL(I)*(1-x)**A3GL(I)*(1+A4GL(I)*x+A5GL(I)*x**(0.5)
     .     +A6GL(I)*x**(1.5)+A7GL(I)*X**2 + A8GL(I)*X**(aa))

      CH=A1CH(I)*x**A2CH(I)*(1-x)**A3CH(I)*(1+A4CH(I)*x+A5CH(I)*x**(0.5)
     .     +A6CH(I)*x**(1.5)+A7CH(I)*X**2 + A8CH(I)*X**(aa))

      BO=A1BO(I)*x**A2BO(I)*(1-x)**A3BO(I)*(1+A4BO(I)*x+A5BO(I)*x**(0.5)
     .     +A6BO(I)*x**(1.5)+A7BO(I)*X**2 + A8BO(I)*X**(aa))


       if (ih2.eq.-1) then
c pbar  u<->ubar  d<->dbar       
       UTEMP=U 
       U=US
       US=UTEMP

       DTEMP=D
       D=DS
       DS=DTEMP
         
       endif
       

       RETURN
       END


c.....Sudakov form factor
      function S(b,iscale)
      implicit none
      integer flag1,flagrealcomplex,imod,iscale
      complex *16 S,f0,f1,f2,b,bstar,blim,blog
      real*8 a_param,a_paramb,b0p,b0pb,aass
      COMMON/aass/aass
      COMMON/flag1/flag1
      COMMON/flagrealcomplex/flagrealcomplex
      COMMON/modified/imod
      COMMON/a_param/a_param,a_paramb,b0p,b0pb
!      include 'const.h'
         integer nf
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                                           C1ggnex
       common/data/pi,II
!fine sostituz const.h

      real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      blim=(1/q)*exp(1/(2*aass*beta0))

      bstar=b
c.....choose bstar (b) for real axis (complex plane) integration
      if (flagrealcomplex.eq.0) bstar=b/sqrt(1+(b**2)/(blim**2))

      if (imod.eq.1) blog=log( (q*bstar/b0p)**2+1) !modified sudakov
      if (imod.eq.0) blog= log( (q*bstar/b0p)**2 )    !normal sudakov

      if (flag1.eq.0) then
         S=exp(blog*f0(beta0*aass*blog))
      elseif (flag1.eq.1) then
         S=exp(blog*f0(beta0*aass*blog) +
     /                           f1(beta0*aass*blog,iscale))
      elseif (flag1.eq.2 .and. iscale.eq.0) then
         S=exp(blog*f0(beta0*aass*blog) +
     /                           f1(beta0*aass*blog,iscale) +
     /                        aass*f2(beta0*aass*blog))
      elseif (flag1.eq.2 .and. iscale.ne.0) then
         S=exp(blog*f0(beta0*aass*blog) +
     /                           f1(beta0*aass*blog,iscale))
      endif
      return
      end
      
      
c.....Soft-gluon-Resummation of LL
      function f0(y)
      implicit none
      complex *16 f0,y
!      include 'const.h'
         integer nf
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                                           C1ggnex
       common/data/pi,II
!fine sostituz const.h

      real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      f0=(A1g/beta0)*(y+log(1-y))/(y)
      return
      end
      
c.....Soft-gluon-Resummation of NLL
c.....Now we have mu_r dependence!
      function f1(y,iscale)
      implicit none
      complex *16 f1,y
!      include 'const.h'
         integer nf,iscale
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                                           C1ggnex
       common/data/pi,II
!fine sostituz const.h

      real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      real *8 a_param,a_paramb,b0p,b0pb
      COMMON/a_param/a_param,a_paramb,b0p,b0pb

      f1=((A1g*beta1)/(beta0**3))*((1d0/2)*log(1-y)*log(1-y) +
     \     (y)/(1-y)+log(1-y)/(1-y)) -
     \     (A2g/(beta0**2))*(log(1-y)+(y)/(1-y)) +
     \     (B1g/beta0)*log(1-y) +
     \     (A1g/beta0)*(y/(1-y)+log(1-y))*log(q2/mur2)

c    a dependence
      if(iscale.eq.0)then
       f1=f1-2*log(a_param)*A1g/beta0*y/(1-y)
      else
       f1=f1-2*log(a_paramb)*A1g/beta0*y/(1-y)
      endif

      return
      end

c.....Soft-gluon-Resummation of NNLL
c.....Now we have mu_r dependence!
      function f2(y)
      implicit none
      complex *16 f2,y
!      include 'const.h'
         integer nf
       real* 8 Euler,Z2,Z3
       real *8 beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #         A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,C1ggnex
       real *8 pi
       complex *16 II
       common/nf/nf
       common/Euler/Euler
       common/Zeta/Z2,Z3
       common/const/beta0,beta1,beta2,A1g,A2g,A3g,B1g,B2g,
     #                A1q,A2q,A3q,B1q,B2q,CA,Cf,TR,b0,C1ggn,
     #                                           C1ggnex
       common/data/pi,II
!fine sostituz const.h

      real *8 qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      common/somescale/qt,qt2,xtau,q,q2,shad,sroot,mur,mur2,muf,muf2
      real *8 a_param,a_paramb,b0p,b0pb
      COMMON/a_param/a_param,a_paramb,b0p,b0pb

c      C1=(pi**2/2d0+11/2d0+pi**2)/2d0

      f2=((A2g*beta1)/(beta0**3))*((y/2)*((3*y-2d0)/(1-y)**2)-
     \     ((1-2*y)*log(1-y)/(1-y)/(1-y))) - 
     \     (B2g/beta0)*((y)/(1-y))+
     \     (B1g*beta1/beta0**2)*((y)/(1-y)+log(1-y)/(1-y))-
     \     (A3g/2/beta0**2)*(y)*(y)/(1-y)/(1-y) +
     \     A1g*((beta1**2/2/beta0**4)*(1-2*y)/(1-y)
     \     /(1-y)*log(1-y)*log(1-y) +
     \     log(1-y)*((beta0*beta2-beta1**2)/(beta0**4)+
     \     beta1**2/beta0**4/(1-y)) +
     \     (y)/(2*beta0**4*(1-y)*(1-y))*
     \     (beta0*beta2*(2d0-3*y)+beta1**2*y)) -
     \     (A1g/2)*(y)*(y)/(1-y)/(1-y)*log(q2/mur2)*log(q2/mur2) +
     \     log(q2/mur2)*(B1g*y/(1-y)+A2g/beta0*y*y/(1-y)/(1-y)+
     \     A1g*beta1/beta0**2*(y/(1-y)+(1-2*y)/(1-y)/(1-y)*log(1-y))) 
     \     +2d0*C1ggn*((y)/(1-y))


c    a dependence (now without constant term)

c     f2=f2-2*A1g/(1-y)**2*(log(a_param))**2-log(a_param)/(1-y)**2
c    \    *(2*B1g*(1-y)+2*y/beta0*A2g-2*A1g*beta1/beta0**2*y*log(1-y))


      f2=f2+2*A1g*y*(y-2)/(1-y)**2*log(a_param)**2-log(a_param)
     \ *(2*B1g*y/(1-y)+2*y/beta0*A2g/(1-y)**2
     \ -2*A1g*beta1/beta0**2*y*log(1-y)/(1-y)**2)
     \ +2d0*A1g*y*log(q2/mur2)*log(a_param)/(1-y)**2    !Double log-dependent term


      return
      end
      
    
c**********************************************************

C.....Inclusion of two heavy quarks: amplitude level

      FUNCTION ABI(X)
      IMPLICIT NONE
      REAL*8 X,FR,FI,root,dasin,PI,etap,etam,rlog
      REAL*8 AR,AI
      COMPLEX*16 ABI
      PI=4.D0*DATAN(1.D0)
      IF(X.GE.0.25D0) THEN
                FR=-2.D0*(DASIN(0.5D0/DSQRT(X)))**2
                FI=0.D0
      ELSEIF(X.LT.0.25D0) THEN
                ROOT=DSQRT(0.25D0-X)
                ETAP=0.5D0+ROOT
                ETAM=0.5D0-ROOT
                RLOG=DLOG(ETAP/ETAM)
                FR=0.5D0*(RLOG**2-PI**2)
                FI=PI*RLOG
                ENDIF
      AR=2.D0*X+X*(4.D0*X-1.D0)*FR
      AI=       X*(4.D0*X-1.D0)*FI
      ABI=3D0*(AR+(0,1)*AI)
      RETURN
      END


      FUNCTION ABISQ(x,y)
      implicit none
      integer approxim
      complex *16 abi,t1,t2
      real*8 abisq,x,y
      common/flag/approxim
      external ABI
      t1=abi(x)+(approxim-1)*abi(y)      
      t2=t1*dconjg(t1)
      abisq=dreal(t2)
      return
      end



! Xsection whitout sigma0
      function xsection(ax,eta,xmuf,isetproton,ippbar1,ippbar2)
      IMPLICIT NONE
      DOUBLE PRECISION ax,ax1,ax2,eta,xmuf, FX1(-5:5)
     .  ,FX2(-5:5),x1,x2,xsection
      integer isetproton,ippbar1,ippbar2,nf
      COMMON/NFLAVORS/nF
       AX1 = (AX+2*ETA)/2d0 
       AX2 = (AX-2*ETA)/2d0 
       x1=dExp(ax1)
       x2=dExp(ax2)
!       xmuf=dsqrt(xmuf2)
!       call partons(xmuf2,x1,fx1,5,isetproton,ippbar1)
!       call partons(xmuf2,x2,fx2,5,isetproton,ippbar2)
       call fdist(ippbar1,x1,xmuf,fx1)
       call fdist(ippbar2,x2,xmuf,fx2)
!       write(*,*)'+',x1,x2,fx1(0),fx2(0)
!       write(*,*)fx1,fx2
       xsection = FX1(0)*FX2(0)

       return
       end

! Xsection2 whitout sigma0
      function xsection2(ax,eta,xmuf,isetproton,ippbar1,ippbar2)
      IMPLICIT NONE
      DOUBLE PRECISION ax,ax1,ax2,eta,xmuf, FX1(-5:5),FX2(-5:5)
     .  ,x1,x2,xsection2
      integer isetproton,ippbar1,ippbar2,nf
      COMMON/NFLAVORS/nF
        AX1 = (AX+2*ETA)/2d0 
        AX2 = (AX-2*ETA)/2d0 
        x1=dExp(ax1)
        x2=dExp(ax2)
      call DISTRIBUTIONS1(X1,FX1(1),FX1(2),FX1(-1),FX1(-2),
     .     FX1(3),FX1(0),FX1(4),FX1(5))
      call DISTRIBUTIONS2(X2,FX2(1),FX2(2),FX2(-1),FX2(-2),
     .     FX2(3),FX2(0),FX2(4),FX2(5))
!       write(*,*)x1,x2,fx1(0)/x1,fx2(0)/x2
!       write(*,*)'-',fx1/x1,fx2/x2
!       write(*,*)

       xsection2= FX1(0)*FX2(0)/x1/x2

       return
       end
      

