      logical function cuts(pjet,njets)
      implicit none
      include 'constants.f'
      include 'masses.f'
      integer i,j,k,njets
      double precision pjet(mxpart,4),etvec(4)
      double precision pt,etarap
CC
      double precision pt3,pt4,eta3,eta4,pt34,y34,yraptwo
      double precision pt5,eta5,eta6,ptmiss,ptjetmax,m45
      double precision cosphi45,deltaphi
      double precision ppt(1:4),pto(1:4),mz(1:4),dmz(1:4),tmp(1:2)
      double precision ETmiss,mz1,mz2
      integer l(4),m(4),i1,i2,i3,i4


      integer higgsdec,ndec
      common/higgsdec/higgsdec,ndec


CC    In the following: when cuts=.true. the event is rejected

      cuts=.false.
CC    

      if(higgsdec.eq.1) then

CC    H->2gamma
CC    Photon 4-momenta pjet(3,j) and pjet(4,j)

CC    Insert here cuts

      pt3=dsqrt(pjet(3,1)**2+pjet(3,2)**2)
      pt4=dsqrt(pjet(4,1)**2+pjet(4,2)**2)      
      eta3=dabs(etarap(3,pjet))
      eta4=dabs(etarap(4,pjet))




CC     Acceptance cuts on the photons
CC     if you comment these lines all events are accepted

c       if( (min(pt3,pt4).lt.25d0).or.(max(pt3,pt4).lt.40d0)
c     &   .or.(eta3.gt.2.5d0).or.(eta4.gt.2.5d0) )   then
c       cuts=.true.
c       endif


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      elseif(higgsdec.eq.2) then

CC    H->2W->lnulnu

CC    Selection cuts
CC    Leptons 4-momenta pjet(4,j) and pjet(5,j)
CC    Neutrinos 4-momenta pjet(3,j) and pjet(6,j)

CC    Leptons pt's and eta

      pt4=dsqrt(pjet(4,1)**2+pjet(4,2)**2)
      pt5=dsqrt(pjet(5,1)**2+pjet(5,2)**2)      
      eta4=etarap(4,pjet)
      eta5=etarap(5,pjet)

c       if((dabs(eta4).gt.2.5d0).or.(dabs(eta5).gt.2.5d0))
c     & cuts=.true.      

c      if(min(pt4,pt5).lt.20d0) cuts=.true.



CC    Ptmiss

      ptmiss=dsqrt((pjet(3,1)+pjet(6,1))**2+(pjet(3,2)+pjet(6,2))**2)

c      if(ptmiss.lt.30d0) cuts=.true.


CC    m45

      m45=dsqrt((pjet(4,4)+pjet(5,4))**2
     &    -(pjet(4,1)+pjet(5,1))**2
     &    -(pjet(4,2)+pjet(5,2))**2
     &    -(pjet(4,3)+pjet(5,3))**2)


c      if(m45.lt.12d0) cuts=.true. 


CC  Further cuts
C     azimuthal angle of (4,5)

c      cosphi45=(pjet(4,1)* pjet(5,1)+ 
c     &    pjet(4,2)* pjet(5,2))/(pt(4,pjet)*pt(5,pjet))

C     deltaphi

c      deltaphi=dabs(dacos(cosphi45))


C Convert to degrees

c      deltaphi=deltaphi*180/3.141592653589793d0

c      if(deltaphi.gt.135d0) cuts=.true.  


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


CC    H->2Z->4l

      elseif(higgsdec/10.eq.3) then


C     Standard rapidity cut

      eta3=dabs(etarap(3,pjet))
      eta4=dabs(etarap(4,pjet))
      eta5=dabs(etarap(5,pjet))
      eta6=dabs(etarap(6,pjet))

c      if(max(eta3,eta4,eta5,eta6).gt.2.5d0) cuts=.true.

      do i=1,4
       ppt(i)=dsqrt(pjet(2+i,1)**2+pjet(2+i,2)**2)
c       if(ppt(i).lt.5d0) cuts=.true.
      enddo

c      if(min(ppt(1),ppt(2),ppt(3),ppt(4)).lt.5d0) cuts=.true.


CC    Order lepton pt's

c      pto(1)=max(ppt(1),ppt(2),ppt(3),ppt(4))
c      pto(4)=min(ppt(1),ppt(2),ppt(3),ppt(4))

c      j=0

c      do i=1,4
c       if((ppt(i).ne.pto(1)).and.(ppt(i).ne.pto(4))) then
c       j=j+1
c       tmp(j)=ppt(i)
c       endif
c      enddo

c      pto(2)=max(tmp(1),tmp(2))
c      pto(3)=min(tmp(1),tmp(2))


c      if((pto(1).lt.30d0).or.(pto(2).lt.25d0).or.(pto(3).lt.15d0)
c     & .or.(pto(4).lt.7d0)) cuts=.true.



C Cuts on ll invariant masses

C Only in the case H->2Z->2e2mu
      
      if(higgsdec.eq.31) then

       mz(1)=dsqrt((pjet(3,4)+pjet(4,4))**2
     &     -(pjet(3,1)+pjet(4,1))**2
     &     -(pjet(3,2)+pjet(4,2))**2
     &     -(pjet(3,3)+pjet(4,3))**2)
       mz(2)=dsqrt((pjet(5,4)+pjet(6,4))**2
     &     -(pjet(5,1)+pjet(6,1))**2
     &     -(pjet(5,2)+pjet(6,2))**2
     &     -(pjet(5,3)+pjet(6,3))**2)

       dmz(1)=dabs(mz(1)-zmass)
       dmz(2)=dabs(mz(2)-zmass)

       if(dmz(1).lt.dmz(2)) then
        mz1=mz(1)
        mz2=mz(2)
       else
        mz1=mz(2)
        mz2=mz(1)
       endif

c       if(mz1.lt.50d0) cuts=.true.
c       if(mz2.lt.12d0) cuts=.true.

       endif

C Only in the case H->2Z->4e
      
      if(higgsdec.eq.32) then

      l(1)=3
      m(1)=4

      l(2)=5
      m(2)=6

      l(3)=3
      m(3)=6

      l(4)=4
      m(4)=5

      do i=1,4

      mz(i)=dsqrt((pjet(l(i),4)+pjet(m(i),4))**2
     &     -(pjet(l(i),1)+pjet(m(i),1))**2
     &     -(pjet(l(i),2)+pjet(m(i),2))**2
     &     -(pjet(l(i),3)+pjet(m(i),3))**2)


      dmz(i)=dabs(mz(i)-zmass)

      enddo



C     Find the closest and next-to closest to mz and put cuts


      do i=1,4       
       if(dmz(i).eq.min(dmz(1),dmz(2),dmz(3),dmz(4))) then
        i1=i
       elseif(dmz(i).eq.max(dmz(1),dmz(2),dmz(3),dmz(4))) then
        i4=i
       else 
        i2=i
       endif
      enddo

     
      i3=10-i1-i2-i4

      if(dmz(i2).gt.dmz(i3))then
       i2=i3 
       i3=10-i1-i2-i4
      endif


c      if(mz(i1).lt.50d0) cuts=.true.      
c      if(mz(i2).lt.12d0) cuts=.true.


      endif


      endif


      return     
      end
 
 
 
 
