      subroutine bookplot(n,tag,titlex,var,wt,xmin,xmax,dx,llplot) 
      implicit none
      include 'nplot.f'
      integer n,higgsdec
      character*(*) titlex
      character*3 llplot
      character*4 tag,mypart
      double precision var,wt
      real*8 xmin,xmax,dx
      common/mypart/mypart

      if (tag.eq.'book') then
          call mbook(n,titlex,dx,xmin,xmax)
          call mbook(20+n,titlex,dx,xmin,xmax)
          call mbook(40+n,titlex,dx,xmin,xmax)
          call mbook(60+n,titlex,dx,xmin,xmax)
          call mbook(80+n,titlex,dx,xmin,xmax)
          call mbook(100+n,titlex,dx,xmin,xmax)
          call mbook(120+n,titlex,dx,xmin,xmax)
      elseif (tag .eq. 'plot') then
          call mfill(n,var,wt)
        linlog(n)=llplot
        titlearray(n)=titlex
      endif

      return
      end

    
      subroutine plotter(p,wt,switch)
      implicit none
      include 'clustering.f'
      include 'constants.f'
      include 'cutoff.f'
      include 'npart.f'
      include 'mxdim.f'
      include 'process.f'
      include 'removebr.f'
      include 'masses.f'

C Variables and commons for the Root interface ********
      character*30 namefull
      logical fulloutput
      common/fulloutput/fulloutput,namefull

      integer realvirtpart
      common/realvirtpart/realvirtpart

      character*4 part
      common/part/part

      integer itmx1,ncall1,itmx2,ncall2
      common/iterat/itmx1,ncall1,itmx2,ncall2

      integer it 
      common/fullwrite/it

C *****************************************************


      character*2 plabel(mxpart)
      common/plabel/plabel

      integer n,switch,nplotmax,i,j
      character tag*4
  
      double precision wt
      double precision m34,p(mxpart,4)
      double precision pt3,pt4,pt5,pt6
      double precision eta3,eta4,eta5,eta6
      double precision pt34,pt3456,y34,y3456
      double precision pt,etarap,yraptwo,yrapfour,pttwo,R
      double precision cosphi34,cosphi45,deltaphi,pto(1:4),tmp(1:2)
      double precision phiggs(4),presthiggs(4),p3in(4),p3out(4)
     .  ,ptmax,ptmin,costhetastar3

      double precision thrustax(2),tempvect(2),ptgg(2),pTt,norm

      logical first
      character*30 runstring
      common/runstring/runstring
      common/nplotmax/nplotmax
      double precision realeventp(mxpart,4)
      common/realeventp/realeventp
      integer order,higgsdec,ndec
      common/higgsdec/higgsdec,ndec
      common/nnlo/order

      data first/.true./
      save first




       if (first) then
        tag='book'
c--- ensure we initialize all possible histograms

        eta3=0d0
        pt3=0d0
        eta4=0d0
        pt4=0d0
        eta5=0d0
        pt5=0d0
        eta6=0d0
        pt6=0d0

        y34=0d0
        pt34=0d0
        m34=0d0
        
        y3456=0d0
        pt3456=0d0


        deltaphi=0d0
        ptmin=0d0
        ptmax=0d0
        pto(1)=0d0
        pto(2)=0d0
        pto(3)=0d0
        pto(4)=0d0
        tmp(1)=0d0
        tmp(2)=0d0
        deltaphi=0d0
        cosphi34=0d0

        wt=0d0

        goto 99
      else
        tag='plot'
      endif



      eta3=etarap(3,p)
      pt3=pt(3,p)
      eta4=etarap(4,p)
      pt4=pt(4,p)        
      y34=yraptwo(3,4,p)
      pt34=pttwo(3,4,p)


 99   continue

      n=1                  
      call bookplot(n,tag,'eta4',eta4,wt,0d0,5d0,0.05d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt4',pt4,wt,0d0,200.0d0,2d0,'lin')
      n=n+1
      call bookplot(n,tag,'y34',y34,wt,0d0,5d0,0.05d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt34',pt34,wt,0d0,500d0,5d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt34l',pt34,wt,0d0,500.0d0,5d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt34ll',pt34,wt,0d0,200d0,5d0,'lin')
      n=n+1
      
   
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Di-photon decay
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      if(higgsdec.eq.1) then
      
       ptmin=min(pt3,pt4)
       ptmax=max(pt3,pt4)

     
       do i=1,4
        p3in(i)=p(3,i)
        phiggs(i)=p(3,i)+p(4,i)
       enddo

CC    On/off-shell higgs

       presthiggs(4)=dsqrt(phiggs(4)**2-phiggs(1)**2-phiggs(2)**2
     .                         -phiggs(3)**2)

       presthiggs(1)=0d0
       presthiggs(2)=0d0
       presthiggs(3)=0d0

       call boostx(p3in,phiggs,presthiggs,p3out)
       costhetastar3=dabs(p3out(3)/p3out(4))


       cosphi34=(p(3,1)*p(4,1)+p(3,2)*p(4,2))/(pt3*pt4)
       deltaphi=dabs(dacos(cosphi34))
     &        *180/3.141592653589793d0

!  We introduce a new diphoton observable, pTt, which is defined as the component of pT transverse to the diphoton thrust axis

       tempvect(1)=p(3,1)-p(4,1)
       tempvect(2)=p(3,2)-p(4,2)
       norm=dsqrt(tempvect(1)**2+tempvect(2)**2)
       thrustax(1)=tempvect(1)/norm
       thrustax(2)=tempvect(2)/norm 
       ptgg(1)=p(3,1)+p(4,1)
       ptgg(2)=p(3,2)+p(4,2)
       pTt=dabs(ptgg(1)*thrustax(2)-ptgg(2)*thrustax(1))


       call bookplot(n,tag,'dphi',deltaphi,wt,0d0,180.0001d0,10d0,'lin')
       n=n+1
       call bookplot(n,tag,'ptmin',ptmin,wt,20d0,200.0001d0,2d0,'lin')
       n=n+1
       call bookplot(n,tag,'ptmax',ptmax,wt,30d0,200.0001d0,2d0,'lin')
       n=n+1
       call bookplot(n,tag,'costhetastar3',costhetastar3,wt
     .    ,0d0,1.00001d0,1d-1,'lin')
       n=n+1
       call bookplot(n,tag,'pTt',pTt,wt,0d0,200d0,2d0,'lin')
       n=n+1


CC    Here writing the full momenta of final state particles.
CC    PLEASE: NOT try to write p(1,i) or p(2,i) or p(5,i) etc...
CC    NOT ever filled out with right momenta

       if((.not. first) .and. fulloutput .and. (wt .ne. 0d0)) then

        write(55,345)realvirtpart*it,wt,p(3,4),p(3,1),p(3,2),p(3,3)
     .  ,p(4,4),p(4,1),p(4,2),p(4,3)
 345   FORMAT (I3,es15.7, 8es20.12)

       else if(first .and. fulloutput) then

        write(55,'(A)')'( Number of virtual and real plots:'

        if (part .eq. 'tota') then
          write(55,'(2I5)')itmx2,itmx2
         else if (part .eq. 'real') then
          write(55,'(A5,I5)')'    0',itmx2
         else if (part .eq. 'virt') then
          write(55,'(I5,A5)')itmx2,'    0'
         else
          write(*,*)'Error Plotter!'
          stop
        endif

        write(55,456)
 456    FORMAT('( n  wt',13x,'p3_0',16x,'p3_1',16x,'p3_2',16x,'p3_3'
     .  ,16x,'p4_0',16x,'p4_1',16x,'p4_2',16x,'p4_3')

      endif

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Di-boson decays
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      else
      
      eta5=etarap(5,p)
      pt5=pt(5,p)  
      eta6=etarap(6,p)
      pt6=pt(6,p)    

      pt3456=(p(3,1)+p(4,1)+p(5,1)+p(6,1))**2
     &      +(p(3,2)+p(4,2)+p(5,2)+p(6,2))**2

      pt3456=dsqrt(pt3456)
      y3456=yrapfour(3,4,5,6,p)



      call bookplot(n,tag,'pt3456',pt3456,wt,0d0,500d0,10d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt3456l',pt3456,wt,0d0,500d0,25d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt3456ll',pt3456,wt,0d0,100d0,1d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt3456lll',pt3456,wt,0d0,100d0,2d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt3456llll',pt3456,wt,0d0,100d0,5d0,'lin')
      n=n+1
      call bookplot(n,tag,'y3456',y3456,wt,0d0,5d0,0.1d0,'lin')
      n=n+1

!    Here we write the full momenta of final state particles.
!    PLEASE: NOT try to write p(1,i) or p(2,i) or p(7,i) etc...
!    NOT ever filled out with right momenta

       if((.not. first) .and. fulloutput .and. (wt .ne. 0d0)) then

        write(55,567)realvirtpart*it,wt,p(3,4),p(3,1),p(3,2),p(3,3)
     .  ,p(4,4),p(4,1),p(4,2),p(4,3)
     .  ,p(5,4),p(5,1),p(5,2),p(5,3)
     .  ,p(6,4),p(6,1),p(6,2),p(6,3)
 567   FORMAT (I3, es15.7, 16es20.12)

       else if(first .and. fulloutput) then

        write(55,'(A)')'( Number of virtual and real plots:'

        if (part .eq. 'tota') then
          write(55,'(2I5)')itmx2,itmx2
         else if (part .eq. 'real') then
          write(55,'(A5,I5)')'    0',itmx2
         else if (part .eq. 'virt') then
          write(55,'(I5,A5)')itmx2,'    0'
         else
          write(*,*)'Error Plotter!'
          stop
        endif

        write(55,678)
 678    FORMAT('( n  wt',13x,'p3_0',16x,'p3_1',16x,'p3_2',16x,'p3_3'
     .  ,16x,'p4_0',16x,'p4_1',16x,'p4_2',16x,'p4_3'
     .  ,16x,'p5_0',16x,'p5_1',16x,'p5_2',16x,'p5_3'
     .  ,16x,'p6_0',16x,'p6_1',16x,'p6_2',16x,'p6_3')

      endif



CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     In the H->WW case define deltaphi and order charged leptons
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      if(higgsdec.eq.2) then

       cosphi45=(p(4,1)*p(5,1)+p(4,2)*p(5,2))/(pt4*pt5)
       deltaphi=dabs(dacos(cosphi45))
     &        *180/3.141592653589793d0


       pto(1)=max(pt4,pt5)
       pto(2)=min(pt4,pt5)

       call bookplot(n,tag,'dphi',deltaphi,wt,0d0,180.0001d0,10d0,'lin')
       n=n+1
       call bookplot(n,tag,'pto1',pto(1),wt,0d0,200.0001d0,2d0,'lin')
       n=n+1
       call bookplot(n,tag,'pto2',pto(2),wt,0d0,200.0001d0,2d0,'lin')
       n=n+1


      endif

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     In the H->ZZ->4l case order the lepton pt's
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

       if(higgsdec/10.eq.3) then
        pto(1)=max(pt3,pt4,pt5,pt6)
        pto(4)=min(pt3,pt4,pt5,pt6)


        j=1
        if((pt3.ne.pto(1)).and.(pt3.ne.pto(4))) then
         tmp(j)=pt3
         j=j+1
        endif
        if((pt4.ne.pto(1)).and.(pt4.ne.pto(4))) then
         tmp(j)=pt4    
         j=j+1
        endif
        if((pt5.ne.pto(1)).and.(pt5.ne.pto(4))) then
         tmp(j)=pt5    
         j=j+1
        endif
        if((pt6.ne.pto(1)).and.(pt6.ne.pto(4))) then
         tmp(j)=pt6
         j=j+1
        endif


        pto(2)=max(tmp(1),tmp(2))
        pto(3)=min(tmp(1),tmp(2))


        call bookplot(n,tag,'pto1',pto(1),wt,0d0,500.0001d0,5d0,'lin')
        n=n+1
        call bookplot(n,tag,'pto2',pto(2),wt,0d0,500.0001d0,5d0,'lin')
        n=n+1
        call bookplot(n,tag,'pto3',pto(3),wt,0d0,500.0001d0,5d0,'lin')
        n=n+1
        call bookplot(n,tag,'pto4',pto(4),wt,0d0,500.0001d0,5d0,'lin')
        n=n+1


       endif


  
      endif

   
      n=n-1

      if (n .gt. 20) then
        write(6,*) 'WARNING - TOO MANY HISTOGRAMS!'
        write(6,*) n,' > 20, which is the built-in maximum'
        stop
      endif

c--- set the maximum number of plots, on the first call
      if (first) then
        first=.false.
        nplotmax=n
      endif
      

      return 
      end
      

      
